!===============================================================================
! Copyright (C) 2021 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

! Content:
!    Intel(R) oneAPI Math Kernel Library (Intel(R) oneMKL)
!    FFTW3 Fortran OpenMP Offload Interfaces
!*****************************************************************************

MODULE PREC
  INTEGER, PARAMETER :: FFTW_SPKP = SELECTED_REAL_KIND(6,37)
  INTEGER, PARAMETER :: FFTW_DPKP = SELECTED_REAL_KIND(15,307)
END MODULE PREC

MODULE FFTW3_OMP_OFFLOAD

  INTERFACE
    SUBROUTINE dfftw_plan_dft_1d_omp_offload_lp64(p, n, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_1d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_1d_omp_offload_ilp64(p, n, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_1d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_2d_omp_offload_lp64(p, nx, ny, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_2d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_2d_omp_offload_ilp64(p, nx, ny, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_2d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_3d_omp_offload_lp64(p, nx, ny, nz, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_3d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_3d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_c2r_omp_offload_lp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_c2r_omp_offload_ilp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_c2r_1d_omp_offload_lp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_1d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_c2r_1d_omp_offload_ilp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_1d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_c2r_2d_omp_offload_lp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_2d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_c2r_2d_omp_offload_ilp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_2d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_c2r_3d_omp_offload_lp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_3d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_c2r_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_c2r_3d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_r2c_omp_offload_lp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      REAL (FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_r2c_omp_offload_ilp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      REAL (FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_r2c_1d_omp_offload_lp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_1d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_r2c_1d_omp_offload_ilp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_1d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_r2c_2d_omp_offload_lp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_2d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_r2c_2d_omp_offload_ilp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_2d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_dft_r2c_3d_omp_offload_lp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_3d_omp_offload_lp64

    SUBROUTINE dfftw_plan_dft_r2c_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_dft_r2c_3d_omp_offload_ilp64

    SUBROUTINE dfftw_plan_guru_dft_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, s, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_omp_offload_lp64

    SUBROUTINE dfftw_plan_guru_dft_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, s, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_omp_offload_ilp64
    
    SUBROUTINE dfftw_plan_guru_dft_c2r_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_c2r_omp_offload_lp64

    SUBROUTINE dfftw_plan_guru_dft_c2r_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_c2r_omp_offload_ilp64
    
    SUBROUTINE dfftw_plan_guru_dft_r2c_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_r2c_omp_offload_lp64

    SUBROUTINE dfftw_plan_guru_dft_r2c_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_guru_dft_r2c_omp_offload_ilp64
    
    SUBROUTINE dfftw_plan_many_dft_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_omp_offload_lp64

    SUBROUTINE dfftw_plan_many_dft_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_omp_offload_ilp64

    SUBROUTINE dfftw_plan_many_dft_c2r_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_c2r_omp_offload_lp64

    SUBROUTINE dfftw_plan_many_dft_c2r_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_c2r_omp_offload_ilp64

    SUBROUTINE dfftw_plan_many_dft_r2c_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_r2c_omp_offload_lp64

    SUBROUTINE dfftw_plan_many_dft_r2c_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_plan_many_dft_r2c_omp_offload_ilp64

    SUBROUTINE dfftw_execute_omp_offload(p, interop) BIND(C)
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_execute_omp_offload

    SUBROUTINE dfftw_execute(p)
      INTEGER*8 :: p
      !$omp  declare variant( dfftw_execute:dfftw_execute_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) )
    END SUBROUTINE dfftw_execute

    SUBROUTINE dfftw_execute_dft_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_execute_dft_omp_offload

    SUBROUTINE dfftw_execute_dft_c2r_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_execute_dft_c2r_omp_offload

    SUBROUTINE dfftw_execute_dft_r2c_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE dfftw_execute_dft_r2c_omp_offload

  END INTERFACE

  INTERFACE dfftw_execute_dft
    SUBROUTINE dfftw_execute_dft_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_execute_dft_cpu:dfftw_execute_dft_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_execute_dft_cpu
  END INTERFACE dfftw_execute_dft

  INTERFACE dfftw_execute_dft_c2r
    SUBROUTINE dfftw_execute_dft_c2r_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_execute_dft_c2r_cpu:dfftw_execute_dft_c2r_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_execute_dft_c2r_cpu
  END INTERFACE dfftw_execute_dft_c2r

  INTERFACE dfftw_execute_dft_r2c
    SUBROUTINE dfftw_execute_dft_r2c_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_execute_dft_r2c_cpu:dfftw_execute_dft_r2c_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_execute_dft_r2c_cpu
  END INTERFACE dfftw_execute_dft_r2c

  INTERFACE dfftw_plan_dft_1d
    SUBROUTINE dfftw_plan_dft_1d_cpu_lp64(p, n, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_1d_cpu_lp64:dfftw_plan_dft_1d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_1d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_1d_cpu_ilp64(p, n, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_1d_cpu_ilp64:dfftw_plan_dft_1d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_1d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_1d

  INTERFACE dfftw_plan_dft_2d
    SUBROUTINE dfftw_plan_dft_2d_cpu_lp64(p, nx, ny, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_2d_cpu_lp64:dfftw_plan_dft_2d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_2d_cpu_lp64

      SUBROUTINE dfftw_plan_dft_2d_cpu_ilp64(p, nx, ny, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_2d_cpu_ilp64:dfftw_plan_dft_2d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_2d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_2d

  INTERFACE dfftw_plan_dft_3d
    SUBROUTINE dfftw_plan_dft_3d_cpu_lp64(p, nx, ny, nz, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_3d_cpu_lp64:dfftw_plan_dft_3d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_3d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_3d_cpu_ilp64(p, nx, ny, nz, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_3d_cpu_ilp64:dfftw_plan_dft_3d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_3d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_3d

  INTERFACE dfftw_plan_dft_c2r
    SUBROUTINE dfftw_plan_dft_c2r_cpu_lp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_cpu_lp64:dfftw_plan_dft_c2r_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_cpu_lp64

    SUBROUTINE dfftw_plan_dft_c2r_cpu_ilp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_cpu_ilp64:dfftw_plan_dft_c2r_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_cpu_ilp64
  END INTERFACE dfftw_plan_dft_c2r

  INTERFACE dfftw_plan_dft_c2r_1d
    SUBROUTINE dfftw_plan_dft_c2r_1d_cpu_lp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_1d_cpu_lp64:dfftw_plan_dft_c2r_1d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_1d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_c2r_1d_cpu_ilp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_1d_cpu_ilp64:dfftw_plan_dft_c2r_1d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_1d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_c2r_1d

  INTERFACE dfftw_plan_dft_c2r_2d
    SUBROUTINE dfftw_plan_dft_c2r_2d_cpu_lp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_2d_cpu_lp64:dfftw_plan_dft_c2r_2d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_2d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_c2r_2d_cpu_ilp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_2d_cpu_ilp64:dfftw_plan_dft_c2r_2d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_2d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_c2r_2d

  INTERFACE dfftw_plan_dft_c2r_3d
    SUBROUTINE dfftw_plan_dft_c2r_3d_cpu_lp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_3d_cpu_lp64:dfftw_plan_dft_c2r_3d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_3d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_c2r_3d_cpu_ilp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_c2r_3d_cpu_ilp64:dfftw_plan_dft_c2r_3d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_c2r_3d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_c2r_3d

  INTERFACE dfftw_plan_dft_r2c
    SUBROUTINE dfftw_plan_dft_r2c_cpu_lp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_cpu_lp64:dfftw_plan_dft_r2c_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_cpu_lp64

    SUBROUTINE dfftw_plan_dft_r2c_cpu_ilp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_cpu_ilp64:dfftw_plan_dft_r2c_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_cpu_ilp64
  END INTERFACE dfftw_plan_dft_r2c

  INTERFACE dfftw_plan_dft_r2c_1d
    SUBROUTINE dfftw_plan_dft_r2c_1d_cpu_lp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_1d_cpu_lp64:dfftw_plan_dft_r2c_1d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_1d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_r2c_1d_cpu_ilp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(*) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(*) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_1d_cpu_ilp64:dfftw_plan_dft_r2c_1d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_1d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_r2c_1d

  INTERFACE dfftw_plan_dft_r2c_2d
    SUBROUTINE dfftw_plan_dft_r2c_2d_cpu_lp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_2d_cpu_lp64:dfftw_plan_dft_r2c_2d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_2d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_r2c_2d_cpu_ilp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_2d_cpu_ilp64:dfftw_plan_dft_r2c_2d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_2d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_r2c_2d

  INTERFACE dfftw_plan_dft_r2c_3d
    SUBROUTINE dfftw_plan_dft_r2c_3d_cpu_lp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_3d_cpu_lp64:dfftw_plan_dft_r2c_3d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_3d_cpu_lp64

    SUBROUTINE dfftw_plan_dft_r2c_3d_cpu_ilp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_dft_r2c_3d_cpu_ilp64:dfftw_plan_dft_r2c_3d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_dft_r2c_3d_cpu_ilp64
  END INTERFACE dfftw_plan_dft_r2c_3d

  INTERFACE dfftw_plan_guru_dft
    SUBROUTINE dfftw_plan_guru_dft_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, s, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_cpu_lp64:dfftw_plan_guru_dft_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_cpu_lp64

    SUBROUTINE dfftw_plan_guru_dft_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, s, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_cpu_ilp64:dfftw_plan_guru_dft_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_cpu_ilp64
  END INTERFACE dfftw_plan_guru_dft

  INTERFACE dfftw_plan_guru_dft_c2r
    SUBROUTINE dfftw_plan_guru_dft_c2r_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_c2r_cpu_lp64:dfftw_plan_guru_dft_c2r_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_c2r_cpu_lp64

    SUBROUTINE dfftw_plan_guru_dft_c2r_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p 
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_c2r_cpu_ilp64:dfftw_plan_guru_dft_c2r_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_c2r_cpu_ilp64
  END INTERFACE dfftw_plan_guru_dft_c2r

  INTERFACE dfftw_plan_guru_dft_r2c
    SUBROUTINE dfftw_plan_guru_dft_r2c_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_r2c_cpu_lp64:dfftw_plan_guru_dft_r2c_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_r2c_cpu_lp64

    SUBROUTINE dfftw_plan_guru_dft_r2c_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_guru_dft_r2c_cpu_ilp64:dfftw_plan_guru_dft_r2c_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_guru_dft_r2c_cpu_ilp64
  END INTERFACE dfftw_plan_guru_dft_r2c

  INTERFACE dfftw_plan_many_dft
    SUBROUTINE dfftw_plan_many_dft_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_cpu_lp64:dfftw_plan_many_dft_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_cpu_lp64

    SUBROUTINE dfftw_plan_many_dft_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_cpu_ilp64:dfftw_plan_many_dft_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_cpu_ilp64
  END INTERFACE dfftw_plan_many_dft

  INTERFACE dfftw_plan_many_dft_c2r
    SUBROUTINE dfftw_plan_many_dft_c2r_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_c2r_cpu_lp64:dfftw_plan_many_dft_c2r_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_c2r_cpu_lp64

    SUBROUTINE dfftw_plan_many_dft_c2r_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_c2r_cpu_ilp64:dfftw_plan_many_dft_c2r_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_c2r_cpu_ilp64
  END INTERFACE dfftw_plan_many_dft_c2r

  INTERFACE dfftw_plan_many_dft_r2c
    SUBROUTINE dfftw_plan_many_dft_r2c_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_r2c_cpu_lp64:dfftw_plan_many_dft_r2c_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_r2c_cpu_lp64

    SUBROUTINE dfftw_plan_many_dft_r2c_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_DPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_DPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( dfftw_plan_many_dft_r2c_cpu_ilp64:dfftw_plan_many_dft_r2c_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE dfftw_plan_many_dft_r2c_cpu_ilp64
  END INTERFACE dfftw_plan_many_dft_r2c

  INTERFACE
    SUBROUTINE sfftw_plan_dft_1d_omp_offload_lp64(p, n, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_1d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_1d_omp_offload_ilp64(p, n, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_1d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_2d_omp_offload_lp64(p, nx, ny, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_2d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_2d_omp_offload_ilp64(p, nx, ny, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_2d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_3d_omp_offload_lp64(p, nx, ny, nz, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_3d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_3d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_c2r_omp_offload_lp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_c2r_omp_offload_ilp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_c2r_1d_omp_offload_lp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_1d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_c2r_1d_omp_offload_ilp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_1d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_c2r_2d_omp_offload_lp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_2d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_c2r_2d_omp_offload_ilp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_2d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_c2r_3d_omp_offload_lp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_3d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_c2r_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL (FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_c2r_3d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_r2c_omp_offload_lp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_r2c_omp_offload_ilp64(p, r, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: r,flags
      INTEGER(8), DIMENSION(*) :: n
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_r2c_1d_omp_offload_lp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_1d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_r2c_1d_omp_offload_ilp64(p, n, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_1d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_r2c_2d_omp_offload_lp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_2d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_r2c_2d_omp_offload_ilp64(p, nx, ny, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_2d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_dft_r2c_3d_omp_offload_lp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_3d_omp_offload_lp64

    SUBROUTINE sfftw_plan_dft_r2c_3d_omp_offload_ilp64(p, nx, ny, nz, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      REAL (FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_dft_r2c_3d_omp_offload_ilp64

    SUBROUTINE sfftw_plan_guru_dft_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, s, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, is, os, n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_omp_offload_lp64

    SUBROUTINE sfftw_plan_guru_dft_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, s, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, is, os, n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_omp_offload_ilp64
    
    SUBROUTINE sfftw_plan_guru_dft_c2r_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_c2r_omp_offload_lp64

    SUBROUTINE sfftw_plan_guru_dft_c2r_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_c2r_omp_offload_ilp64
    
    SUBROUTINE sfftw_plan_guru_dft_r2c_omp_offload_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_r2c_omp_offload_lp64

    SUBROUTINE sfftw_plan_guru_dft_r2c_omp_offload_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_guru_dft_r2c_omp_offload_ilp64

    SUBROUTINE sfftw_plan_many_dft_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_omp_offload_lp64

    SUBROUTINE sfftw_plan_many_dft_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_omp_offload_ilp64

    SUBROUTINE sfftw_plan_many_dft_c2r_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_c2r_omp_offload_lp64

    SUBROUTINE sfftw_plan_many_dft_c2r_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_c2r_omp_offload_ilp64

    SUBROUTINE sfftw_plan_many_dft_r2c_omp_offload_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_r2c_omp_offload_lp64

    SUBROUTINE sfftw_plan_many_dft_r2c_omp_offload_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_plan_many_dft_r2c_omp_offload_ilp64

    SUBROUTINE sfftw_execute_omp_offload(p, interop) BIND(C)
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_execute_omp_offload

    SUBROUTINE sfftw_execute(p)
      INTEGER*8 :: p
      !$omp  declare variant( sfftw_execute:sfftw_execute_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) )
    END SUBROUTINE sfftw_execute

    SUBROUTINE sfftw_execute_dft_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_execute_dft_omp_offload

    SUBROUTINE sfftw_execute_dft_c2r_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_execute_dft_c2r_omp_offload

    SUBROUTINE sfftw_execute_dft_r2c_omp_offload(p, in, out, interop) BIND(C)
      USE PREC
      USE, INTRINSIC :: ISO_C_BINDING
      INTEGER*8 :: p
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      TYPE(C_PTR), INTENT(IN), VALUE :: interop
    END SUBROUTINE sfftw_execute_dft_r2c_omp_offload
  END INTERFACE

  INTERFACE sfftw_execute_dft
    SUBROUTINE sfftw_execute_dft_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_execute_dft_cpu:sfftw_execute_dft_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_execute_dft_cpu
  END INTERFACE sfftw_execute_dft

  INTERFACE sfftw_execute_dft_c2r
    SUBROUTINE sfftw_execute_dft_c2r_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_execute_dft_c2r_cpu:sfftw_execute_dft_c2r_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_execute_dft_c2r_cpu
  END INTERFACE sfftw_execute_dft_c2r

  INTERFACE sfftw_execute_dft_r2c
    SUBROUTINE sfftw_execute_dft_r2c_cpu(p, in, out) BIND(C)
      USE PREC
      INTEGER*8 :: p
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_execute_dft_r2c_cpu:sfftw_execute_dft_r2c_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_execute_dft_r2c_cpu
  END INTERFACE sfftw_execute_dft_r2c

  INTERFACE sfftw_plan_dft_1d
    SUBROUTINE sfftw_plan_dft_1d_cpu_lp64(p, n, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_1d_cpu_lp64:sfftw_plan_dft_1d_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_1d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_1d_cpu_ilp64(p, n, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_1d_cpu_ilp64:sfftw_plan_dft_1d_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_1d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_1d

  INTERFACE sfftw_plan_dft_2d
    SUBROUTINE sfftw_plan_dft_2d_cpu_lp64(p, nx, ny, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_2d_cpu_lp64:sfftw_plan_dft_2d_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_2d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_2d_cpu_ilp64(p, nx, ny, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_2d_cpu_ilp64:sfftw_plan_dft_2d_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_2d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_2d

  INTERFACE sfftw_plan_dft_3d
    SUBROUTINE sfftw_plan_dft_3d_cpu_lp64(p, nx, ny, nz, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_3d_cpu_lp64:sfftw_plan_dft_3d_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_3d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_3d_cpu_ilp64(p, nx, ny, nz, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, s, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_3d_cpu_ilp64:sfftw_plan_dft_3d_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_3d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_3d

  INTERFACE sfftw_plan_dft_c2r
    SUBROUTINE sfftw_plan_dft_c2r_cpu_lp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_cpu_lp64:sfftw_plan_dft_c2r_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_cpu_lp64

    SUBROUTINE sfftw_plan_dft_c2r_cpu_ilp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_cpu_ilp64:sfftw_plan_dft_c2r_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_cpu_ilp64
  END INTERFACE sfftw_plan_dft_c2r

  INTERFACE sfftw_plan_dft_c2r_1d
    SUBROUTINE sfftw_plan_dft_c2r_1d_cpu_lp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_1d_cpu_lp64:sfftw_plan_dft_c2r_1d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_1d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_c2r_1d_cpu_ilp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_1d_cpu_ilp64:sfftw_plan_dft_c2r_1d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_1d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_c2r_1d

  INTERFACE sfftw_plan_dft_c2r_2d
    SUBROUTINE sfftw_plan_dft_c2r_2d_cpu_lp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_2d_cpu_lp64:sfftw_plan_dft_c2r_2d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_2d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_c2r_2d_cpu_ilp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_2d_cpu_ilp64:sfftw_plan_dft_c2r_2d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_2d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_c2r_2d

  INTERFACE sfftw_plan_dft_c2r_3d
    SUBROUTINE sfftw_plan_dft_c2r_3d_cpu_lp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_3d_cpu_lp64:sfftw_plan_dft_c2r_3d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_3d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_c2r_3d_cpu_ilp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_c2r_3d_cpu_ilp64:sfftw_plan_dft_c2r_3d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_c2r_3d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_c2r_3d

  INTERFACE sfftw_plan_dft_r2c
    SUBROUTINE sfftw_plan_dft_r2c_cpu_lp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: r, flags
      INTEGER(4), DIMENSION(*) :: n
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_cpu_lp64:sfftw_plan_dft_r2c_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_cpu_lp64

    SUBROUTINE sfftw_plan_dft_r2c_cpu_ilp64(p, r, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: r, flags
      INTEGER(8), DIMENSION(*) :: n
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_cpu_ilp64:sfftw_plan_dft_r2c_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_cpu_ilp64
  END INTERFACE sfftw_plan_dft_r2c

  INTERFACE sfftw_plan_dft_r2c_1d
    SUBROUTINE sfftw_plan_dft_r2c_1d_cpu_lp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: n, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_1d_cpu_lp64:sfftw_plan_dft_r2c_1d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_1d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_r2c_1d_cpu_ilp64(p, n, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: n, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(*) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(*) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_1d_cpu_ilp64:sfftw_plan_dft_r2c_1d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_1d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_r2c_1d

  INTERFACE sfftw_plan_dft_r2c_2d
    SUBROUTINE sfftw_plan_dft_r2c_2d_cpu_lp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_2d_cpu_lp64:sfftw_plan_dft_r2c_2d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_2d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_r2c_2d_cpu_ilp64(p, nx, ny, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_2d_cpu_ilp64:sfftw_plan_dft_r2c_2d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_2d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_r2c_2d

  INTERFACE sfftw_plan_dft_r2c_3d
    SUBROUTINE sfftw_plan_dft_r2c_3d_cpu_lp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: nx, ny, nz, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_3d_cpu_lp64:sfftw_plan_dft_r2c_3d_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_3d_cpu_lp64

    SUBROUTINE sfftw_plan_dft_r2c_3d_cpu_ilp64(p, nx, ny, nz, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: nx, ny, nz, flags
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_dft_r2c_3d_cpu_ilp64:sfftw_plan_dft_r2c_3d_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_dft_r2c_3d_cpu_ilp64
  END INTERFACE sfftw_plan_dft_r2c_3d

  INTERFACE sfftw_plan_guru_dft
    SUBROUTINE sfftw_plan_guru_dft_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, s, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_cpu_lp64:sfftw_plan_guru_dft_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_cpu_lp64

    SUBROUTINE sfftw_plan_guru_dft_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, s, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, n, is, os
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_cpu_ilp64:sfftw_plan_guru_dft_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_cpu_ilp64
  END INTERFACE sfftw_plan_guru_dft

  INTERFACE sfftw_plan_guru_dft_c2r
    SUBROUTINE sfftw_plan_guru_dft_c2r_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, s, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_c2r_cpu_lp64:sfftw_plan_guru_dft_c2r_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_c2r_cpu_lp64

    SUBROUTINE sfftw_plan_guru_dft_c2r_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p 
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_c2r_cpu_ilp64:sfftw_plan_guru_dft_c2r_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_c2r_cpu_ilp64
  END INTERFACE sfftw_plan_guru_dft_c2r

  INTERFACE sfftw_plan_guru_dft_r2c
    SUBROUTINE sfftw_plan_guru_dft_r2c_cpu_lp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany_rank, flags
      INTEGER(4), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_r2c_cpu_lp64:sfftw_plan_guru_dft_r2c_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_r2c_cpu_lp64

    SUBROUTINE sfftw_plan_guru_dft_r2c_cpu_ilp64(p, rank, n, is, os, howmany_rank, howmany_n, howmany_is, howmany_os, in, out, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany_rank, flags
      INTEGER(8), DIMENSION(*) :: howmany_n, howmany_is, howmany_os, os, is, n
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_guru_dft_r2c_cpu_ilp64:sfftw_plan_guru_dft_r2c_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_guru_dft_r2c_cpu_ilp64
  END INTERFACE sfftw_plan_guru_dft_r2c

  INTERFACE sfftw_plan_many_dft
    SUBROUTINE sfftw_plan_many_dft_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_cpu_lp64:sfftw_plan_many_dft_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_cpu_lp64

    SUBROUTINE sfftw_plan_many_dft_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, s, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, s, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_cpu_ilp64:sfftw_plan_many_dft_omp_offload_ilp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_cpu_ilp64
  END INTERFACE sfftw_plan_many_dft

  INTERFACE sfftw_plan_many_dft_c2r
    SUBROUTINE sfftw_plan_many_dft_c2r_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_c2r_cpu_lp64:sfftw_plan_many_dft_c2r_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_c2r_cpu_lp64

    SUBROUTINE sfftw_plan_many_dft_c2r_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      COMPLEX(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      REAL(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_c2r_cpu_ilp64:sfftw_plan_many_dft_c2r_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_c2r_cpu_ilp64
  END INTERFACE sfftw_plan_many_dft_c2r

  INTERFACE sfftw_plan_many_dft_r2c
    SUBROUTINE sfftw_plan_many_dft_r2c_cpu_lp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(4) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(4), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_r2c_cpu_lp64:sfftw_plan_many_dft_r2c_omp_offload_lp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_r2c_cpu_lp64

    SUBROUTINE sfftw_plan_many_dft_r2c_cpu_ilp64(p, rank, n, howmany, in, inembed, istride, idist, out, onembed, ostride, odist, flags) BIND(C)
      USE PREC
      INTEGER*8 :: p
      INTEGER(8) :: rank, howmany, istride, idist, ostride, odist, flags
      INTEGER(8), DIMENSION(*) :: n, inembed, onembed
      REAL(FFTW_SPKP), INTENT(IN), DIMENSION(..) :: in
      COMPLEX(FFTW_SPKP), INTENT(OUT), DIMENSION(..) :: out
      !$omp  declare variant( sfftw_plan_many_dft_r2c_cpu_ilp64:sfftw_plan_many_dft_r2c_omp_offload_ilp64  ) match( construct={dispatch}, device={arch(gen)} ) append_args( interop(prefer_type("sycl","level_zero"),targetsync) ) adjust_args( need_device_addr:in,out )
    END SUBROUTINE sfftw_plan_many_dft_r2c_cpu_ilp64
  END INTERFACE sfftw_plan_many_dft_r2c

END MODULE FFTW3_OMP_OFFLOAD

!===============================================================================
! Copyright (C) 2005 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      F95 interface for BLAS routines
!*******************************************************************************
! This file was generated automatically!
!*******************************************************************************

MODULE F95_PRECISION
    INTEGER, PARAMETER :: SP = KIND(1.0E0)
    INTEGER, PARAMETER :: DP = KIND(1.0D0)
END MODULE F95_PRECISION

MODULE BLAS95

INTERFACE ASUM
    PURE FUNCTION SASUM_F95(X)
        ! Fortran77 call:
        ! SASUM(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SASUM_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION SASUM_F95
    PURE FUNCTION SCASUM_F95(X)
        ! Fortran77 call:
        ! SCASUM(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SCASUM_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION SCASUM_F95
    PURE FUNCTION DASUM_F95(X)
        ! Fortran77 call:
        ! DASUM(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DASUM_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION DASUM_F95
    PURE FUNCTION DZASUM_F95(X)
        ! Fortran77 call:
        ! DZASUM(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DZASUM_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION DZASUM_F95
END INTERFACE ASUM

INTERFACE AXPY
        ! Default A=1
    PURE SUBROUTINE SAXPY_F95(X,Y,A)
        ! Fortran77 call:
        ! SAXPY(N,A,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: A
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SAXPY_F95
    PURE SUBROUTINE DAXPY_F95(X,Y,A)
        ! Fortran77 call:
        ! DAXPY(N,A,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: A
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DAXPY_F95
    PURE SUBROUTINE CAXPY_F95(X,Y,A)
        ! Fortran77 call:
        ! CAXPY(N,A,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: A
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CAXPY_F95
    PURE SUBROUTINE ZAXPY_F95(X,Y,A)
        ! Fortran77 call:
        ! ZAXPY(N,A,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: A
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZAXPY_F95
END INTERFACE AXPY

INTERFACE COPY
    PURE SUBROUTINE SCOPY_F95(X,Y)
        ! Fortran77 call:
        ! SCOPY(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SCOPY_F95
    PURE SUBROUTINE DCOPY_F95(X,Y)
        ! Fortran77 call:
        ! DCOPY(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DCOPY_F95
    PURE SUBROUTINE CCOPY_F95(X,Y)
        ! Fortran77 call:
        ! CCOPY(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CCOPY_F95
    PURE SUBROUTINE ZCOPY_F95(X,Y)
        ! Fortran77 call:
        ! ZCOPY(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZCOPY_F95
END INTERFACE COPY

INTERFACE DOT
    PURE FUNCTION SDOT_F95(X,Y)
        ! Fortran77 call:
        ! SDOT(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SDOT_F95
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END FUNCTION SDOT_F95
    PURE FUNCTION DDOT_F95(X,Y)
        ! Fortran77 call:
        ! DDOT(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DDOT_F95
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END FUNCTION DDOT_F95
END INTERFACE DOT

INTERFACE SDOT
    PURE FUNCTION SDSDOT_F95(SX,SY,SB)
        ! Fortran77 call:
        ! SDSDOT(N,SB,SX,INCX,SY,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SDSDOT_F95
        REAL(WP), INTENT(IN) :: SB
        REAL(WP), INTENT(IN) :: SX(:)
        REAL(WP), INTENT(IN) :: SY(:)
    END FUNCTION SDSDOT_F95
    PURE FUNCTION DSDOT_F95(SX,SY)
        ! Fortran77 call:
        ! DSDOT(N,SX,INCX,SY,INCY)
        USE F95_PRECISION, ONLY: WP => DP, SP
        REAL(WP) :: DSDOT_F95
        REAL(SP), INTENT(IN) :: SX(:)
        REAL(SP), INTENT(IN) :: SY(:)
    END FUNCTION DSDOT_F95
END INTERFACE SDOT

INTERFACE DOTC
    PURE FUNCTION CDOTC_F95(X,Y)
        ! Fortran77 call:
        ! CDOTC(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP) :: CDOTC_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION CDOTC_F95
    PURE FUNCTION ZDOTC_F95(X,Y)
        ! Fortran77 call:
        ! ZDOTC(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP) :: ZDOTC_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION ZDOTC_F95
END INTERFACE DOTC

INTERFACE DOTU
    PURE FUNCTION CDOTU_F95(X,Y)
        ! Fortran77 call:
        ! CDOTU(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP) :: CDOTU_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION CDOTU_F95
    PURE FUNCTION ZDOTU_F95(X,Y)
        ! Fortran77 call:
        ! ZDOTU(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP) :: ZDOTU_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION ZDOTU_F95
END INTERFACE DOTU

INTERFACE NRM2
    PURE FUNCTION SNRM2_F95(X)
        ! Fortran77 call:
        ! SNRM2(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SNRM2_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION SNRM2_F95
    PURE FUNCTION DNRM2_F95(X)
        ! Fortran77 call:
        ! DNRM2(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DNRM2_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION DNRM2_F95
    PURE FUNCTION SCNRM2_F95(X)
        ! Fortran77 call:
        ! SCNRM2(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SCNRM2_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION SCNRM2_F95
    PURE FUNCTION DZNRM2_F95(X)
        ! Fortran77 call:
        ! DZNRM2(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DZNRM2_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION DZNRM2_F95
END INTERFACE NRM2

INTERFACE ROT
    PURE SUBROUTINE SROT_F95(X,Y,C,S)
        ! Fortran77 call:
        ! SROT(N,X,INCX,Y,INCY,C,S)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SROT_F95
    PURE SUBROUTINE DROT_F95(X,Y,C,S)
        ! Fortran77 call:
        ! DROT(N,X,INCX,Y,INCY,C,S)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DROT_F95
    PURE SUBROUTINE CSROT_F95(X,Y,C,S)
        ! Fortran77 call:
        ! CSROT(N,X,INCX,Y,INCY,C,S)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        COMPLEX(WP), INTENT(INOUT) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CSROT_F95
    PURE SUBROUTINE ZDROT_F95(X,Y,C,S)
        ! Fortran77 call:
        ! ZDROT(N,X,INCX,Y,INCY,C,S)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        COMPLEX(WP), INTENT(INOUT) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZDROT_F95
END INTERFACE ROT

INTERFACE ROTG
    PURE SUBROUTINE SROTG_F95(A,B,C,S)
        ! Fortran77 call:
        ! SROTG(A,B,C,S)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: A
        REAL(WP), INTENT(INOUT) :: B
        REAL(WP), INTENT(OUT) :: C
        REAL(WP), INTENT(OUT) :: S
    END SUBROUTINE SROTG_F95
    PURE SUBROUTINE DROTG_F95(A,B,C,S)
        ! Fortran77 call:
        ! DROTG(A,B,C,S)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: A
        REAL(WP), INTENT(INOUT) :: B
        REAL(WP), INTENT(OUT) :: C
        REAL(WP), INTENT(OUT) :: S
    END SUBROUTINE DROTG_F95
    PURE SUBROUTINE CROTG_F95(A,B,C,S)
        ! Fortran77 call:
        ! CROTG(A,B,C,S)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(INOUT) :: A
        COMPLEX(WP), INTENT(INOUT) :: B
        REAL(WP), INTENT(OUT) :: C
        COMPLEX(WP), INTENT(OUT) :: S
    END SUBROUTINE CROTG_F95
    PURE SUBROUTINE ZROTG_F95(A,B,C,S)
        ! Fortran77 call:
        ! ZROTG(A,B,C,S)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(INOUT) :: A
        COMPLEX(WP), INTENT(INOUT) :: B
        REAL(WP), INTENT(OUT) :: C
        COMPLEX(WP), INTENT(OUT) :: S
    END SUBROUTINE ZROTG_F95
END INTERFACE ROTG

INTERFACE ROTM
    PURE SUBROUTINE SROTM_F95(X,Y,PARAM)
        ! Fortran77 call:
        ! SROTM(N,X,INCX,Y,INCY,PARAM)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
        REAL(WP), INTENT(IN) :: PARAM(5)
    END SUBROUTINE SROTM_F95
    PURE SUBROUTINE DROTM_F95(X,Y,PARAM)
        ! Fortran77 call:
        ! DROTM(N,X,INCX,Y,INCY,PARAM)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
        REAL(WP), INTENT(IN) :: PARAM(5)
    END SUBROUTINE DROTM_F95
END INTERFACE ROTM

INTERFACE ROTMG
    PURE SUBROUTINE SROTMG_F95(D1,D2,X1,Y1,PARAM)
        ! Fortran77 call:
        ! SROTMG(D1,D2,X1,Y1,PARAM)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: D1
        REAL(WP), INTENT(INOUT) :: D2
        REAL(WP), INTENT(INOUT) :: X1
        REAL(WP), INTENT(IN) :: Y1
        REAL(WP), INTENT(OUT) :: PARAM(5)
    END SUBROUTINE SROTMG_F95
    PURE SUBROUTINE DROTMG_F95(D1,D2,X1,Y1,PARAM)
        ! Fortran77 call:
        ! DROTMG(D1,D2,X1,Y1,PARAM)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: D1
        REAL(WP), INTENT(INOUT) :: D2
        REAL(WP), INTENT(INOUT) :: X1
        REAL(WP), INTENT(IN) :: Y1
        REAL(WP), INTENT(OUT) :: PARAM(5)
    END SUBROUTINE DROTMG_F95
END INTERFACE ROTMG

INTERFACE SCAL
    PURE SUBROUTINE SSCAL_F95(X,A)
        ! Fortran77 call:
        ! SSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: A
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE SSCAL_F95
    PURE SUBROUTINE DSCAL_F95(X,A)
        ! Fortran77 call:
        ! DSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: A
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DSCAL_F95
    PURE SUBROUTINE CSCAL_F95(X,A)
        ! Fortran77 call:
        ! CSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN) :: A
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CSCAL_F95
    PURE SUBROUTINE ZSCAL_F95(X,A)
        ! Fortran77 call:
        ! ZSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN) :: A
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZSCAL_F95
    PURE SUBROUTINE CSSCAL_F95(X,A)
        ! Fortran77 call:
        ! CSSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: A
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CSSCAL_F95
    PURE SUBROUTINE ZDSCAL_F95(X,A)
        ! Fortran77 call:
        ! ZDSCAL(N,A,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: A
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZDSCAL_F95
END INTERFACE SCAL

INTERFACE SWAP
    PURE SUBROUTINE SSWAP_F95(X,Y)
        ! Fortran77 call:
        ! SSWAP(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SSWAP_F95
    PURE SUBROUTINE DSWAP_F95(X,Y)
        ! Fortran77 call:
        ! DSWAP(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(INOUT) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DSWAP_F95
    PURE SUBROUTINE CSWAP_F95(X,Y)
        ! Fortran77 call:
        ! CSWAP(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(INOUT) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CSWAP_F95
    PURE SUBROUTINE ZSWAP_F95(X,Y)
        ! Fortran77 call:
        ! ZSWAP(N,X,INCX,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(INOUT) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZSWAP_F95
END INTERFACE SWAP

INTERFACE IAMAX
    PURE FUNCTION ISAMAX_F95(X)
        ! Fortran77 call:
        ! ISAMAX(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER :: ISAMAX_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION ISAMAX_F95
    PURE FUNCTION IDAMAX_F95(X)
        ! Fortran77 call:
        ! IDAMAX(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER :: IDAMAX_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION IDAMAX_F95
    PURE FUNCTION ICAMAX_F95(X)
        ! Fortran77 call:
        ! ICAMAX(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER :: ICAMAX_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION ICAMAX_F95
    PURE FUNCTION IZAMAX_F95(X)
        ! Fortran77 call:
        ! IZAMAX(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER :: IZAMAX_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION IZAMAX_F95
END INTERFACE IAMAX

INTERFACE IAMIN
    PURE FUNCTION ISAMIN_F95(X)
        ! Fortran77 call:
        ! ISAMIN(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER :: ISAMIN_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION ISAMIN_F95
    PURE FUNCTION IDAMIN_F95(X)
        ! Fortran77 call:
        ! IDAMIN(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER :: IDAMIN_F95
        REAL(WP), INTENT(IN) :: X(:)
    END FUNCTION IDAMIN_F95
    PURE FUNCTION ICAMIN_F95(X)
        ! Fortran77 call:
        ! ICAMIN(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER :: ICAMIN_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION ICAMIN_F95
    PURE FUNCTION IZAMIN_F95(X)
        ! Fortran77 call:
        ! IZAMIN(N,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER :: IZAMIN_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
    END FUNCTION IZAMIN_F95
END INTERFACE IAMIN

INTERFACE CABS1
    PURE FUNCTION SCABS1_F95(C)
        ! Fortran77 call:
        ! SCABS1(C)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SCABS1_F95
        COMPLEX(WP), INTENT(IN) :: C
    END FUNCTION SCABS1_F95
    PURE FUNCTION DCABS1_F95(Z)
        ! Fortran77 call:
        ! DCABS1(Z)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DCABS1_F95
        COMPLEX(WP), INTENT(IN) :: Z
    END FUNCTION DCABS1_F95
END INTERFACE CABS1

INTERFACE GBMV
        ! TRANS='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SGBMV_F95(A,X,Y,KL,M,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! SGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER, INTENT(IN), OPTIONAL :: KL
        INTEGER, INTENT(IN), OPTIONAL :: M
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SGBMV_F95
    PURE SUBROUTINE DGBMV_F95(A,X,Y,KL,M,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! DGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER, INTENT(IN), OPTIONAL :: KL
        INTEGER, INTENT(IN), OPTIONAL :: M
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DGBMV_F95
    PURE SUBROUTINE CGBMV_F95(A,X,Y,KL,M,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! CGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        INTEGER, INTENT(IN), OPTIONAL :: KL
        INTEGER, INTENT(IN), OPTIONAL :: M
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CGBMV_F95
    PURE SUBROUTINE ZGBMV_F95(A,X,Y,KL,M,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! ZGBMV(TRANS,M,N,KL,KU,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        INTEGER, INTENT(IN), OPTIONAL :: KL
        INTEGER, INTENT(IN), OPTIONAL :: M
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZGBMV_F95
END INTERFACE GBMV

INTERFACE GEMV
        ! TRANS='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SGEMV_F95
    PURE SUBROUTINE DGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DGEMV_F95
    PURE SUBROUTINE CGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! CGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CGEMV_F95
    PURE SUBROUTINE ZGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! ZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZGEMV_F95
    PURE SUBROUTINE SCGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! SCGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SCGEMV_F95
    PURE SUBROUTINE DZGEMV_F95(A,X,Y,ALPHA,BETA,TRANS)
        ! Fortran77 call:
        ! DZGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DZGEMV_F95
END INTERFACE GEMV

INTERFACE GER
        ! Default ALPHA=1
    PURE SUBROUTINE SGER_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! SGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE SGER_F95
    PURE SUBROUTINE DGER_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! DGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE DGER_F95
END INTERFACE GER

INTERFACE GERC
        ! Default ALPHA=1
    PURE SUBROUTINE CGERC_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! CGERC(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE CGERC_F95
    PURE SUBROUTINE ZGERC_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! ZGERC(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE ZGERC_F95
END INTERFACE GERC

INTERFACE GERU
        ! Default ALPHA=1
    PURE SUBROUTINE CGERU_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! CGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE CGERU_F95
    PURE SUBROUTINE ZGERU_F95(A,X,Y,ALPHA)
        ! Fortran77 call:
        ! ZGERU(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE ZGERU_F95
END INTERFACE GERU

INTERFACE HBMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHBMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! CHBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CHBMV_F95
    PURE SUBROUTINE ZHBMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZHBMV_F95
END INTERFACE HBMV

INTERFACE HEMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHEMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! CHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CHEMV_F95
    PURE SUBROUTINE ZHEMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHEMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZHEMV_F95
END INTERFACE HEMV

INTERFACE HER
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE CHER_F95(A,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! CHER(UPLO,N,ALPHA,X,INCX,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
    END SUBROUTINE CHER_F95
    PURE SUBROUTINE ZHER_F95(A,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! ZHER(UPLO,N,ALPHA,X,INCX,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
    END SUBROUTINE ZHER_F95
END INTERFACE HER

INTERFACE HER2
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE CHER2_F95(A,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! CHER2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE CHER2_F95
    PURE SUBROUTINE ZHER2_F95(A,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! ZHER2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE ZHER2_F95
END INTERFACE HER2

INTERFACE HPMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHPMV_F95(AP,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! CHPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CHPMV_F95
    PURE SUBROUTINE ZHPMV_F95(AP,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZHPMV_F95
END INTERFACE HPMV

INTERFACE HPR
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE CHPR_F95(AP,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! CHPR(UPLO,N,ALPHA,X,INCX,AP)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
    END SUBROUTINE CHPR_F95
    PURE SUBROUTINE ZHPR_F95(AP,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! ZHPR(UPLO,N,ALPHA,X,INCX,AP)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
    END SUBROUTINE ZHPR_F95
END INTERFACE HPR

INTERFACE HPR2
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE CHPR2_F95(AP,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! CHPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE CHPR2_F95
    PURE SUBROUTINE ZHPR2_F95(AP,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! ZHPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(INOUT) :: AP(:)
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE ZHPR2_F95
END INTERFACE HPR2

INTERFACE SBMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSBMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! SSBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SSBMV_F95
    PURE SUBROUTINE DSBMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! DSBMV(UPLO,N,K,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DSBMV_F95
END INTERFACE SBMV

INTERFACE SPMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSPMV_F95(AP,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! SSPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SSPMV_F95
    PURE SUBROUTINE DSPMV_F95(AP,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! DSPMV(UPLO,N,ALPHA,AP,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DSPMV_F95
END INTERFACE SPMV

INTERFACE SPR
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE SSPR_F95(AP,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! SSPR(UPLO,N,ALPHA,X,INCX,AP)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
    END SUBROUTINE SSPR_F95
    PURE SUBROUTINE DSPR_F95(AP,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! DSPR(UPLO,N,ALPHA,X,INCX,AP)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
    END SUBROUTINE DSPR_F95
END INTERFACE SPR

INTERFACE SPR2
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE SSPR2_F95(AP,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! SSPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE SSPR2_F95
    PURE SUBROUTINE DSPR2_F95(AP,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! DSPR2(UPLO,N,ALPHA,X,INCX,Y,INCY,AP)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: AP(:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE DSPR2_F95
END INTERFACE SPR2

INTERFACE SYMV
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSYMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! SSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SSYMV_F95
    PURE SUBROUTINE DSYMV_F95(A,X,Y,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! DSYMV(UPLO,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DSYMV_F95
END INTERFACE SYMV

INTERFACE SYR
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE SSYR_F95(A,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! SSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
    END SUBROUTINE SSYR_F95
    PURE SUBROUTINE DSYR_F95(A,X,UPLO,ALPHA)
        ! Fortran77 call:
        ! DSYR(UPLO,N,ALPHA,X,INCX,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
    END SUBROUTINE DSYR_F95
END INTERFACE SYR

INTERFACE SYR2
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
    PURE SUBROUTINE SSYR2_F95(A,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! SSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE SSYR2_F95
    PURE SUBROUTINE DSYR2_F95(A,X,Y,UPLO,ALPHA)
        ! Fortran77 call:
        ! DSYR2(UPLO,N,ALPHA,X,INCX,Y,INCY,A,LDA)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(INOUT) :: A(:,:)
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE DSYR2_F95
END INTERFACE SYR2

INTERFACE TBMV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STBMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STBMV_F95
    PURE SUBROUTINE DTBMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTBMV_F95
    PURE SUBROUTINE CTBMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTBMV_F95
    PURE SUBROUTINE ZTBMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTBMV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTBMV_F95
END INTERFACE TBMV

INTERFACE TBSV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STBSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STBSV_F95
    PURE SUBROUTINE DTBSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTBSV_F95
    PURE SUBROUTINE CTBSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTBSV_F95
    PURE SUBROUTINE ZTBSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTBSV(UPLO,TRANS,DIAG,N,K,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTBSV_F95
END INTERFACE TBSV

INTERFACE TPMV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STPMV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STPMV_F95
    PURE SUBROUTINE DTPMV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTPMV_F95
    PURE SUBROUTINE CTPMV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTPMV_F95
    PURE SUBROUTINE ZTPMV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTPMV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTPMV_F95
END INTERFACE TPMV

INTERFACE TPSV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STPSV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STPSV_F95
    PURE SUBROUTINE DTPSV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: AP(:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTPSV_F95
    PURE SUBROUTINE CTPSV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTPSV_F95
    PURE SUBROUTINE ZTPSV_F95(AP,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTPSV(UPLO,TRANS,DIAG,N,AP,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: AP(:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTPSV_F95
END INTERFACE TPSV

INTERFACE TRMV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STRMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STRMV_F95
    PURE SUBROUTINE DTRMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTRMV_F95
    PURE SUBROUTINE CTRMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTRMV_F95
    PURE SUBROUTINE ZTRMV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTRMV_F95
END INTERFACE TRMV

INTERFACE TRSV
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
    PURE SUBROUTINE STRSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! STRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE STRSV_F95
    PURE SUBROUTINE DTRSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! DTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE DTRSV_F95
    PURE SUBROUTINE CTRSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! CTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE CTRSV_F95
    PURE SUBROUTINE ZTRSV_F95(A,X,UPLO,TRANS,DIAG)
        ! Fortran77 call:
        ! ZTRSV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: X(:)
    END SUBROUTINE ZTRSV_F95
END INTERFACE TRSV

INTERFACE GEMM
        ! TRANSA='N','C','T'; default: 'N'
        ! TRANSB='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SGEMM_F95
    PURE SUBROUTINE DGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DGEMM_F95
    PURE SUBROUTINE CGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! CGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CGEMM_F95
    PURE SUBROUTINE ZGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! ZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZGEMM_F95
    PURE SUBROUTINE SCGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! SCGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SCGEMM_F95
    PURE SUBROUTINE DZGEMM_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! DZGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DZGEMM_F95
END INTERFACE GEMM

INTERFACE HEMM
        ! SIDE='L','R'; default: 'L'
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHEMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! CHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CHEMM_F95
    PURE SUBROUTINE ZHEMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHEMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZHEMM_F95
END INTERFACE HEMM

INTERFACE HERK
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHERK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! CHERK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CHERK_F95
    PURE SUBROUTINE ZHERK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHERK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZHERK_F95
END INTERFACE HERK

INTERFACE HER2K
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CHER2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! CHER2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CHER2K_F95
    PURE SUBROUTINE ZHER2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! ZHER2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZHER2K_F95
END INTERFACE HER2K

INTERFACE SYMM
        ! SIDE='L','R'; default: 'L'
        ! UPLO='U','L'; default: 'U'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSYMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! SSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SSYMM_F95
    PURE SUBROUTINE DSYMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! DSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DSYMM_F95
    PURE SUBROUTINE CSYMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! CSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CSYMM_F95
    PURE SUBROUTINE ZSYMM_F95(A,B,C,SIDE,UPLO,ALPHA,BETA)
        ! Fortran77 call:
        ! ZSYMM(SIDE,UPLO,M,N,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZSYMM_F95
END INTERFACE SYMM

INTERFACE SYRK
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSYRK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! SSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SSYRK_F95
    PURE SUBROUTINE DSYRK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! DSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DSYRK_F95
    PURE SUBROUTINE CSYRK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! CSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CSYRK_F95
    PURE SUBROUTINE ZSYRK_F95(A,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! ZSYRK(UPLO,TRANS,N,K,ALPHA,A,LDA,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZSYRK_F95
END INTERFACE SYRK

INTERFACE SYR2K
        ! UPLO='U','L'; default: 'U'
        ! TRANS='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SSYR2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! SSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SSYR2K_F95
    PURE SUBROUTINE DSYR2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! DSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DSYR2K_F95
    PURE SUBROUTINE CSYR2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! CSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CSYR2K_F95
    PURE SUBROUTINE ZSYR2K_F95(A,B,C,UPLO,TRANS,ALPHA,BETA)
        ! Fortran77 call:
        ! ZSYR2K(UPLO,TRANS,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANS
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZSYR2K_F95
END INTERFACE SYR2K

INTERFACE TRMM
        ! SIDE='L','R'; default: 'L'
        ! UPLO='U','L'; default: 'U'
        ! TRANSA='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
        ! Default ALPHA=1
    PURE SUBROUTINE STRMM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! STRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE STRMM_F95
    PURE SUBROUTINE DTRMM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! DTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE DTRMM_F95
    PURE SUBROUTINE CTRMM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! CTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE CTRMM_F95
    PURE SUBROUTINE ZTRMM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! ZTRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE ZTRMM_F95
END INTERFACE TRMM

INTERFACE TRSM
        ! SIDE='L','R'; default: 'L'
        ! UPLO='U','L'; default: 'U'
        ! TRANSA='N','C','T'; default: 'N'
        ! DIAG='N','U'; default: 'N'
        ! Default ALPHA=1
    PURE SUBROUTINE STRSM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! STRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE STRSM_F95
    PURE SUBROUTINE DTRSM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! DTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE DTRSM_F95
    PURE SUBROUTINE CTRSM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! CTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE CTRSM_F95
    PURE SUBROUTINE ZTRSM_F95(A,B,SIDE,UPLO,TRANSA,DIAG,ALPHA)
        ! Fortran77 call:
        ! ZTRSM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: SIDE
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: DIAG
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(INOUT) :: B(:,:)
    END SUBROUTINE ZTRSM_F95
END INTERFACE TRSM

INTERFACE GEMMT
        ! UPLO='U','L'; default: 'U'
        ! TRANSA='N','C','T'; default: 'N'
        ! TRANSB='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SGEMMT_F95(A,B,C,UPLO,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! SGEMMT(UPLO,TRANSA,TRANSB,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE SGEMMT_F95
    PURE SUBROUTINE DGEMMT_F95(A,B,C,UPLO,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! DGEMMT(UPLO,TRANSA,TRANSB,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: B(:,:)
        REAL(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE DGEMMT_F95
    PURE SUBROUTINE CGEMMT_F95(A,B,C,UPLO,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! CGEMMT(UPLO,TRANSA,TRANSB,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CGEMMT_F95
    PURE SUBROUTINE ZGEMMT_F95(A,B,C,UPLO,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! ZGEMMT(UPLO,TRANSA,TRANSB,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: UPLO
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZGEMMT_F95
END INTERFACE GEMMT

INTERFACE AXPYI
        ! Default A=1
    PURE SUBROUTINE SAXPYI_F95(X,INDX,Y,A)
        ! Fortran77 call:
        ! SAXPYI(NZ,A,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: A
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SAXPYI_F95
    PURE SUBROUTINE DAXPYI_F95(X,INDX,Y,A)
        ! Fortran77 call:
        ! DAXPYI(NZ,A,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: A
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DAXPYI_F95
    PURE SUBROUTINE CAXPYI_F95(X,INDX,Y,A)
        ! Fortran77 call:
        ! CAXPYI(NZ,A,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: A
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CAXPYI_F95
    PURE SUBROUTINE ZAXPYI_F95(X,INDX,Y,A)
        ! Fortran77 call:
        ! ZAXPYI(NZ,A,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: A
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZAXPYI_F95
END INTERFACE AXPYI

INTERFACE DOTI
    PURE FUNCTION SDOTI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! SDOTI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP) :: SDOTI_F95
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END FUNCTION SDOTI_F95
    PURE FUNCTION DDOTI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! DDOTI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP) :: DDOTI_F95
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END FUNCTION DDOTI_F95
END INTERFACE DOTI

INTERFACE DOTCI
    PURE FUNCTION CDOTCI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! CDOTCI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP) :: CDOTCI_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION CDOTCI_F95
    PURE FUNCTION ZDOTCI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! ZDOTCI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP) :: ZDOTCI_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION ZDOTCI_F95
END INTERFACE DOTCI

INTERFACE DOTUI
    PURE FUNCTION CDOTUI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! CDOTUI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP) :: CDOTUI_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION CDOTUI_F95
    PURE FUNCTION ZDOTUI_F95(X,INDX,Y)
        ! Fortran77 call:
        ! ZDOTUI(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP) :: ZDOTUI_F95
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END FUNCTION ZDOTUI_F95
END INTERFACE DOTUI

INTERFACE GTHR
    PURE SUBROUTINE SGTHR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! SGTHR(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE SGTHR_F95
    PURE SUBROUTINE DGTHR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! DGTHR(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE DGTHR_F95
    PURE SUBROUTINE CGTHR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! CGTHR(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE CGTHR_F95
    PURE SUBROUTINE ZGTHR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! ZGTHR(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE ZGTHR_F95
END INTERFACE GTHR

INTERFACE GTHRZ
    PURE SUBROUTINE SGTHRZ_F95(X,INDX,Y)
        ! Fortran77 call:
        ! SGTHRZ(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SGTHRZ_F95
    PURE SUBROUTINE DGTHRZ_F95(X,INDX,Y)
        ! Fortran77 call:
        ! DGTHRZ(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DGTHRZ_F95
    PURE SUBROUTINE CGTHRZ_F95(X,INDX,Y)
        ! Fortran77 call:
        ! CGTHRZ(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CGTHRZ_F95
    PURE SUBROUTINE ZGTHRZ_F95(X,INDX,Y)
        ! Fortran77 call:
        ! ZGTHRZ(NZ,Y,X,INDX)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(OUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZGTHRZ_F95
END INTERFACE GTHRZ

INTERFACE ROTI
        ! Default C=1
        ! Default S=1
    PURE SUBROUTINE SROTI_F95(X,INDX,Y,C,S)
        ! Fortran77 call:
        ! SROTI(NZ,X,INDX,Y,C,S)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        REAL(WP), INTENT(INOUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE SROTI_F95
    PURE SUBROUTINE DROTI_F95(X,INDX,Y,C,S)
        ! Fortran77 call:
        ! DROTI(NZ,X,INDX,Y,C,S)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: C
        REAL(WP), INTENT(IN) :: S
        REAL(WP), INTENT(INOUT) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(IN) :: Y(:)
    END SUBROUTINE DROTI_F95
END INTERFACE ROTI

INTERFACE SCTR
    PURE SUBROUTINE SSCTR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! SSCTR(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(OUT) :: Y(:)
    END SUBROUTINE SSCTR_F95
    PURE SUBROUTINE DSCTR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! DSCTR(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        REAL(WP), INTENT(OUT) :: Y(:)
    END SUBROUTINE DSCTR_F95
    PURE SUBROUTINE CSCTR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! CSCTR(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(OUT) :: Y(:)
    END SUBROUTINE CSCTR_F95
    PURE SUBROUTINE ZSCTR_F95(X,INDX,Y)
        ! Fortran77 call:
        ! ZSCTR(NZ,X,INDX,Y)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN) :: X(:)
        INTEGER, INTENT(IN) :: INDX(:)
        COMPLEX(WP), INTENT(OUT) :: Y(:)
    END SUBROUTINE ZSCTR_F95
END INTERFACE SCTR

INTERFACE GEMM3M
        ! TRANSA='N','C','T'; default: 'N'
        ! TRANSB='N','C','T'; default: 'N'
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE CGEMM3M_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! CGEMM3M(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => SP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE CGEMM3M_F95
    PURE SUBROUTINE ZGEMM3M_F95(A,B,C,TRANSA,TRANSB,ALPHA,BETA)
        ! Fortran77 call:
        ! ZGEMM3M(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        USE F95_PRECISION, ONLY: WP => DP
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSA
        CHARACTER(LEN=1), INTENT(IN), OPTIONAL :: TRANSB
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: B(:,:)
        COMPLEX(WP), INTENT(INOUT) :: C(:,:)
    END SUBROUTINE ZGEMM3M_F95
END INTERFACE GEMM3M

INTERFACE AXPBY
        ! Default ALPHA=1
        ! Default BETA=1
    PURE SUBROUTINE SAXPBY_F95(X,Y,ALPHA,BETA)
        ! Fortran77 call:
        ! SAXPBY(N,ALPHA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE SAXPBY_F95
    PURE SUBROUTINE DAXPBY_F95(X,Y,ALPHA,BETA)
        ! Fortran77 call:
        ! DAXPBY(N,ALPHA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: X(:)
        REAL(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE DAXPBY_F95
    PURE SUBROUTINE CAXPBY_F95(X,Y,ALPHA,BETA)
        ! Fortran77 call:
        ! CAXPBY(N,ALPHA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE CAXPBY_F95
    PURE SUBROUTINE ZAXPBY_F95(X,Y,ALPHA,BETA)
        ! Fortran77 call:
        ! ZAXPBY(N,ALPHA,X,INCX,BETA,Y,INCY)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: X(:)
        COMPLEX(WP), INTENT(INOUT) :: Y(:)
    END SUBROUTINE ZAXPBY_F95
END INTERFACE AXPBY

INTERFACE GEM2V
        ! Default ALPHA=1
        ! Default BETA=0
    PURE SUBROUTINE SGEM2VU_F95(A,X1,X2,Y1,Y2,ALPHA,BETA)
        ! Fortran77 call:
        ! SGEM2VU(M,N,ALPHA,A,LDA,X1,INCX1,X2,INCX2,BETA,Y1,INCY1,Y2,
        !   INCY2)
        USE F95_PRECISION, ONLY: WP => SP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X1(:)
        REAL(WP), INTENT(IN) :: X2(:)
        REAL(WP), INTENT(INOUT) :: Y1(:)
        REAL(WP), INTENT(INOUT) :: Y2(:)
    END SUBROUTINE SGEM2VU_F95
    PURE SUBROUTINE DGEM2VU_F95(A,X1,X2,Y1,Y2,ALPHA,BETA)
        ! Fortran77 call:
        ! DGEM2VU(M,N,ALPHA,A,LDA,X1,INCX1,X2,INCX2,BETA,Y1,INCY1,Y2,
        !   INCY2)
        USE F95_PRECISION, ONLY: WP => DP
        REAL(WP), INTENT(IN), OPTIONAL :: ALPHA
        REAL(WP), INTENT(IN), OPTIONAL :: BETA
        REAL(WP), INTENT(IN) :: A(:,:)
        REAL(WP), INTENT(IN) :: X1(:)
        REAL(WP), INTENT(IN) :: X2(:)
        REAL(WP), INTENT(INOUT) :: Y1(:)
        REAL(WP), INTENT(INOUT) :: Y2(:)
    END SUBROUTINE DGEM2VU_F95
    PURE SUBROUTINE CGEM2VC_F95(A,X1,X2,Y1,Y2,ALPHA,BETA)
        ! Fortran77 call:
        ! CGEM2VC(M,N,ALPHA,A,LDA,X1,INCX1,X2,INCX2,BETA,Y1,INCY1,Y2,
        !   INCY2)
        USE F95_PRECISION, ONLY: WP => SP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X1(:)
        COMPLEX(WP), INTENT(IN) :: X2(:)
        COMPLEX(WP), INTENT(INOUT) :: Y1(:)
        COMPLEX(WP), INTENT(INOUT) :: Y2(:)
    END SUBROUTINE CGEM2VC_F95
    PURE SUBROUTINE ZGEM2VC_F95(A,X1,X2,Y1,Y2,ALPHA,BETA)
        ! Fortran77 call:
        ! ZGEM2VC(M,N,ALPHA,A,LDA,X1,INCX1,X2,INCX2,BETA,Y1,INCY1,Y2,
        !   INCY2)
        USE F95_PRECISION, ONLY: WP => DP
        COMPLEX(WP), INTENT(IN), OPTIONAL :: ALPHA
        COMPLEX(WP), INTENT(IN), OPTIONAL :: BETA
        COMPLEX(WP), INTENT(IN) :: A(:,:)
        COMPLEX(WP), INTENT(IN) :: X1(:)
        COMPLEX(WP), INTENT(IN) :: X2(:)
        COMPLEX(WP), INTENT(INOUT) :: Y1(:)
        COMPLEX(WP), INTENT(INOUT) :: Y2(:)
    END SUBROUTINE ZGEM2VC_F95
END INTERFACE GEM2V

INTERFACE SGEMM_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE SGEMM_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! SGEMM_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => SP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        REAL(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        REAL(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE SGEMM_BATCH_F95
END INTERFACE SGEMM_BATCH

INTERFACE DGEMM_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE DGEMM_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! DGEMM_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => DP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        REAL(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        REAL(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE DGEMM_BATCH_F95
END INTERFACE DGEMM_BATCH

INTERFACE CGEMM_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE CGEMM_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! CGEMM_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => SP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE CGEMM_BATCH_F95
END INTERFACE CGEMM_BATCH

INTERFACE ZGEMM_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE ZGEMM_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! ZGEMM_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => DP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE ZGEMM_BATCH_F95
END INTERFACE ZGEMM_BATCH

INTERFACE CGEMM3M_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE CGEMM3M_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! CGEMM3M_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => SP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE CGEMM3M_BATCH_F95
END INTERFACE CGEMM3M_BATCH

INTERFACE ZGEMM3M_BATCH
        ! TRANSA_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! TRANSB_ARRAY=Array where each element is one of 'N','C','T'; default: 'N'
        ! ALPHA_ARRAY=Array of alpha values; default: 1
        ! BETA_ARRAY=Array of beta values; default: 0
    PURE SUBROUTINE ZGEMM3M_BATCH_F95(A_ARRAY,B_ARRAY,C_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY, &
         GROUP_SIZE,TRANSA_ARRAY,TRANSB_ARRAY,ALPHA_ARRAY,BETA_ARRAY)
        ! Fortran77 call:
        ! ZGEMM3M_BATCH(TRANSA_ARRAY,TRANSB_ARRAY,M_ARRAY,N_ARRAY,K_ARRAY,ALPHA_ARRAY,A_ARRAY,LDA_ARRAY,B_ARRAY,LDB_ARRAY,BETA_ARRAY,C_ARRAY,LDC_ARRAY,GROUP_COUNT,GROUP_SIZE)
        USE F95_PRECISION, ONLY: WP => DP
        USE, INTRINSIC :: ISO_C_BINDING
        ! TRANSA_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSA_ARRAY(:)
        ! TRANSB_ARRAY: INOUT intent instead of IN because PURE.
        CHARACTER(LEN=1), INTENT(INOUT), OPTIONAL :: TRANSB_ARRAY(:)
        ! ALPHA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: ALPHA_ARRAY(:)
        ! BETA_ARRAY: INOUT intent instead of IN because PURE.
        COMPLEX(WP), INTENT(INOUT), OPTIONAL :: BETA_ARRAY(:)
        INTEGER, INTENT(IN) :: M_ARRAY(:)
        INTEGER, INTENT(IN) :: N_ARRAY(:)
        INTEGER, INTENT(IN) :: K_ARRAY(:)
        INTEGER, INTENT(IN) :: GROUP_SIZE(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: A_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(IN) :: B_ARRAY(:)
        INTEGER(KIND=C_INTPTR_T), INTENT(INOUT) :: C_ARRAY(:)
    END SUBROUTINE ZGEMM3M_BATCH_F95
END INTERFACE ZGEMM3M_BATCH

END MODULE BLAS95

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      oneMKL Library FORTRAN interface for VSL OpenMP offload
!*******************************************************************************

include "mkl_vsl.f90"

module onemkl_vsl_omp_variant
  use MKL_VSL_TYPE

  !++
  !  VSL CONTINUOUS DISTRIBUTION GENERATOR FUNCTION INTERFACES.
  !--

  ! Uniform distribution
  interface
     integer function mkl_vsl_vsrnguniform_omp_offload (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnguniform_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnguniform_omp_offload (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnguniform_omp_offload
  end interface

  ! Gaussian distribution
  interface
     integer function mkl_vsl_vsrnggaussian_omp_offload (method, stream, n, r, a, sigma, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggaussian_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnggaussian_omp_offload (method, stream, n, r, a, sigma, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggaussian_omp_offload
  end interface

  ! GaussianMV distribution
  interface
     integer function mkl_vsl_vsrnggaussianmv_omp_offload (method, stream, n, r, dimen, mstorage, a, t, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=4),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=4),intent(in)  :: a(dimen)
       real(kind=4),intent(in)  :: t(dimen,dimen)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggaussianmv_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnggaussianmv_omp_offload (method, stream, n, r, dimen, mstorage, a, t, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=8),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=8),intent(in)  :: a(dimen)
       real(kind=8),intent(in)  :: t(dimen,dimen)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggaussianmv_omp_offload
  end interface

  ! Multinomial distribution
  interface
     integer function mkl_vsl_virngmultinomial_omp_offload (method, stream, n, r, ntrial, k, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer, intent(in)         :: ntrial
       integer, intent(in)         :: k
       real(kind=8),intent(in)     :: p(k)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngmultinomial_omp_offload
  end interface

  ! PoissonV distribution
  interface
     integer function mkl_vsl_virngpoissonv_omp_offload (method, stream, n, r, lambda, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngpoissonv_omp_offload
  end interface

  ! Exponential distribution
  interface
     integer function mkl_vsl_vsrngexponential_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngexponential_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngexponential_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngexponential_omp_offload
  end interface

  ! Laplace distribution
  interface
     integer function mkl_vsl_vsrnglaplace_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnglaplace_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnglaplace_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnglaplace_omp_offload
  end interface

  ! Weibull distribution
  interface
     integer function mkl_vsl_vsrngweibull_omp_offload (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngweibull_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngweibull_omp_offload (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngweibull_omp_offload
  end interface

  ! Cauchy distribution
  interface
     integer function mkl_vsl_vsrngcauchy_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngcauchy_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngcauchy_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngcauchy_omp_offload
  end interface

  ! Rayleigh distribution
  interface
     integer function mkl_vsl_vsrngrayleigh_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngrayleigh_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngrayleigh_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngrayleigh_omp_offload
  end interface

  ! Lognormal distribution
  interface
     integer function mkl_vsl_vsrnglognormal_omp_offload (method, stream, n, r, a, sigma, b, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       real(kind=4),intent(in)  :: b
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnglognormal_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnglognormal_omp_offload (method, stream, n, r, a, sigma, b, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       real(kind=8),intent(in)  :: b
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnglognormal_omp_offload
  end interface

  ! Gumbel distribution
  interface
     integer function mkl_vsl_vsrnggumbel_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggumbel_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnggumbel_omp_offload (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggumbel_omp_offload
  end interface

  ! Beta distribution
  interface
     integer function mkl_vsl_vsrngbeta_omp_offload (method, stream, n, r, p, q, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: p
       real(kind=4),intent(in)  :: q
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngbeta_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngbeta_omp_offload (method, stream, n, r, p, q, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: p
       real(kind=8),intent(in)  :: q
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngbeta_omp_offload
  end interface

  ! Gamma distribution
  interface
     integer function mkl_vsl_vsrnggamma_omp_offload (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggamma_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrnggamma_omp_offload (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggamma_omp_offload
  end interface

  ! ChiSquare distribution
  interface
     integer function mkl_vsl_vsrngchisquare_omp_offload (method, stream, n, r, v, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       integer,intent(in)       :: v
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngchisquare_omp_offload
  end interface

  interface
     integer function mkl_vsl_vdrngchisquare_omp_offload (method, stream, n, r, v, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       integer,intent(in)       :: v
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngchisquare_omp_offload
  end interface

!++
!  VSL DISCRETE DISTRIBUTION GENERATOR FUNCTION INTERFACES.
!--
  ! Uniform distribution
  interface
     integer function mkl_vsl_virnguniform_omp_offload (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: a
       integer(kind=4),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniform_omp_offload
  end interface

  ! UniformBits distribution
  interface
     integer function mkl_vsl_virnguniformbits_omp_offload (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits_omp_offload
  end interface

  ! UniformBits32 distribution
  interface
     integer function mkl_vsl_virnguniformbits32_omp_offload (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits32_omp_offload
  end interface

  ! UniformBits64 distribution
  interface
     integer function mkl_vsl_virnguniformbits64_omp_offload (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=8),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits64_omp_offload
  end interface

  ! Bernoulli distribution
  interface
     integer function mkl_vsl_virngbernoulli_omp_offload (method, stream, n, r, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngbernoulli_omp_offload
  end interface

  ! Geometric distribution
  interface
     integer function mkl_vsl_virnggeometric_omp_offload (method, stream, n, r, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnggeometric_omp_offload
  end interface

  ! Hypergeometric distribution
  interface
     integer function mkl_vsl_virnghypergeometric_omp_offload (method, stream, n, r, l, s, m, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: l
       integer(kind=4),intent(in)  :: s
       integer(kind=4),intent(in)  :: m
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnghypergeometric_omp_offload
  end interface

  ! Binomial distribution
  interface
     integer function mkl_vsl_virngbinomial_omp_offload (method, stream, n, r, ntrial, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: ntrial
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngbinomial_omp_offload
  end interface

  ! Negbinomial distribution
  interface
     integer function mkl_vsl_virngnegbinomial_omp_offload (method, stream, n, r, a, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: a
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngnegbinomial_omp_offload
  end interface

  ! Poisson distribution
  interface
     integer function mkl_vsl_virngpoisson_omp_offload (method, stream, n, r, lambda, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngpoisson_omp_offload
  end interface


  !++
  !  SUMMARY STATISTICS LIBRARY ROUTINES
  !--

  !  Compute routines
  interface
    integer function mkl_vsl_dsscompute_omp_offload(task, estimates, method, interop) BIND(C)
       use,intrinsic :: iso_c_binding
          import :: VSL_SS_TASK
          type(VSL_SS_TASK)            :: task
          integer(kind=8),intent(in)   :: estimates
          integer,intent(in)           :: method
          type(c_ptr),intent(in),value :: interop
    end function mkl_vsl_dsscompute_omp_offload
  end interface

  interface
    integer function mkl_vsl_ssscompute_omp_offload(task, estimates, method, interop) BIND(C)
       use,intrinsic :: iso_c_binding
          import :: VSL_SS_TASK
          type(VSL_SS_TASK)            :: task
          integer(kind=8),intent(in)   :: estimates
          integer,intent(in)           :: method
          type(c_ptr),intent(in),value :: interop
    end function mkl_vsl_ssscompute_omp_offload
  end interface

end module onemkl_vsl_omp_variant


module onemkl_vsl_omp_variant_lp64
  use MKL_VSL_TYPE

  !++
  !  VSL CONTINUOUS DISTRIBUTION GENERATOR FUNCTION INTERFACES.
  !--

  ! Uniform distribution
  interface
     integer function mkl_vsl_vsrnguniform_omp_offload_lp64 (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnguniform_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnguniform_omp_offload_lp64 (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnguniform_omp_offload_lp64
  end interface

  ! Gaussian distribution
  interface
     integer function mkl_vsl_vsrnggaussian_omp_offload_lp64 (method, stream, n, r, a, sigma, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggaussian_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnggaussian_omp_offload_lp64 (method, stream, n, r, a, sigma, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggaussian_omp_offload_lp64
  end interface

  ! GaussianMV distribution
  interface
     integer function mkl_vsl_vsrnggaussianmv_omp_offload_lp64 (method, stream, n, r, dimen, mstorage, a, t, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=4),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=4),intent(in)  :: a(dimen)
       real(kind=4),intent(in)  :: t(dimen,dimen)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggaussianmv_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnggaussianmv_omp_offload_lp64 (method, stream, n, r, dimen, mstorage, a, t, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=8),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=8),intent(in)  :: a(dimen)
       real(kind=8),intent(in)  :: t(dimen,dimen)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggaussianmv_omp_offload_lp64
  end interface

  ! Multinomial distribution
  interface
     integer function mkl_vsl_virngmultinomial_omp_offload_lp64 (method, stream, n, r, ntrial, k, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer, intent(in)         :: ntrial
       integer, intent(in)         :: k
       real(kind=8),intent(in)     :: p(k)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngmultinomial_omp_offload_lp64
  end interface

  ! PoissonV distribution
  interface
     integer function mkl_vsl_virngpoissonv_omp_offload_lp64 (method, stream, n, r, lambda, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngpoissonv_omp_offload_lp64
  end interface

  ! Exponential distribution
  interface
     integer function mkl_vsl_vsrngexponential_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngexponential_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngexponential_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngexponential_omp_offload_lp64
  end interface

  ! Laplace distribution
  interface
     integer function mkl_vsl_vsrnglaplace_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnglaplace_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnglaplace_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnglaplace_omp_offload_lp64
  end interface

  ! Weibull distribution
  interface
     integer function mkl_vsl_vsrngweibull_omp_offload_lp64 (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngweibull_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngweibull_omp_offload_lp64 (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngweibull_omp_offload_lp64
  end interface

  ! Cauchy distribution
  interface
     integer function mkl_vsl_vsrngcauchy_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngcauchy_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngcauchy_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngcauchy_omp_offload_lp64
  end interface

  ! Rayleigh distribution
  interface
     integer function mkl_vsl_vsrngrayleigh_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngrayleigh_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngrayleigh_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngrayleigh_omp_offload_lp64
  end interface

  ! Lognormal distribution
  interface
     integer function mkl_vsl_vsrnglognormal_omp_offload_lp64 (method, stream, n, r, a, sigma, b, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       real(kind=4),intent(in)  :: b
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnglognormal_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnglognormal_omp_offload_lp64 (method, stream, n, r, a, sigma, b, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       real(kind=8),intent(in)  :: b
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnglognormal_omp_offload_lp64
  end interface

  ! Gumbel distribution
  interface
     integer function mkl_vsl_vsrnggumbel_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggumbel_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnggumbel_omp_offload_lp64 (method, stream, n, r, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggumbel_omp_offload_lp64
  end interface

  ! Beta distribution
  interface
     integer function mkl_vsl_vsrngbeta_omp_offload_lp64 (method, stream, n, r, p, q, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: p
       real(kind=4),intent(in)  :: q
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngbeta_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngbeta_omp_offload_lp64 (method, stream, n, r, p, q, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: p
       real(kind=8),intent(in)  :: q
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngbeta_omp_offload_lp64
  end interface

  ! Gamma distribution
  interface
     integer function mkl_vsl_vsrnggamma_omp_offload_lp64 (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrnggamma_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrnggamma_omp_offload_lp64 (method, stream, n, r, alpha, a, beta, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrnggamma_omp_offload_lp64
  end interface

  ! ChiSquare distribution
  interface
     integer function mkl_vsl_vsrngchisquare_omp_offload_lp64 (method, stream, n, r, v, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       integer,intent(in)       :: v
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vsrngchisquare_omp_offload_lp64
  end interface

  interface
     integer function mkl_vsl_vdrngchisquare_omp_offload_lp64 (method, stream, n, r, v, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       integer,intent(in)       :: v
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_vdrngchisquare_omp_offload_lp64
  end interface

!++
!  VSL DISCRETE DISTRIBUTION GENERATOR FUNCTION INTERFACES.
!--
  ! Uniform distribution
  interface
     integer function mkl_vsl_virnguniform_omp_offload_lp64 (method, stream, n, r, a, b, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: a
       integer(kind=4),intent(in)  :: b
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniform_omp_offload_lp64
  end interface

  ! UniformBits distribution
  interface
     integer function mkl_vsl_virnguniformbits_omp_offload_lp64 (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits_omp_offload_lp64
  end interface

  ! UniformBits32 distribution
  interface
     integer function mkl_vsl_virnguniformbits32_omp_offload_lp64 (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits32_omp_offload_lp64
  end interface

  ! UniformBits64 distribution
  interface
     integer function mkl_vsl_virnguniformbits64_omp_offload_lp64 (method, stream, n, r, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=8),intent(out) :: r(n)
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnguniformbits64_omp_offload_lp64
  end interface

  ! Bernoulli distribution
  interface
     integer function mkl_vsl_virngbernoulli_omp_offload_lp64 (method, stream, n, r, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngbernoulli_omp_offload_lp64
  end interface

  ! Geometric distribution
  interface
     integer function mkl_vsl_virnggeometric_omp_offload_lp64 (method, stream, n, r, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnggeometric_omp_offload_lp64
  end interface

  ! Hypergeometric distribution
  interface
     integer function mkl_vsl_virnghypergeometric_omp_offload_lp64 (method, stream, n, r, l, s, m, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: l
       integer(kind=4),intent(in)  :: s
       integer(kind=4),intent(in)  :: m
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virnghypergeometric_omp_offload_lp64
  end interface

  ! Binomial distribution
  interface
     integer function mkl_vsl_virngbinomial_omp_offload_lp64 (method, stream, n, r, ntrial, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: ntrial
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngbinomial_omp_offload_lp64
  end interface

  ! Negbinomial distribution
  interface
     integer function mkl_vsl_virngnegbinomial_omp_offload_lp64 (method, stream, n, r, a, p, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: a
       real(kind=8),intent(in)     :: p
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngnegbinomial_omp_offload_lp64
  end interface

  ! Poisson distribution
  interface
     integer function mkl_vsl_virngpoisson_omp_offload_lp64 (method, stream, n, r, lambda, interop) BIND(C)
       use,intrinsic :: iso_c_binding
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda
       type(c_ptr),intent(in),value :: interop
     end function mkl_vsl_virngpoisson_omp_offload_lp64
  end interface

  !++
  !  SUMMARY STATISTICS LIBRARY ROUTINES
  !--

  !  Compute routines
  interface
    integer function mkl_vsl_dsscompute_omp_offload_lp64(task, estimates, method, interop) BIND(C)
       use,intrinsic :: iso_c_binding
          import :: VSL_SS_TASK
          type(VSL_SS_TASK)            :: task
          integer(kind=8),intent(in)   :: estimates
          integer,intent(in)           :: method
          type(c_ptr),intent(in),value :: interop
    end function mkl_vsl_dsscompute_omp_offload_lp64
  end interface

  interface
    integer function mkl_vsl_ssscompute_omp_offload_lp64(task, estimates, method, interop) BIND(C)
       use,intrinsic :: iso_c_binding
          import :: VSL_SS_TASK
          type(VSL_SS_TASK)            :: task
          integer(kind=8),intent(in)   :: estimates
          integer,intent(in)           :: method
          type(c_ptr),intent(in),value :: interop
    end function mkl_vsl_ssscompute_omp_offload_lp64
  end interface
end module onemkl_vsl_omp_variant_lp64

!===============================================================================
! Copyright (C) 2018 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!
!   Content:
!           Intel(R) oneAPI Math Kernel Library (oneMKL) Sparse QR FORTRAN header file
!
!           Contains interface to: MKL_SPARSE_X_QR
!                                  MKL_SPARSE_QR_REORDER
!                                  MKL_SPARSE_X_QR_FACTORIZE
!                                  MKL_SPARSE_X_QR_SOLVE
!                                  MKL_SPARSE_X_QR_QMULT
!                                  MKL_SPARSE_X_QR_RSOLVE
!                                  MKL_SPARSE_SET_QR_HINT
!
!===============================================================================

MODULE MKL_SPARSE_QR

    USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INTPTR_T, C_INT
    USE MKL_SPBLAS, ONLY : SPARSE_MATRIX_T, MATRIX_DESCR

    ENUM, BIND(C)
        ENUMERATOR :: SPARSE_QR_WITH_PIVOTS
    END ENUM

    INTERFACE

    FUNCTION MKL_SPARSE_SET_QR_HINT(A, HINT) &
        BIND(C, name='MKL_SPARSE_SET_QR_HINT')
        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT) :: A
        INTEGER(C_INT)       , INTENT(IN)    :: HINT
        INTEGER(C_INT) MKL_SPARSE_SET_QR_HINT
    END FUNCTION

    FUNCTION MKL_SPARSE_D_QR(operation, A, descr, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_D_QR')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        TYPE(MATRIX_DESCR)   , INTENT(IN)               :: descr
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_DOUBLE)       , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_DOUBLE)       , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_D_QR
    END FUNCTION

    FUNCTION MKL_SPARSE_S_QR(operation,A,descr, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_S_QR')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_FLOAT
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        TYPE(MATRIX_DESCR)   , INTENT(IN)               :: descr
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_FLOAT)        , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_FLOAT)        , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_S_QR
    END FUNCTION

    FUNCTION MKL_SPARSE_QR_REORDER(A, descr) &
        BIND(C, name='MKL_SPARSE_QR_REORDER')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        TYPE(MATRIX_DESCR)   , INTENT(IN)               :: descr

        INTEGER(C_INT) MKL_SPARSE_QR_REORDER
    END FUNCTION

    FUNCTION MKL_SPARSE_D_QR_FACTORIZE(A, alt_values) &
        BIND(C, name='MKL_SPARSE_D_QR_FACTORIZE')
        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        REAL(C_DOUBLE)       , INTENT(IN) , DIMENSION(*):: alt_values

        INTEGER(C_INT) MKL_SPARSE_D_QR_FACTORIZE
    END FUNCTION

    FUNCTION MKL_SPARSE_S_QR_FACTORIZE(A, alt_values) &
        BIND(C, name='MKL_SPARSE_S_QR_FACTORIZE')
        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_FLOAT
        IMPORT SPARSE_MATRIX_T
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        REAL(C_FLOAT)        , INTENT(IN) , DIMENSION(*):: alt_values

        INTEGER(C_INT) MKL_SPARSE_S_QR_FACTORIZE
    END FUNCTION

    FUNCTION MKL_SPARSE_D_QR_SOLVE(operation, A, alt_values, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_D_QR_SOLVE')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        REAL(C_DOUBLE)       , INTENT(OUT), DIMENSION(*):: alt_values
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_DOUBLE)       , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_DOUBLE)       , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_D_QR_SOLVE
    END FUNCTION

    FUNCTION MKL_SPARSE_S_QR_SOLVE(operation, A, alt_values, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_S_QR_SOLVE')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_FLOAT
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        REAL(C_FLOAT)        , INTENT(OUT), DIMENSION(*):: alt_values
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_FLOAT)        , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_FLOAT)        , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_S_QR_SOLVE
    END FUNCTION

    FUNCTION MKL_SPARSE_D_QR_QMULT(operation, A, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_D_QR_QMULT')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_DOUBLE)       , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_DOUBLE)       , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_D_QR_QMULT
    END FUNCTION

    FUNCTION MKL_SPARSE_S_QR_QMULT(operation, A, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_S_QR_QMULT')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_FLOAT
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_FLOAT)        , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_FLOAT)        , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_S_QR_QMULT
    END FUNCTION

    FUNCTION MKL_SPARSE_D_QR_RSOLVE(operation, A, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_D_QR_RSOLVE')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_DOUBLE
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_DOUBLE)       , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_DOUBLE)       , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_D_QR_RSOLVE
    END FUNCTION

    FUNCTION MKL_SPARSE_S_QR_RSOLVE(operation, A, layout, columns, x, ldx, b, ldb) &
        BIND(C, name='MKL_SPARSE_S_QR_RSOLVE')

        USE, INTRINSIC :: ISO_C_BINDING , ONLY : C_INT, C_FLOAT
        IMPORT SPARSE_MATRIX_T
        IMPORT MATRIX_DESCR
        INTEGER(C_INT)       , INTENT(IN)               :: operation
        TYPE(SPARSE_MATRIX_T), INTENT(INOUT)            :: A
        INTEGER(C_INT)       , INTENT(IN)               :: layout
        INTEGER              , INTENT(IN)               :: columns
        REAL(C_FLOAT)        , INTENT(OUT), DIMENSION(*):: x
        INTEGER              , INTENT(IN)               :: ldx
        REAL(C_FLOAT)        , INTENT(IN) , DIMENSION(*):: b
        INTEGER              , INTENT(IN)               :: ldb

        INTEGER(C_INT) MKL_SPARSE_S_QR_RSOLVE
    END FUNCTION

    END INTERFACE

END MODULE

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      Intel(R) oneAPI Math Kernel Library (oneMKL) FORTRAN interface for BLAS
!      OpenMP offload
!*******************************************************************************

module onemkl_blas_omp_offload_lp64

  include "mkl_blas_omp_variant_lp64.f90"

  interface

     ! Matrix transposition and copy API

     subroutine mkl_simatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, ab, lda, ldb, stride, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       real,intent(in)                :: alpha
       real,intent(inout)             :: ab( * )
       !$omp  declare variant( mkl_simatcopy_batch_strided:mkl_blas_simatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab)
     end subroutine mkl_simatcopy_batch_strided

     subroutine mkl_dimatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, ab, lda, ldb, stride, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       double precision,intent(in)    :: alpha
       double precision,intent(inout) :: ab( * )
       !$omp  declare variant( mkl_dimatcopy_batch_strided:mkl_blas_dimatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab)
     end subroutine mkl_dimatcopy_batch_strided

     subroutine mkl_cimatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, ab, lda, ldb, stride, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       complex,intent(in)             :: alpha
       complex,intent(inout)          :: ab( * )
       !$omp  declare variant( mkl_cimatcopy_batch_strided:mkl_blas_cimatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab)
     end subroutine mkl_cimatcopy_batch_strided

     subroutine mkl_zimatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, ab, lda, ldb, stride, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       complex*16,intent(in)          :: alpha
       complex*16,intent(inout)       :: ab( * )
       !$omp  declare variant( mkl_zimatcopy_batch_strided:mkl_blas_zimatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab)
     end subroutine mkl_zimatcopy_batch_strided

     subroutine mkl_somatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       real,intent(in)                :: alpha
       real,intent(in)                :: a( lda, * )
       real,intent(inout)             :: b( ldb, * )
       !$omp  declare variant( mkl_somatcopy_batch_strided:mkl_blas_somatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine mkl_somatcopy_batch_strided

     subroutine mkl_domatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       double precision,intent(in)    :: alpha
       double precision,intent(in)    :: a( lda, * )
       double precision,intent(inout) :: b( ldb, * )
       !$omp  declare variant( mkl_domatcopy_batch_strided:mkl_blas_domatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine mkl_domatcopy_batch_strided

     subroutine mkl_comatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       complex,intent(in)             :: alpha
       complex,intent(in)             :: a( lda, * )
       complex,intent(inout)          :: b( ldb, * )
       !$omp  declare variant( mkl_comatcopy_batch_strided:mkl_blas_comatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine mkl_comatcopy_batch_strided

     subroutine mkl_zomatcopy_batch_strided ( ordering, trans, rows,          &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       complex*16,intent(in)          :: alpha
       complex*16,intent(in)          :: a( lda, * )
       complex*16,intent(inout)       :: b( ldb, * )
       !$omp  declare variant( mkl_zomatcopy_batch_strided:mkl_blas_zomatcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine mkl_zomatcopy_batch_strided

     subroutine mkl_somatadd_batch_strided ( ordering, transa, transb, rows,      &
          &cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc,           &
          &stridec, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       real,intent(in)                :: alpha, beta
       real,intent(in)                :: a( lda, * )
       real,intent(in)                :: b( ldb, * )
       real,intent(inout)             :: c( ldc, * )
       !$omp  declare variant( mkl_somatadd_batch_strided:mkl_blas_somatadd_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine mkl_somatadd_batch_strided

     subroutine mkl_domatadd_batch_strided ( ordering, transa, transb, rows,      &
          &cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc,           &
          &stridec, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       double precision,intent(in)    :: alpha, beta
       double precision,intent(in)    :: a( lda, * )
       double precision,intent(in)    :: b( ldb, * )
       double precision,intent(inout) :: c( ldc, * )
       !$omp  declare variant( mkl_domatadd_batch_strided:mkl_blas_domatadd_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine mkl_domatadd_batch_strided

     subroutine mkl_comatadd_batch_strided ( ordering, transa, transb, rows,      &
          &cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc,           &
          &stridec, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       complex,intent(in)             :: alpha, beta
       complex,intent(in)             :: a( lda, * )
       complex,intent(in)             :: b( ldb, * )
       complex,intent(inout)          :: c( ldc, * )
       !$omp  declare variant( mkl_comatadd_batch_strided:mkl_blas_comatadd_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine mkl_comatadd_batch_strided

     subroutine mkl_zomatadd_batch_strided ( ordering, transa, transb, rows,      &
          &cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc,           &
          &stridec, batch_size ) BIND(C)
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       complex*16,intent(in)          :: alpha, beta
       complex*16,intent(in)          :: a( lda, * )
       complex*16,intent(in)          :: b( ldb, * )
       complex*16,intent(inout)       :: c( ldc, * )
       !$omp  declare variant( mkl_zomatadd_batch_strided:mkl_blas_zomatadd_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine mkl_zomatadd_batch_strided

     subroutine mkl_simatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       real,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       !$omp  declare variant( mkl_simatcopy_batch:mkl_blas_simatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab_array)
     end subroutine mkl_simatcopy_batch

     subroutine mkl_dimatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       double precision,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       !$omp  declare variant( mkl_dimatcopy_batch:mkl_blas_dimatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab_array)
     end subroutine mkl_dimatcopy_batch

     subroutine mkl_cimatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       !$omp  declare variant( mkl_cimatcopy_batch:mkl_blas_cimatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab_array)
     end subroutine mkl_cimatcopy_batch

     subroutine mkl_zimatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex*16,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       !$omp  declare variant( mkl_zimatcopy_batch:mkl_blas_zimatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:ab_array)
     end subroutine mkl_zimatcopy_batch

     subroutine mkl_somatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       real,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       !$omp  declare variant( mkl_somatcopy_batch:mkl_blas_somatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a_array,b_array)
     end subroutine mkl_somatcopy_batch

     subroutine mkl_domatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       double precision,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       !$omp  declare variant( mkl_domatcopy_batch:mkl_blas_domatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a_array,b_array)
     end subroutine mkl_domatcopy_batch

     subroutine mkl_comatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       !$omp  declare variant( mkl_comatcopy_batch:mkl_blas_comatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a_array,b_array)
     end subroutine mkl_comatcopy_batch

     subroutine mkl_zomatcopy_batch ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex*16,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       !$omp  declare variant( mkl_zomatcopy_batch:mkl_blas_zomatcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a_array,b_array)
     end subroutine mkl_zomatcopy_batch

     ! BLAS Level3

     subroutine dgemm ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp declare variant( dgemm:mkl_blas_dgemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dgemm

     subroutine sgemm ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( sgemm:mkl_blas_sgemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine sgemm

     subroutine zgemm ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zgemm:mkl_blas_zgemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm

     subroutine cgemm ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cgemm:mkl_blas_cgemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm

     subroutine zgemm3m ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zgemm3m:mkl_blas_zgemm3m_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm3m

     subroutine cgemm3m ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cgemm3m:mkl_blas_cgemm3m_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm3m
     
     subroutine gemm_s8u8s32 ( transa, transb, offsetc, m, n, k,       &
          &alpha, a, lda, ao, b, ldb, bo, beta, c, ldc, co ) BIND(C)
       character*1,intent(in)          :: transa, transb, offsetc
       integer,intent(in)              :: m, n, k, lda, ldb, ldc
       integer*1,intent(in)            :: ao, bo
       real,intent(in)                 :: alpha, beta
       integer*1,intent(in)            :: a( lda, * ), b (ldb, * )
       integer*4,intent(inout)         :: c( ldc, * )
       integer*4,intent(in)            :: co( * )
       !$omp  declare variant( gemm_s8u8s32:mkl_blas_gemm_s8u8s32_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c,co)
     end subroutine gemm_s8u8s32

     subroutine dsymm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dsymm:mkl_blas_dsymm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dsymm

     subroutine ssymm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( ssymm:mkl_blas_ssymm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ssymm

     subroutine zsymm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zsymm:mkl_blas_zsymm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zsymm

     subroutine csymm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( csymm:mkl_blas_csymm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine csymm

     subroutine zhemm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zhemm:mkl_blas_zhemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zhemm

     subroutine chemm ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( chemm:mkl_blas_chemm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine chemm

     subroutine dsyrk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dsyrk:mkl_blas_dsyrk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine dsyrk

     subroutine ssyrk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( ssyrk:mkl_blas_ssyrk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine ssyrk

     subroutine zsyrk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zsyrk:mkl_blas_zsyrk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine zsyrk

     subroutine csyrk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( csyrk:mkl_blas_csyrk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine csyrk

     subroutine zherk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       double precision,intent(in)        :: alpha, beta
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zherk:mkl_blas_zherk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine zherk

     subroutine cherk ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       real,intent(in)                     :: alpha, beta
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cherk:mkl_blas_cherk_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine cherk

     subroutine dsyr2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dsyr2k:mkl_blas_dsyr2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dsyr2k

     subroutine ssyr2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( ssyr2k:mkl_blas_ssyr2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ssyr2k

     subroutine zsyr2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zsyr2k:mkl_blas_zsyr2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zsyr2k

     subroutine csyr2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( csyr2k:mkl_blas_csyr2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine csyr2k

     subroutine zher2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       double precision,intent(in)        :: beta
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zher2k:mkl_blas_zher2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zher2k

     subroutine cher2k ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       real,intent(in)                     :: beta
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cher2k:mkl_blas_cher2k_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cher2k

     subroutine dtrmm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       !$omp  declare variant( dtrmm:mkl_blas_dtrmm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine dtrmm

     subroutine strmm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       !$omp  declare variant( strmm:mkl_blas_strmm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine strmm

     subroutine ztrmm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       !$omp  declare variant( ztrmm:mkl_blas_ztrmm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ztrmm

     subroutine ctrmm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       !$omp  declare variant( ctrmm:mkl_blas_ctrmm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ctrmm

     subroutine strmm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       real,intent(in)                    :: alpha, beta
       real,intent(in)                    :: a( lda, * ), b( ldb, * )
       real,intent(inout)                 :: c( ldc, * )
       !$omp  declare variant( strmm_oop:mkl_blas_strmm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine strmm_oop

     subroutine dtrmm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dtrmm_oop:mkl_blas_dtrmm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dtrmm_oop

     subroutine ctrmm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex,intent(in)                 :: alpha, beta
       complex,intent(in)                 :: a( lda, * ), b( ldb, * )
       complex,intent(inout)              :: c( ldc, * )
       !$omp  declare variant( ctrmm_oop:mkl_blas_ctrmm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ctrmm_oop

     subroutine ztrmm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( ztrmm_oop:mkl_blas_ztrmm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ztrmm_oop

     subroutine dtrsm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       !$omp  declare variant( dtrsm:mkl_blas_dtrsm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine dtrsm

     subroutine strsm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       !$omp  declare variant( strsm:mkl_blas_strsm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine strsm

     subroutine ztrsm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       !$omp  declare variant( ztrsm:mkl_blas_ztrsm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ztrsm

     subroutine ctrsm ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       !$omp  declare variant( ctrsm:mkl_blas_ctrsm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ctrsm

     subroutine strsm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       real,intent(in)                    :: alpha, beta
       real,intent(in)                    :: a( lda, * ), b( ldb, * )
       real,intent(inout)                 :: c( ldc, * )
       !$omp  declare variant( strsm_oop:mkl_blas_strsm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine strsm_oop

     subroutine dtrsm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dtrsm_oop:mkl_blas_dtrsm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dtrsm_oop

     subroutine ctrsm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex,intent(in)                 :: alpha, beta
       complex,intent(in)                 :: a( lda, * ), b( ldb, * )
       complex,intent(inout)              :: c( ldc, * )
       !$omp  declare variant( ctrsm_oop:mkl_blas_ctrsm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ctrsm_oop

     subroutine ztrsm_oop ( side, uplo, trans, diag, m, n, alpha, a, lda,    &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( ztrsm_oop:mkl_blas_ztrsm_oop_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine ztrsm_oop

     subroutine dgemmt ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, transa, transb
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dgemmt:mkl_blas_dgemmt_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dgemmt

     subroutine sgemmt ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, transa, transb
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( sgemmt:mkl_blas_sgemmt_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine sgemmt

     subroutine zgemmt ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)             :: uplo, transa, transb
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zgemmt:mkl_blas_zgemmt_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemmt

     subroutine cgemmt ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc ) BIND(C)
       character*1,intent(in)              :: uplo, transa, transb
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cgemmt:mkl_blas_cgemmt_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemmt

     ! BLAS Level2

     subroutine dgbmv ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dgbmv:mkl_blas_dgbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dgbmv

     subroutine sgbmv ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( sgbmv:mkl_blas_sgbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sgbmv

     subroutine zgbmv ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zgbmv:mkl_blas_zgbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgbmv

     subroutine cgbmv ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( cgbmv:mkl_blas_cgbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgbmv

     subroutine dgemv ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dgemv:mkl_blas_dgemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dgemv

     subroutine sgemv ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( sgemv:mkl_blas_sgemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sgemv

     subroutine zgemv ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zgemv:mkl_blas_zgemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgemv

     subroutine cgemv ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( cgemv:mkl_blas_cgemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgemv

     subroutine dsbmv ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dsbmv:mkl_blas_dsbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dsbmv

     subroutine ssbmv ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( ssbmv:mkl_blas_ssbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine ssbmv

     subroutine zhbmv ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zhbmv:mkl_blas_zhbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zhbmv

     subroutine chbmv ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( chbmv:mkl_blas_chbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine chbmv

     subroutine dsymv ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dsymv:mkl_blas_dsymv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dsymv

     subroutine ssymv ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( ssymv:mkl_blas_ssymv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine ssymv

     subroutine zhemv ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zhemv:mkl_blas_zhemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zhemv

     subroutine chemv ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( chemv:mkl_blas_chemv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine chemv

     subroutine dspmv ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dspmv:mkl_blas_dspmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dspmv

     subroutine sspmv ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( sspmv:mkl_blas_sspmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sspmv

     subroutine zhpmv ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zhpmv:mkl_blas_zhpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zhpmv

     subroutine chpmv ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( chpmv:mkl_blas_chpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine chpmv

     subroutine dger ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       double precision,intent(in)         :: y( * ), x( * )
       double precision,intent(inout)      :: a( lda, * )
       !$omp  declare variant( dger:mkl_blas_dger_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dger

     subroutine sger ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       real,intent(in)                     :: y( * ), x( * )
       real,intent(inout)                  :: a( lda, * )
       !$omp  declare variant( sger:mkl_blas_sger_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sger

     subroutine zgerc ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex*16,intent(in)               :: y( * ), x( * )
       complex*16,intent(inout)            :: a( lda, * )
       !$omp  declare variant( zgerc:mkl_blas_zgerc_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgerc

     subroutine cgerc ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex,intent(in)                  :: y( * ), x( * )
       complex,intent(inout)               :: a( lda, * )
       !$omp  declare variant( cgerc:mkl_blas_cgerc_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgerc

     subroutine zgeru ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex*16,intent(in)               :: y( * ), x( * )
       complex*16,intent(inout)            :: a( lda, * )
       !$omp  declare variant( zgeru:mkl_blas_zgeru_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgeru

     subroutine cgeru ( m, n, alpha, x, incx,   &
          &y, incy, a, lda ) BIND(C)
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex,intent(in)                  :: y( * ), x( * )
       complex,intent(inout)               :: a( lda, * )
       !$omp  declare variant( cgeru:mkl_blas_cgeru_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgeru

     subroutine dsyr ( uplo, n, alpha, x, incx,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, lda, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: a( lda, * )
       !$omp  declare variant( dsyr:mkl_blas_dsyr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dsyr

     subroutine ssyr ( uplo, n, alpha, x, incx,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, lda, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: a( lda, * )
       !$omp  declare variant( ssyr:mkl_blas_ssyr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ssyr

     subroutine zher ( uplo, n, alpha, x, incx,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, lda, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: a( lda, * )
       !$omp  declare variant( zher:mkl_blas_zher_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine zher

     subroutine cher ( uplo, n, alpha, x, incx,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, lda, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: a( lda, * )
       !$omp  declare variant( cher:mkl_blas_cher_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine cher

     subroutine dspr ( uplo, n, alpha, x, incx,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: a( * )
       !$omp  declare variant( dspr:mkl_blas_dspr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dspr

     subroutine sspr ( uplo, n, alpha, x, incx,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: a( * )
       !$omp  declare variant( sspr:mkl_blas_sspr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine sspr

     subroutine zhpr ( uplo, n, alpha, x, incx,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: a( * )
       !$omp  declare variant( zhpr:mkl_blas_zhpr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine zhpr

     subroutine chpr ( uplo, n, alpha, x, incx,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: a( * )
       !$omp  declare variant( chpr:mkl_blas_chpr_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine chpr

     subroutine dsyr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       double precision,intent(in)         :: x( * ), y( * )
       double precision,intent(inout)      :: a( lda, * )
       !$omp  declare variant( dsyr2:mkl_blas_dsyr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dsyr2

     subroutine ssyr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       real,intent(in)                     :: x( * ), y( * )
       real,intent(inout)                  :: a( lda, * )
       !$omp  declare variant( ssyr2:mkl_blas_ssyr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine ssyr2

     subroutine zher2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       complex*16,intent(in)               :: x( * ), y( * )
       complex*16,intent(inout)            :: a( lda, * )
       !$omp  declare variant( zher2:mkl_blas_zher2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zher2

     subroutine cher2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda ) BIND(C)
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       complex,intent(in)                  :: x( * ), y( * )
       complex,intent(inout)               :: a( lda, * )
       !$omp  declare variant( cher2:mkl_blas_cher2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cher2

     subroutine dspr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * ), y( * )
       double precision,intent(inout)      :: a( * )
       !$omp  declare variant( dspr2:mkl_blas_dspr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dspr2

     subroutine sspr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       real,intent(inout)                  :: a( * )
       !$omp  declare variant( sspr2:mkl_blas_sspr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sspr2

     subroutine zhpr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       complex*16,intent(inout)            :: a( * )
       !$omp  declare variant( zhpr2:mkl_blas_zhpr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zhpr2

     subroutine chpr2 ( uplo, n, alpha, x, incx, y, incy,   &
          &a ) BIND(C)
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       complex,intent(inout)               :: a( * )
       !$omp  declare variant( chpr2:mkl_blas_chpr2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine chpr2

     subroutine dtbmv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtbmv:mkl_blas_dtbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtbmv

     subroutine stbmv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( stbmv:mkl_blas_stbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine stbmv

     subroutine ztbmv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztbmv:mkl_blas_ztbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztbmv

     subroutine ctbmv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctbmv:mkl_blas_ctbmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctbmv

     subroutine dtrmv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtrmv:mkl_blas_dtrmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtrmv

     subroutine strmv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( strmv:mkl_blas_strmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine strmv

     subroutine ztrmv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztrmv:mkl_blas_ztrmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztrmv

     subroutine ctrmv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctrmv:mkl_blas_ctrmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctrmv

     subroutine dtpmv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtpmv:mkl_blas_dtpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtpmv

     subroutine stpmv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( stpmv:mkl_blas_stpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine stpmv

     subroutine ztpmv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztpmv:mkl_blas_ztpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztpmv

     subroutine ctpmv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctpmv:mkl_blas_ctpmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctpmv

     subroutine dtbsv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtbsv:mkl_blas_dtbsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtbsv

     subroutine stbsv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( stbsv:mkl_blas_stbsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine stbsv

     subroutine ztbsv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztbsv:mkl_blas_ztbsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztbsv

     subroutine ctbsv ( uplo, trans, diag, n, k, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctbsv:mkl_blas_ctbsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctbsv

     subroutine dtrsv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtrsv:mkl_blas_dtrsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtrsv

     subroutine strsv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( strsv:mkl_blas_strsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine strsv

     subroutine ztrsv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztrsv:mkl_blas_ztrsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztrsv

     subroutine ctrsv ( uplo, trans, diag, n, a, lda, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctrsv:mkl_blas_ctrsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctrsv

     subroutine dtpsv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( * )
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dtpsv:mkl_blas_dtpsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine dtpsv

     subroutine stpsv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( * )
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( stpsv:mkl_blas_stpsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine stpsv

     subroutine ztpsv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( * )
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( ztpsv:mkl_blas_ztpsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ztpsv

     subroutine ctpsv ( uplo, trans, diag, n, a, x, incx ) BIND(C)
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( * )
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( ctpsv:mkl_blas_ctpsv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x)
     end subroutine ctpsv

     ! BLAS Level1

     function dasum ( n, x, incx ) BIND(C)
       double precision                    :: dasum
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       !$omp  declare variant( dasum:mkl_blas_dasum_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function dasum

     function sasum ( n, x, incx ) BIND(C)
       real                                :: sasum
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       !$omp  declare variant( sasum:mkl_blas_sasum_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function sasum

     function dzasum ( n, x, incx ) BIND(C)
       double precision                    :: dzasum
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       !$omp  declare variant( dzasum:mkl_blas_dzasum_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function dzasum

     function scasum ( n, x, incx ) BIND(C)
       real                                :: scasum
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       !$omp  declare variant( scasum:mkl_blas_scasum_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function scasum

     function dnrm2 ( n, x, incx ) BIND(C)
       double precision                    :: dnrm2
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       !$omp  declare variant( dnrm2:mkl_blas_dnrm2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function dnrm2

     function snrm2 ( n, x, incx ) BIND(C)
       real                                :: snrm2
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       !$omp  declare variant( snrm2:mkl_blas_snrm2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function snrm2

     function dznrm2 ( n, x, incx ) BIND(C)
       double precision                    :: dznrm2
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       !$omp  declare variant( dznrm2:mkl_blas_dznrm2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function dznrm2

     function scnrm2 ( n, x, incx ) BIND(C)
       real                                :: scnrm2
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       !$omp  declare variant( scnrm2:mkl_blas_scnrm2_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function scnrm2

     subroutine daxpy ( n, alpha, x, incx,   &
          &y, incy ) BIND(C)
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( daxpy:mkl_blas_daxpy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine daxpy

     subroutine saxpy ( n, alpha, x, incx,   &
          &y, incy ) BIND(C)
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( saxpy:mkl_blas_saxpy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine saxpy

     subroutine zaxpy ( n, alpha, x, incx,   &
          &y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zaxpy:mkl_blas_zaxpy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zaxpy

     subroutine caxpy ( n, alpha, x, incx,   &
          &y, incy ) BIND(C)
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( caxpy:mkl_blas_caxpy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine caxpy

     subroutine daxpby ( n, alpha, x, incx,   &
          &beta, y, incy ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( daxpby:mkl_blas_daxpby_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine daxpby

     subroutine saxpby ( n, alpha, x, incx,   &
          &beta, y, incy ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( saxpby:mkl_blas_saxpby_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine saxpby

     subroutine zaxpby ( n, alpha, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zaxpby:mkl_blas_zaxpby_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zaxpby

     subroutine caxpby ( n, alpha, x, incx,   &
          &beta, y, incy ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( caxpby:mkl_blas_caxpby_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine caxpby

     subroutine dcopy ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dcopy:mkl_blas_dcopy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine dcopy

     subroutine scopy ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( scopy:mkl_blas_scopy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine scopy

     subroutine zcopy ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zcopy:mkl_blas_zcopy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zcopy

     subroutine ccopy ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( ccopy:mkl_blas_ccopy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine ccopy

     function ddot ( n, x, incx, y, incy ) BIND(C)
       double precision                    :: ddot
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * ), y( * )
       !$omp  declare variant( ddot:mkl_blas_ddot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function ddot

     function sdot ( n, x, incx, y, incy ) BIND(C)
       real                                :: sdot
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       !$omp  declare variant( sdot:mkl_blas_sdot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function sdot

     function dsdot ( n, x, incx, y, incy ) BIND(C)
       double precision                    :: dsdot
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       !$omp  declare variant( dsdot:mkl_blas_dsdot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function dsdot

     function sdsdot ( n, sb, x, incx, y, incy ) BIND(C)
       real                                :: sdsdot
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: sb, x( * ), y( * )
       !$omp  declare variant( sdsdot:mkl_blas_sdsdot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function sdsdot

     function zdotc ( n, x, incx, y, incy ) BIND(C, name="mkl_blas_zdotc_fbind_omp_offload_lp64")
       complex*16                          :: zdotc
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       !$omp  declare variant( zdotc:mkl_blas_zdotc_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function zdotc

     function cdotc ( n, x, incx, y, incy ) BIND(C, name="mkl_blas_cdotc_fbind_omp_offload_lp64")
       complex                             :: cdotc
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       !$omp  declare variant( cdotc:mkl_blas_cdotc_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function cdotc

     function zdotu ( n, x, incx, y, incy ) BIND(C, name="mkl_blas_zdotu_fbind_omp_offload_lp64")
       complex*16                          :: zdotu
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       !$omp  declare variant( zdotu:mkl_blas_zdotu_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function zdotu

     function cdotu ( n, x, incx, y, incy ) BIND(C, name="mkl_blas_cdotu_fbind_omp_offload_lp64")
       complex                             :: cdotu
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       !$omp  declare variant( cdotu:mkl_blas_cdotu_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end function cdotu

     subroutine drot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       double precision,intent(in)         :: c, s
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(inout)      :: x( * ), y( * )
       !$omp  declare variant( drot:mkl_blas_drot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine drot

     subroutine srot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       real,intent(in)                     :: c, s
       integer,intent(in)                  :: incx, incy, n
       real,intent(inout)                  :: x( * ), y( * )
       !$omp  declare variant( srot:mkl_blas_srot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine srot

     subroutine zdrot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       double precision,intent(in)         :: c, s
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       !$omp  declare variant( zdrot:mkl_blas_zdrot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zdrot

     subroutine zrot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       double precision,intent(in)         :: c
       complex*16, intent(in)              :: s
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       !$omp  declare variant( zrot:mkl_blas_zrot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zrot

     subroutine csrot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       real,intent(in)                     :: c, s
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       !$omp  declare variant( csrot:mkl_blas_csrot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine csrot

     subroutine crot ( n, x, incx,   &
          &y, incy, c, s ) BIND(C)
       real,intent(in)                     :: c
       complex, intent(in)                 :: s
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       !$omp  declare variant( crot:mkl_blas_crot_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine crot

     subroutine drotg( a, b, c, s ) BIND(C)
       double precision,intent(inout)      :: a( * ), b( * ), c( * ), s( * )
       !$omp  declare variant( drotg:mkl_blas_drotg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c,s)
     end subroutine drotg

     subroutine srotg( a, b, c, s ) BIND(C)
       real,intent(inout)                  :: a( * ), b( * ), c( * ), s( * )
       !$omp  declare variant( srotg:mkl_blas_srotg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c,s)
     end subroutine srotg

     subroutine zrotg( a, b, c, s ) BIND(C)
       complex*16,intent(inout)            :: a( * ), b( * ), s( * )
       double precision,intent(inout)      :: c( * )
       !$omp  declare variant( zrotg:mkl_blas_zrotg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c,s)
     end subroutine zrotg

     subroutine crotg( a, b, c, s ) BIND(C)
       complex,intent(inout)               :: a( * ), b( * ), s( * )
       real,intent(inout)                  :: c( * )
       !$omp  declare variant( crotg:mkl_blas_crotg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c,s)
     end subroutine crotg

     subroutine drotm ( n, x, incx,   &
          &y, incy, param ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: param( * )
       double precision,intent(inout)      :: x( * ), y( * )
       !$omp  declare variant( drotm:mkl_blas_drotm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y,param)
     end subroutine drotm

     subroutine srotm ( n, x, incx,   &
          &y, incy, param ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: param( * )
       real,intent(inout)                  :: x( * ), y( * )
       !$omp  declare variant( srotm:mkl_blas_srotm_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y,param)
     end subroutine srotm

     subroutine drotmg ( d1, d2, x1, x2, param ) BIND(C)
       double precision,intent(in)         :: x2
       double precision,intent(inout)      :: d1( * ), d2( * ), x1( * ), param( * )
       !$omp  declare variant( drotmg:mkl_blas_drotmg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:d1,d2,x1,param)
     end subroutine drotmg

     subroutine srotmg ( d1, d2, x1, x2, param ) BIND(C)
       real,intent(in)                     :: x2
       real,intent(inout)                  :: d1( * ), d2( * ), x1( * ), param( * )
       !$omp  declare variant( srotmg:mkl_blas_srotmg_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:d1,d2,x1,param)
     end subroutine srotmg

     subroutine dscal ( n, alpha, x, incx ) BIND(C)
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       double precision,intent(inout)      :: x( * )
       !$omp  declare variant( dscal:mkl_blas_dscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine dscal

     subroutine sscal ( n, alpha, x, incx ) BIND(C)
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       real,intent(inout)                  :: x( * )
       !$omp  declare variant( sscal:mkl_blas_sscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine sscal

     subroutine zscal ( n, alpha, x, incx ) BIND(C)
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( zscal:mkl_blas_zscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine zscal

     subroutine cscal ( n, alpha, x, incx ) BIND(C)
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( cscal:mkl_blas_cscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine cscal

     subroutine zdscal ( n, alpha, x, incx ) BIND(C)
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(inout)            :: x( * )
       !$omp  declare variant( zdscal:mkl_blas_zdscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine zdscal

     subroutine csscal ( n, alpha, x, incx ) BIND(C)
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(inout)               :: x( * )
       !$omp  declare variant( csscal:mkl_blas_csscal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end subroutine csscal

     subroutine dswap ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(inout)      :: x( * ), y( * )
       !$omp  declare variant( dswap:mkl_blas_dswap_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine dswap

     subroutine sswap ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       real,intent(inout)                  :: x( * ), y( * )
       !$omp  declare variant( sswap:mkl_blas_sswap_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine sswap

     subroutine zswap ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       !$omp  declare variant( zswap:mkl_blas_zswap_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zswap

     subroutine cswap ( n, x, incx,   &
          &y, incy ) BIND(C)
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       !$omp  declare variant( cswap:mkl_blas_cswap_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine cswap

     function idamax ( n, x, incx ) BIND(C)
       integer                             :: idamax
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       !$omp  declare variant( idamax:mkl_blas_idamax_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function idamax

     function isamax ( n, x, incx ) BIND(C)
       integer                             :: isamax
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       !$omp  declare variant( isamax:mkl_blas_isamax_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function isamax

     function izamax ( n, x, incx ) BIND(C)
       integer                             :: izamax
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       !$omp  declare variant( izamax:mkl_blas_izamax_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function izamax

     function icamax ( n, x, incx ) BIND(C)
       integer                             :: icamax
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       !$omp  declare variant( icamax:mkl_blas_icamax_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function icamax

     function idamin ( n, x, incx ) BIND(C)
       integer                             :: idamin
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       !$omp  declare variant( idamin:mkl_blas_idamin_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function idamin

     function isamin ( n, x, incx ) BIND(C)
       integer                             :: isamin
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       !$omp  declare variant( isamin:mkl_blas_isamin_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function isamin

     function izamin ( n, x, incx ) BIND(C)
       integer                             :: izamin
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       !$omp  declare variant( izamin:mkl_blas_izamin_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function izamin

     function icamin ( n, x, incx ) BIND(C)
       integer                             :: icamin
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       !$omp  declare variant( icamin:mkl_blas_icamin_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x)
     end function icamin

     ! BLAS batch

     subroutine dtrsm_batch_strided ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, stridea, ldb, strideb, batch_size
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       !$omp  declare variant( dtrsm_batch_strided:mkl_blas_dtrsm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine dtrsm_batch_strided

     subroutine strsm_batch_strided ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, stridea, ldb, strideb, batch_size
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       !$omp  declare variant( strsm_batch_strided:mkl_blas_strsm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine strsm_batch_strided

     subroutine ztrsm_batch_strided ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, stridea, ldb, strideb, batch_size
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       !$omp  declare variant( ztrsm_batch_strided:mkl_blas_ztrsm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ztrsm_batch_strided

     subroutine ctrsm_batch_strided ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size ) BIND(C)
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, stridea, ldb, strideb, batch_size
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       !$omp  declare variant( ctrsm_batch_strided:mkl_blas_ctrsm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ctrsm_batch_strided

     subroutine ssyrk_batch_strided ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( ssyrk_batch_strided:mkl_blas_ssyrk_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine ssyrk_batch_strided

     subroutine dsyrk_batch_strided ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       double precision,intent(in)         :: alpha, beta
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: c( ldc, * )
       !$omp  declare variant( dsyrk_batch_strided:mkl_blas_dsyrk_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine dsyrk_batch_strided

     subroutine csyrk_batch_strided ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( csyrk_batch_strided:mkl_blas_csyrk_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine csyrk_batch_strided

     subroutine zsyrk_batch_strided ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       complex*16,intent(in)               :: alpha, beta
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: c( ldc, * )
       !$omp  declare variant( zsyrk_batch_strided:mkl_blas_zsyrk_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine zsyrk_batch_strided

     subroutine dgemm_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       !$omp  declare variant( dgemm_batch_strided:mkl_blas_dgemm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dgemm_batch_strided

     subroutine sgemm_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( sgemm_batch_strided:mkl_blas_sgemm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine sgemm_batch_strided

     subroutine zgemm_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zgemm_batch_strided:mkl_blas_zgemm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm_batch_strided

     subroutine cgemm_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cgemm_batch_strided:mkl_blas_cgemm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm_batch_strided

     subroutine zgemm3m_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       !$omp  declare variant( zgemm3m_batch_strided:mkl_blas_zgemm3m_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm3m_batch_strided

     subroutine cgemm3m_batch_strided ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size ) BIND(C)
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cgemm3m_batch_strided:mkl_blas_cgemm3m_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm3m_batch_strided
     
    subroutine daxpy_batch_strided ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( daxpy_batch_strided:mkl_blas_daxpy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine daxpy_batch_strided

     subroutine saxpy_batch_strided ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( saxpy_batch_strided:mkl_blas_saxpy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine saxpy_batch_strided

     subroutine zaxpy_batch_strided ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zaxpy_batch_strided:mkl_blas_zaxpy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zaxpy_batch_strided

     subroutine caxpy_batch_strided ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( caxpy_batch_strided:mkl_blas_caxpy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine caxpy_batch_strided

     subroutine scopy_batch_strided ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( scopy_batch_strided:mkl_blas_scopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine scopy_batch_strided

     subroutine dcopy_batch_strided ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dcopy_batch_strided:mkl_blas_dcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine dcopy_batch_strided

     subroutine ccopy_batch_strided ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( ccopy_batch_strided:mkl_blas_ccopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine ccopy_batch_strided

     subroutine zcopy_batch_strided ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zcopy_batch_strided:mkl_blas_zcopy_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x,y)
     end subroutine zcopy_batch_strided

     subroutine dgemv_batch_strided ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size ) BIND(C)
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       !$omp  declare variant( dgemv_batch_strided:mkl_blas_dgemv_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dgemv_batch_strided

     subroutine sgemv_batch_strided ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size ) BIND(C)
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       !$omp  declare variant( sgemv_batch_strided:mkl_blas_sgemv_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sgemv_batch_strided

     subroutine zgemv_batch_strided ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size ) BIND(C)
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       !$omp  declare variant( zgemv_batch_strided:mkl_blas_zgemv_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgemv_batch_strided

     subroutine cgemv_batch_strided ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size ) BIND(C)
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       !$omp  declare variant( cgemv_batch_strided:mkl_blas_cgemv_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgemv_batch_strided

     subroutine ddgmm_batch_strided ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: c( ldc, * )
       !$omp  declare variant( ddgmm_batch_strided:mkl_blas_ddgmm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine ddgmm_batch_strided

     subroutine sdgmm_batch_strided ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: c( ldc, * )
       !$omp  declare variant( sdgmm_batch_strided:mkl_blas_sdgmm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine sdgmm_batch_strided

     subroutine zdgmm_batch_strided ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: c( ldc, * )
       !$omp  declare variant( zdgmm_batch_strided:mkl_blas_zdgmm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine zdgmm_batch_strided

     subroutine cdgmm_batch_strided ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size ) BIND(C)
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: c( ldc, * )
       !$omp  declare variant( cdgmm_batch_strided:mkl_blas_cdgmm_batch_strided_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine cdgmm_batch_strided

     subroutine daxpy_batch(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       double precision,intent(in)             :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( daxpy_batch:mkl_blas_daxpy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine daxpy_batch

     subroutine saxpy_batch(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       real,intent(in)                         :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( saxpy_batch:mkl_blas_saxpy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine saxpy_batch

     subroutine zaxpy_batch(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       complex*16,intent(in)                   :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( zaxpy_batch:mkl_blas_zaxpy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine zaxpy_batch

     subroutine caxpy_batch(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       complex,intent(in)                      :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( caxpy_batch:mkl_blas_caxpy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine caxpy_batch

     subroutine scopy_batch(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( scopy_batch:mkl_blas_scopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine scopy_batch

     subroutine dcopy_batch(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( dcopy_batch:mkl_blas_dcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine dcopy_batch

     subroutine ccopy_batch(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( ccopy_batch:mkl_blas_ccopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine ccopy_batch

     subroutine zcopy_batch(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       !$omp  declare variant( zcopy_batch:mkl_blas_zcopy_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:x_array,y_array)
     end subroutine zcopy_batch

     subroutine dtrsm_batch ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       !$omp  declare variant( dtrsm_batch:mkl_blas_dtrsm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine dtrsm_batch

     subroutine strsm_batch ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       !$omp  declare variant( strsm_batch:mkl_blas_strsm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine strsm_batch

     subroutine ztrsm_batch ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       !$omp  declare variant( ztrsm_batch:mkl_blas_ztrsm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ztrsm_batch

     subroutine ctrsm_batch ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       !$omp  declare variant( ctrsm_batch:mkl_blas_ctrsm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b)
     end subroutine ctrsm_batch

     subroutine dsyrk_batch ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( dsyrk_batch:mkl_blas_dsyrk_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine dsyrk_batch

     subroutine ssyrk_batch ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( ssyrk_batch:mkl_blas_ssyrk_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine ssyrk_batch

     subroutine zsyrk_batch ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( zsyrk_batch:mkl_blas_zsyrk_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine zsyrk_batch

     subroutine csyrk_batch ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( csyrk_batch:mkl_blas_csyrk_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,c)
     end subroutine csyrk_batch

     subroutine dgemm_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( dgemm_batch:mkl_blas_dgemm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine dgemm_batch

     subroutine sgemm_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( sgemm_batch:mkl_blas_sgemm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine sgemm_batch

     subroutine zgemm_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( zgemm_batch:mkl_blas_zgemm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm_batch

     subroutine cgemm_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( cgemm_batch:mkl_blas_cgemm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm_batch

     subroutine zgemm3m_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( zgemm3m_batch:mkl_blas_zgemm3m_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine zgemm3m_batch

     subroutine cgemm3m_batch ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       !$omp  declare variant( cgemm3m_batch:mkl_blas_cgemm3m_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,b,c)
     end subroutine cgemm3m_batch
     
     subroutine dgemv_batch ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       double precision,intent(in)             :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       !$omp  declare variant( dgemv_batch:mkl_blas_dgemv_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine dgemv_batch

     subroutine sgemv_batch ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       real,intent(in)                         :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       !$omp  declare variant( sgemv_batch:mkl_blas_sgemv_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine sgemv_batch

     subroutine zgemv_batch ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       complex*16,intent(in)                   :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       !$omp  declare variant( zgemv_batch:mkl_blas_zgemv_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine zgemv_batch

     subroutine cgemv_batch ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       complex,intent(in)                      :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       !$omp  declare variant( cgemv_batch:mkl_blas_cgemv_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,y)
     end subroutine cgemv_batch

     subroutine ddgmm_batch ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       !$omp  declare variant( ddgmm_batch:mkl_blas_ddgmm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine ddgmm_batch

     subroutine sdgmm_batch ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       !$omp  declare variant( sdgmm_batch:mkl_blas_sdgmm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine sdgmm_batch

     subroutine zdgmm_batch ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       !$omp  declare variant( zdgmm_batch:mkl_blas_zdgmm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine zdgmm_batch

     subroutine cdgmm_batch ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size ) BIND(C)
       use, intrinsic :: ISO_C_BINDING
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       !$omp  declare variant( cdgmm_batch:mkl_blas_cdgmm_batch_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(prefer_type("sycl","level_zero"),targetsync)) adjust_args(need_device_addr:a,x,c)
     end subroutine cdgmm_batch

  end interface

end module onemkl_blas_omp_offload_lp64

!===============================================================================
! Copyright (C) 2006 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

MODULE MKL_POISSON

USE MKL_DFTI

INTERFACE

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!INTERFACES FOR 3D CASE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


SUBROUTINE D_INIT_HELMHOLTZ_3D(AX,BX,AY,BY,AZ,BZ,NX,NY,NZ,BCTYPE,Q,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, NZ, STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION AX,BX,AY,BY,AZ,BZ,Q
   CHARACTER(6) BCTYPE
   DOUBLE PRECISION DPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_COMMIT_HELMHOLTZ_3D(F,BD_AX,BD_BX,BD_AY,BD_BY,BD_AZ,BD_BZ,XHANDLE,YHANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION DPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,IPAR(12)+1,*)
   DOUBLE PRECISION BD_AX(IPAR(12)+1,*),BD_BX(IPAR(12)+1,*),BD_AY(IPAR(11)+1,*),BD_BY(IPAR(11)+1,*)
   DOUBLE PRECISION BD_AZ(IPAR(11)+1,*),BD_BZ(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: XHANDLE, YHANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_HELMHOLTZ_3D(F,BD_AX,BD_BX,BD_AY,BD_BY,BD_AZ,BD_BZ,XHANDLE,YHANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,IPAR(12)+1,*)
   DOUBLE PRECISION BD_AX(IPAR(12)+1,*),BD_BX(IPAR(12)+1,*),BD_AY(IPAR(11)+1,*),BD_BY(IPAR(11)+1,*)
   DOUBLE PRECISION BD_AZ(IPAR(11)+1,*),BD_BZ(IPAR(11)+1,*)
   DOUBLE PRECISION DPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: XHANDLE, YHANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE FREE_HELMHOLTZ_3D(XHANDLE,YHANDLE,IPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: XHANDLE, YHANDLE
END SUBROUTINE

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!INTERFACES FOR 2D CASE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


SUBROUTINE D_INIT_HELMHOLTZ_2D(AX,BX,AY,BY,NX,NY,BCTYPE,Q,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION AX,BX,AY,BY,Q
   CHARACTER(4) BCTYPE
   DOUBLE PRECISION DPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_COMMIT_HELMHOLTZ_2D(F,BD_AX,BD_BX,BD_AY,BD_BY,HANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   DOUBLE PRECISION BD_AX(*),BD_BX(*),BD_AY(*),BD_BY(*)
   DOUBLE PRECISION DPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_HELMHOLTZ_2D(F,BD_AX,BD_BX,BD_AY,BD_BY,HANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   DOUBLE PRECISION BD_AX(*),BD_BX(*),BD_AY(*),BD_BY(*)
   DOUBLE PRECISION DPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE FREE_HELMHOLTZ_2D(HANDLE,IPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE
!**********************************************************************
!***********************SINGLE*****************************************
!**********************************************************************
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!INTERFACES FOR 3D CASE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


SUBROUTINE S_INIT_HELMHOLTZ_3D(AX,BX,AY,BY,AZ,BZ,NX,NY,NZ,BCTYPE,Q,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, NZ, STAT
   INTEGER IPAR(*)
   REAL AX,BX,AY,BY,AZ,BZ,Q
   CHARACTER(6) BCTYPE
   REAL SPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_COMMIT_HELMHOLTZ_3D(F,BD_AX,BD_BX,BD_AY,BD_BY,BD_AZ,BD_BZ,XHANDLE,YHANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL SPAR(*)
   REAL F(IPAR(11)+1,IPAR(12)+1,*)
   REAL BD_AX(IPAR(12)+1,*),BD_BX(IPAR(12)+1,*),BD_AY(IPAR(11)+1,*),BD_BY(IPAR(11)+1,*)
   REAL BD_AZ(IPAR(11)+1,*),BD_BZ(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: XHANDLE, YHANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_HELMHOLTZ_3D(F,BD_AX,BD_BX,BD_AY,BD_BY,BD_AZ,BD_BZ,XHANDLE,YHANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL F(IPAR(11)+1,IPAR(12)+1,*)
   REAL BD_AX(IPAR(12)+1,*),BD_BX(IPAR(12)+1,*),BD_AY(IPAR(11)+1,*),BD_BY(IPAR(11)+1,*)
   REAL BD_AZ(IPAR(11)+1,*),BD_BZ(IPAR(11)+1,*)
   REAL SPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: XHANDLE, YHANDLE
END SUBROUTINE

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!INTERFACES FOR 2D CASE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


SUBROUTINE S_INIT_HELMHOLTZ_2D(AX,BX,AY,BY,NX,NY,BCTYPE,Q,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   REAL AX,BX,AY,BY,Q
   CHARACTER(4) BCTYPE
   REAL SPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_COMMIT_HELMHOLTZ_2D(F,BD_AX,BD_BX,BD_AY,BD_BY,HANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL F(IPAR(11)+1,*)
   REAL BD_AX(*),BD_BX(*),BD_AY(*),BD_BY(*)
   REAL SPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_HELMHOLTZ_2D(F,BD_AX,BD_BX,BD_AY,BD_BY,HANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL F(IPAR(11)+1,*)
   REAL BD_AX(*),BD_BX(*),BD_AY(*),BD_BY(*)
   REAL SPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

SUBROUTINE D_INIT_SPH_P(AX,BX,AY,BY,NX,NY,Q,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION AX,BX,AY,BY,Q
   DOUBLE PRECISION DPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_COMMIT_SPH_P(F,HANDLE_S,HANDLE_C,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION DPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE_C, HANDLE_S
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_SPH_P(F,HANDLE_S,HANDLE_C,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION DPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE_C, HANDLE_S
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE FREE_SPH_P(HANDLE_S,HANDLE_C,IPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE_S, HANDLE_C
END SUBROUTINE

!---------------------------------------------------------------------
SUBROUTINE D_INIT_SPH_NP(AX,BX,AY,BY,NX,NY,Q,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION AX,BX,AY,BY,Q
   DOUBLE PRECISION DPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_COMMIT_SPH_NP(F,HANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION DPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE D_SPH_NP(F,HANDLE,IPAR,DPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   DOUBLE PRECISION DPAR(*)
   DOUBLE PRECISION F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE FREE_SPH_NP(HANDLE,IPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!======================================================================

SUBROUTINE S_INIT_SPH_P(AX,BX,AY,BY,NX,NY,Q,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   REAL AX,BX,AY,BY,Q
   REAL SPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_COMMIT_SPH_P(F,HANDLE_S,HANDLE_C,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL SPAR(*)
   REAL F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE_C, HANDLE_S
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_SPH_P(F,HANDLE_S,HANDLE_C,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL SPAR(*)
   REAL F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE_C, HANDLE_S
END SUBROUTINE

!--------------------------------------------------------------------

SUBROUTINE S_INIT_SPH_NP(AX,BX,AY,BY,NX,NY,Q,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER NX, NY, STAT
   INTEGER IPAR(*)
   REAL AX,BX,AY,BY,Q
   REAL SPAR(*)
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_COMMIT_SPH_NP(F,HANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL SPAR(*)
   REAL F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE

!---------------------------------------------------------------------

SUBROUTINE S_SPH_NP(F,HANDLE,IPAR,SPAR,STAT)
   USE MKL_DFTI

   INTEGER STAT
   INTEGER IPAR(*)
   REAL SPAR(*)
   REAL F(IPAR(11)+1,*)
   TYPE(DFTI_DESCRIPTOR), POINTER :: HANDLE
END SUBROUTINE


END INTERFACE
END MODULE

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      oneMKL Library FORTRAN interface for VSL OpenMP offload
!*******************************************************************************

include "mkl_vsl_omp_variant.f90"

module onemkl_vsl_omp_offload
  use onemkl_vsl_omp_variant

  !++
  !  VSL CONTINUOUS DISTRIBUTION GENERATOR FUNCTION INTERFACES.
  !--

  ! Uniform distribution
  interface
     integer function vsrnguniform(method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: b
       !$omp  declare variant( vsrnguniform:mkl_vsl_vsrnguniform_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnguniform
  end interface

  interface
     integer function vdrnguniform (method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: b
       !$omp  declare variant( vdrnguniform:mkl_vsl_vdrnguniform_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnguniform
  end interface
  
  ! Gaussian distribution
  interface
     integer function vsrnggaussian (method, stream, n, r, a, sigma)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       !$omp  declare variant( vsrnggaussian:mkl_vsl_vsrnggaussian_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggaussian
  end interface

  interface
     integer function vdrnggaussian (method, stream, n, r, a, sigma)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       !$omp  declare variant( vdrnggaussian:mkl_vsl_vdrnggaussian_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggaussian
  end interface

  ! GaussianMV distribution
  interface
     integer function vsrnggaussianmv (method, stream, n, r, dimen, mstorage, a, t)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=4),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=4),intent(in)  :: a(dimen)
       real(kind=4),intent(in)  :: t(dimen,dimen)
       !$omp  declare variant( vsrnggaussianmv:mkl_vsl_vsrnggaussianmv_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggaussianmv
  end interface

  interface
     integer function vdrnggaussianmv (method, stream, n, r, dimen, mstorage, a, t)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=8),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=8),intent(in)  :: a(dimen)
       real(kind=8),intent(in)  :: t(dimen,dimen)
       !$omp  declare variant( vdrnggaussianmv:mkl_vsl_vdrnggaussianmv_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggaussianmv
  end interface

  ! Multinomial distribution
  interface
     integer function virngmultinomial (method, stream, n, r, ntrial, k, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)           :: method
       type(VSL_STREAM_STATE)       :: stream
       integer,intent(in)           :: n
       integer(kind=4),intent(out) :: r(n)
       integer, intent(in)          :: ntrial
       integer, intent(in)          :: k
       real(kind=8),intent(in)      :: p(k)
       !$omp  declare variant( virngmultinomial:mkl_vsl_virngmultinomial_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngmultinomial
  end interface

  ! PoissonV distribution
  interface
     integer function virngpoissonv (method, stream, n, r, ntrial, k, lambda)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda(n)
       !$omp  declare variant( virngpoissonv:mkl_vsl_virngpoissonv_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngpoissonv
  end interface

  ! Exponential distribution
  interface
     integer function vsrngexponential (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngexponential:mkl_vsl_vsrngexponential_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngexponential
  end interface

  interface
     integer function vdrngexponential (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngexponential:mkl_vsl_vdrngexponential_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngexponential
  end interface

  ! Laplace distribution
  interface
     integer function vsrnglaplace (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnglaplace:mkl_vsl_vsrnglaplace_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnglaplace
  end interface

  interface
     integer function vdrnglaplace (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnglaplace:mkl_vsl_vdrnglaplace_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnglaplace
  end interface

  ! Weibull distribution
  interface
     integer function vsrngweibull (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngweibull:mkl_vsl_vsrngweibull_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngweibull
  end interface

  interface
     integer function vdrngweibull (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngweibull:mkl_vsl_vdrngweibull_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngweibull
  end interface

  ! Cauchy distribution
  interface
     integer function vsrngcauchy (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngcauchy:mkl_vsl_vsrngcauchy_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngcauchy
  end interface

  interface
     integer function vdrngcauchy (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngcauchy:mkl_vsl_vdrngcauchy_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngcauchy
  end interface

  ! Rayleigh distribution
  interface
     integer function vsrngrayleigh (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngrayleigh:mkl_vsl_vsrngrayleigh_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngrayleigh
  end interface

  interface
     integer function vdrngrayleigh (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngrayleigh:mkl_vsl_vdrngrayleigh_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngrayleigh
  end interface

  ! Lognormal distribution
  interface
     integer function vsrnglognormal (method, stream, n, r, a, sigma, b, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       real(kind=4),intent(in)  :: b
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnglognormal:mkl_vsl_vsrnglognormal_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnglognormal
  end interface

  interface
     integer function vdrnglognormal (method, stream, n, r, a, sigma, b, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       real(kind=8),intent(in)  :: b
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnglognormal:mkl_vsl_vdrnglognormal_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnglognormal
  end interface

  ! Gumbel distribution
  interface
     integer function vsrnggumbel (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnggumbel:mkl_vsl_vsrnggumbel_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggumbel
  end interface

  interface
     integer function vdrnggumbel (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnggumbel:mkl_vsl_vdrnggumbel_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggumbel
  end interface

  ! Beta distribution
  interface
     integer function vsrngbeta (method, stream, n, r, p, q, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: p
       real(kind=4),intent(in)  :: q
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngbeta:mkl_vsl_vsrngbeta_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngbeta
  end interface

  interface
     integer function vdrngbeta (method, stream, n, r, p, q, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: p
       real(kind=8),intent(in)  :: q
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngbeta:mkl_vsl_vdrngbeta_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngbeta
    end interface

  ! Gamma distribution
  interface
     integer function vsrnggamma (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnggamma:mkl_vsl_vsrnggamma_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggamma
  end interface

  interface
     integer function vdrnggamma (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnggamma:mkl_vsl_vdrnggamma_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggamma
    end interface

  ! ChiSquare distribution
  interface
     integer function vsrngchisquare (method, stream, n, r,v)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       integer,intent(in)       :: v
       !$omp  declare variant( vsrngchisquare:mkl_vsl_vsrngchisquare_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngchisquare
  end interface

  interface
     integer function vdrngchisquare (method, stream, n, r, v)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       integer,intent(in)       :: v
       !$omp  declare variant( vdrngchisquare:mkl_vsl_vdrngchisquare_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngchisquare
    end interface

!++
!  VSL DISCRETE DISTRIBUTION GENERATOR FUNCTION INTERFACES.
!--
  ! Uniform distribution
  interface
     integer function virnguniform (method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: a
       integer(kind=4),intent(in)  :: b
       !$omp  declare variant( virnguniform:mkl_vsl_virnguniform_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniform
  end interface

  ! UniformBits distribution
  interface
     integer function virnguniformbits (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits:mkl_vsl_virnguniformbits_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits
  end interface

  ! UniformBits32 distribution
  interface
     integer function virnguniformbits32 (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits32:mkl_vsl_virnguniformbits32_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits32
  end interface

  ! UniformBits64 distribution
  interface
     integer function virnguniformbits64 (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=8),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits64:mkl_vsl_virnguniformbits64_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits64
  end interface

  ! Bernoulli distribution
  interface
     integer function virngbernoulli (method, stream, n, r, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngbernoulli:mkl_vsl_virngbernoulli_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngbernoulli
  end interface

  ! Geometric distribution
  interface
     integer function virnggeometric (method, stream, n, r, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virnggeometric:mkl_vsl_virnggeometric_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnggeometric
  end interface

  ! Hypergeometric distribution
  interface
     integer function virnghypergeometric (method, stream, n, r, l, s, m)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: l
       integer(kind=4),intent(in)  :: s
       integer(kind=4),intent(in)  :: m
       !$omp  declare variant( virnghypergeometric:mkl_vsl_virnghypergeometric_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnghypergeometric
  end interface

  ! Binomial distribution
  interface
     integer function virngbinomial (method, stream, n, r, ntrial, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: ntrial
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngbinomial:mkl_vsl_virngbinomial_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngbinomial
  end interface

  ! Negbinomial distribution
  interface
     integer function virngnegbinomial (method, stream, n, r, a, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: a
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngnegbinomial:mkl_vsl_virngnegbinomial_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngnegbinomial
  end interface

  ! Poisson distribution
  interface
     integer function virngpoisson (method, stream, n, r, lambda)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda
       !$omp  declare variant( virngpoisson:mkl_vsl_virngpoisson_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngpoisson
  end interface

  !++
  !  VSL SERVICE FUNCTION INTERFACES.
  !--

  ! NewStream - stream creation/initialization
        interface
          integer function vslnewstream( stream, brng, seed )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
            integer,intent(in)     :: brng
            integer,intent(in)     :: seed
     end function
        end interface

  ! NewStreamEx - advanced stream creation/initialization
        interface
          integer function vslnewstreamex( stream, brng, n, params )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer,intent(in)         :: brng
            integer,intent(in)         :: n
            integer(kind=4),intent(in) :: params(n)
     end function
        end interface

  ! DeleteStream - delete stream
        interface
          integer function vsldeletestream( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! CopyStream - copy all stream information
        interface
          integer function vslcopystream( newstream, srcstream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: newstream
            type(VSL_STREAM_STATE) :: srcstream
     end function
        end interface

  ! CopyStreamState - copy stream state only
        interface
          integer function vslcopystreamstate( deststream, srcstream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: deststream
            type(VSL_STREAM_STATE) :: srcstream
     end function
        end interface

  ! LeapfrogStream - leapfrog method
        interface
          integer function vslleapfrogstream( stream, k, nstreams )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
            integer,intent(in)     :: k
            integer,intent(in)     :: nstreams
     end function
        end interface

  ! SkipAheadStream - skip-ahead method
        interface
          integer function vslskipaheadstream( stream, nskip )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer(kind=8),intent(in) :: nskip
     end function
        end interface

  ! SkipAheadStreamEx - skip-ahead extended method
        interface
          integer function vslskipaheadstreamex( stream, n, params )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer,intent(in)         :: n
            integer(kind=8),intent(in) :: params(n)
     end function
        end interface

  ! GetBrngProperties - get BRNG properties
        interface
          integer function vslgetbrngproperties( brng, properties )
              import :: VSL_BRNG_PROPERTIES
            integer(kind=4),intent(in)            :: brng
            type(VSL_BRNG_PROPERTIES),intent(out) :: properties
     end function
        end interface

  ! GetStreamStateBrng - get BRNG associated with given stream
        interface
          integer function vslgetstreamstatebrng( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! SaveStreamF - save stream to file
        interface
          integer function vslsavestreamf( stream, fname )
              import :: VSL_STREAM_STATE
            character(*)           :: fname
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! LoadStreamF - save stream to file
        interface
          integer function vslloadstreamf( stream, fname )
              import :: VSL_STREAM_STATE
            character(*)           :: fname
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! SaveStreamM - save stream to memory
        interface
          integer function vslsavestreamm( stream, memptr )
              import :: VSL_STREAM_STATE
            integer(kind=1),dimension(*),intent(out)::memptr
            type(VSL_STREAM_STATE),intent(in)       :: stream
     end function
        end interface

  ! LoadStreamM - load stream from memory
        interface
          integer function vslloadstreamm( stream, memptr )
              import :: VSL_STREAM_STATE
            integer(kind=1),dimension(*),intent(in)::memptr
            type(VSL_STREAM_STATE),intent(out)      ::stream
     end function
        end interface

  ! GetStreamSize - get size of random stream
        interface
          integer function vslgetstreamsize( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE),intent(in) :: stream
     end function
        end interface

  !++
  !  SUMMARY STATISTICS LIBRARY ROUTINES
  !--

  !  Compute routines
      interface
        integer function vsldsscompute(task, estimates, method)
              import :: VSL_SS_TASK
              type(VSL_SS_TASK)            :: task
              integer(kind=8),intent(in)   :: estimates
              integer,intent(in)           :: method
              !$omp  declare variant( vsldsscompute:mkl_vsl_dsscompute_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync))
     end function
      end interface

      interface
        integer function vslssscompute(task, estimates, method)
              import :: VSL_SS_TASK
              type(VSL_SS_TASK)            :: task
              integer(kind=8),intent(in)   :: estimates
              integer,intent(in)           :: method
              !$omp  declare variant( vslssscompute:mkl_vsl_ssscompute_omp_offload ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync))
     end function
      end interface

    !  Task constructors
      INTERFACE
       INTEGER FUNCTION vsldssnewtask(task,p,n,x_storage,x,w,indices)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)       :: task
             INTEGER,INTENT(IN)      :: p
             INTEGER,INTENT(IN)      :: n
             INTEGER,INTENT(IN)      :: x_storage
             REAL(KIND=8),INTENT(IN) :: x(n,p)
             REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL:: w
             INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL:: indices
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslsssnewtask(task,p,n,x_storage,x,w,indices)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)       :: task
             INTEGER,INTENT(IN)      :: p
             INTEGER,INTENT(IN)      :: n
             INTEGER,INTENT(IN)      :: x_storage
             REAL(KIND=4),INTENT(IN) :: x(n,p)
             REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL:: w
             INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL:: indices
     end function
      END INTERFACE


!  Task editors

!  Editor to modify a task parameter
      INTERFACE
       INTEGER FUNCTION vsldssedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)                    :: task
             INTEGER,INTENT(IN)                   :: parameter
             REAL(KIND=8),DIMENSION(*),INTENT(IN) :: par_addr
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslsssedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)                    :: task
             INTEGER,INTENT(IN)                   :: parameter
             REAL(KIND=4),DIMENSION(*),INTENT(IN) :: par_addr
     end function
       END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslissedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)               :: task
             INTEGER,INTENT(IN)              :: parameter
             INTEGER,INTENT(IN)              :: par_addr
     end function
      END INTERFACE


!  Task specific editors

!  Editors to modify moments related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditmoments(task, mean, r2m, r3m, r4m,     &
     &                                                c2m, c3m, c4m)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)          :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r2m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r3m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r4m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c2m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c3m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c4m
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditmoments(task, mean, r2m, r3m, r4m,     &
     &                                                c2m, c3m, c4m)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)          :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r2m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r3m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r4m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c2m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c3m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c4m
     end function
      END INTERFACE

!  Editors to modify sums related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditsums(task, sum, r2s, r3s, r4s,         &
     &                                                c2s, c3s, c4s)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)          :: sum
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r2s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r3s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r4s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c2s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c3s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c4s
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditsums(task, sum, r2s, r3s, r4s,         &
     &                                                c2s, c3s, c4s)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)          :: sum
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r2s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r3s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r4s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c2s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c3s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c4s
     end function
      END INTERFACE

!  Editors to modify variance-covariance/correlation matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcovcor(task, mean,cov, cov_storage,    &
     &                                              cor, cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: cov
              INTEGER,INTENT(IN), OPTIONAL                :: cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: cor
              INTEGER,INTENT(IN), OPTIONAL                :: cor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcovcor(task, mean,cov, cov_storage,    &
     &                                              cor, cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: cov
              INTEGER,INTENT(IN), OPTIONAL                :: cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: cor
              INTEGER,INTENT(IN), OPTIONAL                :: cor_storage
     end function
      END INTERFACE

!  Editors to modify cross-product matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcp(task, mean, sum,                    &
     &                                              cp, cp_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: sum
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: cp
              INTEGER,INTENT(IN)                          :: cp_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcp(task, mean, sum,                    &
     &                                              cp, cp_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: sum
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: cp
              INTEGER,INTENT(IN)                          :: cp_storage
     end function
      END INTERFACE

!  Editors to modify partial variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditpartialcovcor(task, p_idx_array,       &
     &                       cov, cov_storage, cor, cor_storage,         &
     &                       p_cov, p_cov_storage, p_cor, p_cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: p_idx_array
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: cov
              INTEGER,INTENT(IN),OPTIONAL              :: cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: cor
              INTEGER,INTENT(IN),OPTIONAL              :: cor_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cov
              INTEGER,INTENT(IN),OPTIONAL      :: p_cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cor
              INTEGER,INTENT(IN),OPTIONAL      :: p_cor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditpartialcovcor(task, p_idx_array,       &
     &                       cov, cov_storage, cor, cor_storage,         &
     &                       p_cov, p_cov_storage, p_cor, p_cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: p_idx_array
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: cov
              INTEGER,INTENT(IN),OPTIONAL              :: cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: cor
              INTEGER,INTENT(IN),OPTIONAL              :: cor_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cov
              INTEGER,INTENT(IN),OPTIONAL      :: p_cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cor
              INTEGER,INTENT(IN),OPTIONAL      :: p_cor_storage
     end function
      END INTERFACE

!  Editors to modify quantiles related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditquantiles(task, quant_order_n,         &
     &                                 quant_order,quants,               &
     &                                 order_stats, order_stats_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                         :: task
              INTEGER,INTENT(IN),OPTIONAL               :: quant_order_n
              REAL(KIND=8),INTENT(IN),dimension(*),OPTIONAL::quant_order
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL::quants
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL ::           &
     &                                                     order_stats
              INTEGER,INTENT(IN),OPTIONAL  ::      order_stats_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditquantiles(task, quant_order_n,         &
     &                                 quant_order,quants,               &
     &                                 order_stats, order_stats_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                         :: task
              INTEGER,INTENT(IN),OPTIONAL               :: quant_order_n
              REAL(KIND=4),INTENT(IN),dimension(*),OPTIONAL::quant_order
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL::quants
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL ::           &
     &                                                     order_stats
              INTEGER,INTENT(IN),OPTIONAL  ::      order_stats_storage
     end function
      END INTERFACE


!  Editors to modify stream data quantiles related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditstreamquantiles(task,                  &
     &        quant_order_n, quant_order, quants, nparams, params)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                     :: task
              INTEGER,INTENT(IN)                    :: quant_order_n
              REAL(KIND=8),INTENT(IN),dimension(*)  :: quant_order
              REAL(KIND=8),DIMENSION(*),INTENT(IN)  :: quants
              INTEGER,INTENT(IN)                    :: nparams
              REAL(KIND=8),INTENT(IN), DIMENSION(*) :: params
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditstreamquantiles(task,                  &
     &        quant_order_n, quant_order, quants, nparams, params)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                     :: task
              INTEGER,INTENT(IN)                    :: quant_order_n
              REAL(KIND=4),INTENT(IN),dimension(*)  :: quant_order
              REAL(KIND=4),DIMENSION(*),INTENT(IN)  :: quants
              INTEGER,INTENT(IN)                    :: nparams
              REAL(KIND=4),INTENT(IN), DIMENSION(*) :: params
     end function
      END INTERFACE


!  Editors to modify pooled/group variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditpooledcovariance(task, grp_indices,    &
     &           pld_mean, pld_cov, grp_cov_indices, grp_means, grp_cov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: grp_indices
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_cov
              INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL ::grp_cov_indices
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: grp_means
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: grp_cov
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditpooledcovariance(task, grp_indices,    &
     &           pld_mean, pld_cov, grp_cov_indices, grp_means, grp_cov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: grp_indices
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_cov
              INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL ::grp_cov_indices
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: grp_means
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: grp_cov
     end function
      END INTERFACE


!  Editors to modify robust variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditrobustcovariance(task,rcov_storage,    &
     &                                      nparams, params,rmean, rcov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,INTENT(IN)                   :: rcov_storage
              INTEGER,INTENT(IN)                   :: nparams
              REAL(KIND=8),INTENT(IN)              :: params(nparams)
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: rmean
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: rcov
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditrobustcovariance(task,rcov_storage,    &
     &                                      nparams, params,rmean, rcov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,INTENT(IN)                   :: rcov_storage
              INTEGER,INTENT(IN)                   :: nparams
              REAL(KIND=4),INTENT(IN)              :: params(nparams)
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: rmean
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: rcov
     end function
      END INTERFACE


!  Editors to modify outliers detection parameters
      INTERFACE
        INTEGER FUNCTION vsldsseditoutliersdetection(task,               &
     &                                               nparams, params, w)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,INTENT(IN)      :: nparams
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: params(nparams)
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: w
     end function
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION vslssseditoutliersdetection(task,               &
     &                                               nparams, params, w)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,INTENT(IN)      :: nparams
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: params(nparams)
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: w
     end function
      END INTERFACE

!  Editors to modify missing values parameters
      INTERFACE
        INTEGER FUNCTION vsldsseditmissingvalues(task, nparams, params,  &
     &        init_estimates_n, init_estimates,  prior_n, prior,         &
     &        simul_missing_vals_n,simul_missing_vals,                   &
     &        estimates_n, estimates)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)           :: task
              INTEGER,INTENT(IN)          :: nparams
              REAL(KIND=8),INTENT(IN)     :: params(nparams)
              INTEGER,INTENT(IN),OPTIONAL :: init_estimates_n
              REAL(KIND=8),INTENT(IN), DIMENSION(*),OPTIONAL::           &
     &                                       init_estimates
              INTEGER,INTENT(IN),OPTIONAL :: prior_n
              REAL(KIND=8),INTENT(IN),DIMENSION(*),OPTIONAL :: prior
              INTEGER,INTENT(IN),OPTIONAL :: simul_missing_vals_n
              REAL(KIND=8),INTENT(IN),DIMENSION(*),OPTIONAL ::           &
     &                                 simul_missing_vals
              INTEGER,INTENT(IN),OPTIONAL :: estimates_n
              REAL(KIND=8),INTENT(IN), DIMENSION(*), OPTIONAL ::         &
     &                                 estimates
     end function
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION vslssseditmissingvalues(task, nparams, params,  &
     &        init_estimates_n, init_estimates,  prior_n, prior,         &
     &        simul_missing_vals_n,simul_missing_vals,                   &
     &        estimates_n, estimates)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)           :: task
              INTEGER,INTENT(IN)          :: nparams
              REAL(KIND=4),INTENT(IN)     :: params(nparams)
              INTEGER,INTENT(IN),OPTIONAL :: init_estimates_n
              REAL(KIND=4),INTENT(IN), DIMENSION(*),OPTIONAL::           &
     &                                       init_estimates
              INTEGER,INTENT(IN),OPTIONAL :: prior_n
              REAL(KIND=4),INTENT(IN),DIMENSION(*),OPTIONAL :: prior
              INTEGER,INTENT(IN),OPTIONAL :: simul_missing_vals_n
              REAL(KIND=4),INTENT(IN),DIMENSION(*),OPTIONAL ::           &
     &                                 simul_missing_vals
              INTEGER,INTENT(IN),OPTIONAL :: estimates_n
              REAL(KIND=4),INTENT(IN), DIMENSION(*), OPTIONAL ::         &
     &                                 estimates
     end function
      END INTERFACE

    !     Editors to modify matrix parameterization
    !     related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcorparameterization (task,             &
     &                             cor, cor_storage, pcor, pcor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: cor
              INTEGER,INTENT(IN)                   :: cor_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: pcor
              INTEGER,INTENT(IN)                   :: pcor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcorparameterization (task,             &
     &                             cor, cor_storage, pcor, pcor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: cor
              INTEGER,INTENT(IN)                   :: cor_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: pcor
              INTEGER,INTENT(IN)                   :: pcor_storage
     end function
      END INTERFACE
  
    !  Task destructor
    INTERFACE
      INTEGER FUNCTION vslssdeletetask(task)
          IMPORT :: VSL_SS_TASK
            TYPE(VSL_SS_TASK)      :: task
     end function
    END INTERFACE
end module onemkl_vsl_omp_offload


module onemkl_vsl_omp_offload_ilp64
  use onemkl_vsl_omp_offload
end module onemkl_vsl_omp_offload_ilp64


module onemkl_vsl_omp_offload_lp64
  use onemkl_vsl_omp_variant_lp64

  !++
  !  VSL CONTINUOUS DISTRIBUTION GENERATOR FUNCTION INTERFACES.
  !--

  ! Uniform distribution
  interface
     integer function vsrnguniform(method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: b
       !$omp  declare variant( vsrnguniform:mkl_vsl_vsrnguniform_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnguniform
  end interface

  interface
     integer function vdrnguniform (method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: b
       !$omp  declare variant( vdrnguniform:mkl_vsl_vdrnguniform_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnguniform
  end interface
  
  ! Gaussian distribution
  interface
     integer function vsrnggaussian (method, stream, n, r, a, sigma)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       !$omp  declare variant( vsrnggaussian:mkl_vsl_vsrnggaussian_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggaussian
  end interface

  interface
     integer function vdrnggaussian (method, stream, n, r, a, sigma)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       !$omp  declare variant( vdrnggaussian:mkl_vsl_vdrnggaussian_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggaussian
  end interface

  ! GaussianMV distribution
  interface
     integer function vsrnggaussianmv (method, stream, n, r, dimen, mstorage, a, t)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=4),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=4),intent(in)  :: a(dimen)
       real(kind=4),intent(in)  :: t(dimen,dimen)
       !$omp  declare variant( vsrnggaussianmv:mkl_vsl_vsrnggaussianmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggaussianmv
  end interface

  interface
     integer function vdrnggaussianmv (method, stream, n, r, dimen, mstorage, a, t)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       integer, intent(in)      :: dimen
       real(kind=8),intent(out) :: r(dimen,n)
       integer, intent(in)      :: mstorage
       real(kind=8),intent(in)  :: a(dimen)
       real(kind=8),intent(in)  :: t(dimen,dimen)
       !$omp  declare variant( vdrnggaussianmv:mkl_vsl_vdrnggaussianmv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggaussianmv
  end interface

  ! Multinomial distribution
  interface
     integer function virngmultinomial (method, stream, n, r, ntrial, k, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer, intent(in)         :: ntrial
       integer, intent(in)         :: k
       real(kind=8),intent(in)     :: p(k)
       !$omp  declare variant( virngmultinomial:mkl_vsl_virngmultinomial_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngmultinomial
  end interface

  ! PoissonV distribution
  interface
     integer function virngpoissonv (method, stream, n, r, lambda)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda(n)
       !$omp  declare variant( virngpoissonv:mkl_vsl_virngpoissonv_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngpoissonv
  end interface

  ! Exponential distribution
  interface
     integer function vsrngexponential (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngexponential:mkl_vsl_vsrngexponential_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngexponential
  end interface

  interface
     integer function vdrngexponential (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngexponential:mkl_vsl_vdrngexponential_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngexponential
  end interface

  ! Laplace distribution
  interface
     integer function vsrnglaplace (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnglaplace:mkl_vsl_vsrnglaplace_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnglaplace
  end interface

  interface
     integer function vdrnglaplace (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnglaplace:mkl_vsl_vdrnglaplace_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnglaplace
  end interface

  ! Weibull distribution
  interface
     integer function vsrngweibull (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngweibull:mkl_vsl_vsrngweibull_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngweibull
  end interface

  interface
     integer function vdrngweibull (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngweibull:mkl_vsl_vdrngweibull_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngweibull
  end interface

  ! Cauchy distribution
  interface
     integer function vsrngcauchy (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngcauchy:mkl_vsl_vsrngcauchy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngcauchy
  end interface

  interface
     integer function vdrngcauchy (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngcauchy:mkl_vsl_vdrngcauchy_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngcauchy
  end interface

  ! Rayleigh distribution
  interface
     integer function vsrngrayleigh (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngrayleigh:mkl_vsl_vsrngrayleigh_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngrayleigh
  end interface

  interface
     integer function vdrngrayleigh (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngrayleigh:mkl_vsl_vdrngrayleigh_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngrayleigh
  end interface

  ! Lognormal distribution
  interface
     integer function vsrnglognormal (method, stream, n, r, a, sigma, b, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: sigma
       real(kind=4),intent(in)  :: b
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnglognormal:mkl_vsl_vsrnglognormal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnglognormal
  end interface

  interface
     integer function vdrnglognormal (method, stream, n, r, a, sigma, b, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: sigma
       real(kind=8),intent(in)  :: b
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnglognormal:mkl_vsl_vdrnglognormal_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnglognormal
  end interface

  ! Gumbel distribution
  interface
     integer function vsrnggumbel (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnggumbel:mkl_vsl_vsrnggumbel_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggumbel
  end interface

  interface
     integer function vdrnggumbel (method, stream, n, r, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnggumbel:mkl_vsl_vdrnggumbel_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggumbel
  end interface

  ! Beta distribution
  interface
     integer function vsrngbeta (method, stream, n, r, p, q, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: p
       real(kind=4),intent(in)  :: q
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrngbeta:mkl_vsl_vsrngbeta_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngbeta
  end interface

  interface
     integer function vdrngbeta (method, stream, n, r, p, q, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: p
       real(kind=8),intent(in)  :: q
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrngbeta:mkl_vsl_vdrngbeta_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngbeta
    end interface

  ! Gamma distribution
  interface
     integer function vsrnggamma (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       real(kind=4),intent(in)  :: alpha
       real(kind=4),intent(in)  :: a
       real(kind=4),intent(in)  :: beta
       !$omp  declare variant( vsrnggamma:mkl_vsl_vsrnggamma_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrnggamma
  end interface

  interface
     integer function vdrnggamma (method, stream, n, r, alpha, a, beta)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       real(kind=8),intent(in)  :: alpha
       real(kind=8),intent(in)  :: a
       real(kind=8),intent(in)  :: beta
       !$omp  declare variant( vdrnggamma:mkl_vsl_vdrnggamma_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrnggamma
    end interface

  ! ChiSquare distribution
  interface
     integer function vsrngchisquare (method, stream, n, r, v)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=4),intent(out) :: r(n)
       integer,intent(in)       :: v
       !$omp  declare variant( vsrngchisquare:mkl_vsl_vsrngchisquare_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vsrngchisquare
  end interface

  interface
     integer function vdrngchisquare (method, stream, n, r, v)
       import :: VSL_STREAM_STATE
       integer,intent(in)       :: method
       type(VSL_STREAM_STATE)   :: stream
       integer,intent(in)       :: n
       real(kind=8),intent(out) :: r(n)
       integer,intent(in)       :: v
       !$omp  declare variant( vdrngchisquare:mkl_vsl_vdrngchisquare_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function vdrngchisquare
    end interface

!++
!  VSL DISCRETE DISTRIBUTION GENERATOR FUNCTION INTERFACES.
!--
  ! Uniform distribution
  interface
     integer function virnguniform (method, stream, n, r, a, b)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: a
       integer(kind=4),intent(in)  :: b
       !$omp  declare variant( virnguniform:mkl_vsl_virnguniform_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniform
  end interface

  ! UniformBits distribution
  interface
     integer function virnguniformbits (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits:mkl_vsl_virnguniformbits_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits
  end interface

  ! UniformBits32 distribution
  interface
     integer function virnguniformbits32 (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits32:mkl_vsl_virnguniformbits32_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits32
  end interface

  ! UniformBits64 distribution
  interface
     integer function virnguniformbits64 (method, stream, n, r)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=8),intent(out) :: r(n)
       !$omp  declare variant( virnguniformbits64:mkl_vsl_virnguniformbits64_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnguniformbits64
  end interface

  ! Bernoulli distribution
  interface
     integer function virngbernoulli (method, stream, n, r, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngbernoulli:mkl_vsl_virngbernoulli_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngbernoulli
  end interface

  ! Geometric distribution
  interface
     integer function virnggeometric (method, stream, n, r, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virnggeometric:mkl_vsl_virnggeometric_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnggeometric
  end interface

  ! Hypergeometric distribution
  interface
     integer function virnghypergeometric (method, stream, n, r, l, s, m)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: l
       integer(kind=4),intent(in)  :: s
       integer(kind=4),intent(in)  :: m
       !$omp  declare variant( virnghypergeometric:mkl_vsl_virnghypergeometric_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virnghypergeometric
  end interface

  ! Binomial distribution
  interface
     integer function virngbinomial (method, stream, n, r, ntrial, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       integer(kind=4),intent(in)  :: ntrial
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngbinomial:mkl_vsl_virngbinomial_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngbinomial
  end interface

  ! Negbinomial distribution
  interface
     integer function virngnegbinomial (method, stream, n, r, a, p)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: a
       real(kind=8),intent(in)     :: p
       !$omp  declare variant( virngnegbinomial:mkl_vsl_virngnegbinomial_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngnegbinomial
  end interface

  ! Poisson distribution
  interface
     integer function virngpoisson (method, stream, n, r, lambda)
       import :: VSL_STREAM_STATE
       integer,intent(in)          :: method
       type(VSL_STREAM_STATE)      :: stream
       integer,intent(in)          :: n
       integer(kind=4),intent(out) :: r(n)
       real(kind=8),intent(in)     :: lambda
       !$omp  declare variant( virngpoisson:mkl_vsl_virngpoisson_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync)) adjust_args(need_device_addr:r)
     end function virngpoisson
  end interface

  !++
  !  VSL SERVICE FUNCTION INTERFACES.
  !--

  ! NewStream - stream creation/initialization
        interface
          integer function vslnewstream( stream, brng, seed )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
            integer,intent(in)     :: brng
            integer,intent(in)     :: seed
     end function
        end interface

  ! NewStreamEx - advanced stream creation/initialization
        interface
          integer function vslnewstreamex( stream, brng, n, params )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer,intent(in)         :: brng
            integer,intent(in)         :: n
            integer(kind=4),intent(in) :: params(n)
     end function
        end interface

  ! DeleteStream - delete stream
        interface
          integer function vsldeletestream( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! CopyStream - copy all stream information
        interface
          integer function vslcopystream( newstream, srcstream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: newstream
            type(VSL_STREAM_STATE) :: srcstream
     end function
        end interface

  ! CopyStreamState - copy stream state only
        interface
          integer function vslcopystreamstate( deststream, srcstream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: deststream
            type(VSL_STREAM_STATE) :: srcstream
     end function
        end interface

  ! LeapfrogStream - leapfrog method
        interface
          integer function vslleapfrogstream( stream, k, nstreams )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
            integer,intent(in)     :: k
            integer,intent(in)     :: nstreams
     end function
        end interface

  ! SkipAheadStream - skip-ahead method
        interface
          integer function vslskipaheadstream( stream, nskip )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer(kind=8),intent(in) :: nskip
     end function
        end interface

  ! SkipAheadStreamEx - skip-ahead extended method
        interface
          integer function vslskipaheadstreamex( stream, n, params )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE)     :: stream
            integer,intent(in)         :: n
            integer(kind=8),intent(in) :: params(n)
     end function
        end interface

  ! GetBrngProperties - get BRNG properties
        interface
          integer function vslgetbrngproperties( brng, properties )
              import :: VSL_BRNG_PROPERTIES
            integer(kind=4),intent(in)            :: brng
            type(VSL_BRNG_PROPERTIES),intent(out) :: properties
     end function
        end interface

  ! GetStreamStateBrng - get BRNG associated with given stream
        interface
          integer function vslgetstreamstatebrng( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! SaveStreamF - save stream to file
        interface
          integer function vslsavestreamf( stream, fname )
              import :: VSL_STREAM_STATE
            character(*)           :: fname
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! LoadStreamF - save stream to file
        interface
          integer function vslloadstreamf( stream, fname )
              import :: VSL_STREAM_STATE
            character(*)           :: fname
            type(VSL_STREAM_STATE) :: stream
     end function
        end interface

  ! SaveStreamM - save stream to memory
        interface
          integer function vslsavestreamm( stream, memptr )
              import :: VSL_STREAM_STATE
            integer(kind=1),dimension(*),intent(out)::memptr
            type(VSL_STREAM_STATE),intent(in)       :: stream
     end function
        end interface

  ! LoadStreamM - load stream from memory
        interface
          integer function vslloadstreamm( stream, memptr )
              import :: VSL_STREAM_STATE
            integer(kind=1),dimension(*),intent(in)::memptr
            type(VSL_STREAM_STATE),intent(out)      ::stream
     end function
        end interface

  ! GetStreamSize - get size of random stream
        interface
          integer function vslgetstreamsize( stream )
              import :: VSL_STREAM_STATE
            type(VSL_STREAM_STATE),intent(in) :: stream
     end function
        end interface

  !++
  !  SUMMARY STATISTICS LIBRARY ROUTINES
  !--

  !  Compute routines
      interface
        integer function vsldsscompute(task, estimates, method)
              import :: VSL_SS_TASK
              type(VSL_SS_TASK)            :: task
              integer(kind=8),intent(in)   :: estimates
              integer,intent(in)           :: method
              !$omp  declare variant( vsldsscompute:mkl_vsl_dsscompute_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync))
     end function
      end interface

      interface
        integer function vslssscompute(task, estimates, method)
              import :: VSL_SS_TASK
              type(VSL_SS_TASK)            :: task
              integer(kind=8),intent(in)   :: estimates
              integer,intent(in)           :: method
              !$omp  declare variant( vslssscompute:mkl_vsl_ssscompute_omp_offload_lp64 ) match( construct={dispatch}, device={arch(gen)} ) append_args(interop(targetsync))
     end function
      end interface

  !  Task constructors
      INTERFACE
       INTEGER FUNCTION vsldssnewtask(task,p,n,x_storage,x,w,indices)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)       :: task
             INTEGER,INTENT(IN)      :: p
             INTEGER,INTENT(IN)      :: n
             INTEGER,INTENT(IN)      :: x_storage
             REAL(KIND=8),INTENT(IN) :: x(n,p)
             REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL:: w
             INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL:: indices
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslsssnewtask(task,p,n,x_storage,x,w,indices)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)       :: task
             INTEGER,INTENT(IN)      :: p
             INTEGER,INTENT(IN)      :: n
             INTEGER,INTENT(IN)      :: x_storage
             REAL(KIND=4),INTENT(IN) :: x(n,p)
             REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL:: w
             INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL:: indices
     end function
      END INTERFACE


!  Task editors

!  Editor to modify a task parameter
      INTERFACE
       INTEGER FUNCTION vsldssedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)                    :: task
             INTEGER,INTENT(IN)                   :: parameter
             REAL(KIND=8),DIMENSION(*),INTENT(IN) :: par_addr
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslsssedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)                    :: task
             INTEGER,INTENT(IN)                   :: parameter
             REAL(KIND=4),DIMENSION(*),INTENT(IN) :: par_addr
     end function
       END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslissedittask(task,parameter,par_addr)
             IMPORT :: VSL_SS_TASK
             TYPE(VSL_SS_TASK)               :: task
             INTEGER,INTENT(IN)              :: parameter
             INTEGER,INTENT(IN)              :: par_addr
     end function
      END INTERFACE


!  Task specific editors

!  Editors to modify moments related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditmoments(task, mean, r2m, r3m, r4m,     &
     &                                                c2m, c3m, c4m)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)          :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r2m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r3m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r4m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c2m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c3m
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c4m
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditmoments(task, mean, r2m, r3m, r4m,     &
     &                                                c2m, c3m, c4m)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)          :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r2m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r3m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r4m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c2m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c3m
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c4m
     end function
      END INTERFACE

!  Editors to modify sums related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditsums(task, sum, r2s, r3s, r4s,         &
     &                                                c2s, c3s, c4s)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)          :: sum
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r2s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r3s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: r4s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c2s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c3s
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: c4s
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditsums(task, sum, r2s, r3s, r4s,         &
     &                                                c2s, c3s, c4s)
           IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                             :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)          :: sum
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r2s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r3s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: r4s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c2s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c3s
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: c4s
     end function
      END INTERFACE

!  Editors to modify variance-covariance/correlation matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcovcor(task, mean,cov, cov_storage,    &
     &                                              cor, cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: cov
              INTEGER,INTENT(IN), OPTIONAL                :: cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: cor
              INTEGER,INTENT(IN), OPTIONAL                :: cor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcovcor(task, mean,cov, cov_storage,    &
     &                                              cor, cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: cov
              INTEGER,INTENT(IN), OPTIONAL                :: cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: cor
              INTEGER,INTENT(IN), OPTIONAL                :: cor_storage
     end function
      END INTERFACE

!  Editors to modify cross-product matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcp(task, mean, sum,                    &
     &                                              cp, cp_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: sum
              REAL(KIND=8),DIMENSION(*),INTENT(IN)           :: cp
              INTEGER,INTENT(IN)                          :: cp_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcp(task, mean, sum,                    &
     &                                              cp, cp_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                              :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: sum
              REAL(KIND=4),DIMENSION(*),INTENT(IN)           :: cp
              INTEGER,INTENT(IN)                          :: cp_storage
     end function
      END INTERFACE

!  Editors to modify partial variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditpartialcovcor(task, p_idx_array,       &
     &                       cov, cov_storage, cor, cor_storage,         &
     &                       p_cov, p_cov_storage, p_cor, p_cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: p_idx_array
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: cov
              INTEGER,INTENT(IN),OPTIONAL              :: cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: cor
              INTEGER,INTENT(IN),OPTIONAL              :: cor_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cov
              INTEGER,INTENT(IN),OPTIONAL      :: p_cov_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cor
              INTEGER,INTENT(IN),OPTIONAL      :: p_cor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditpartialcovcor(task, p_idx_array,       &
     &                       cov, cov_storage, cor, cor_storage,         &
     &                       p_cov, p_cov_storage, p_cor, p_cor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: p_idx_array
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: cov
              INTEGER,INTENT(IN),OPTIONAL              :: cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: cor
              INTEGER,INTENT(IN),OPTIONAL              :: cor_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cov
              INTEGER,INTENT(IN),OPTIONAL      :: p_cov_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: p_cor
              INTEGER,INTENT(IN),OPTIONAL      :: p_cor_storage
     end function
      END INTERFACE

!  Editors to modify quantiles related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditquantiles(task, quant_order_n,         &
     &                                 quant_order,quants,               &
     &                                 order_stats, order_stats_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                         :: task
              INTEGER,INTENT(IN),OPTIONAL               :: quant_order_n
              REAL(KIND=8),INTENT(IN),dimension(*),OPTIONAL::quant_order
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL::quants
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL ::           &
     &                                                     order_stats
              INTEGER,INTENT(IN),OPTIONAL  ::      order_stats_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditquantiles(task, quant_order_n,         &
     &                                 quant_order,quants,               &
     &                                 order_stats, order_stats_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                         :: task
              INTEGER,INTENT(IN),OPTIONAL               :: quant_order_n
              REAL(KIND=4),INTENT(IN),dimension(*),OPTIONAL::quant_order
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL::quants
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL ::           &
     &                                                     order_stats
              INTEGER,INTENT(IN),OPTIONAL  ::      order_stats_storage
     end function
      END INTERFACE


!  Editors to modify stream data quantiles related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditstreamquantiles(task,                  &
     &        quant_order_n, quant_order, quants, nparams, params)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                     :: task
              INTEGER,INTENT(IN)                    :: quant_order_n
              REAL(KIND=8),INTENT(IN),dimension(*)  :: quant_order
              REAL(KIND=8),DIMENSION(*),INTENT(IN)  :: quants
              INTEGER,INTENT(IN)                    :: nparams
              REAL(KIND=8),INTENT(IN), DIMENSION(*) :: params
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditstreamquantiles(task,                  &
     &        quant_order_n, quant_order, quants, nparams, params)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                     :: task
              INTEGER,INTENT(IN)                    :: quant_order_n
              REAL(KIND=4),INTENT(IN),dimension(*)  :: quant_order
              REAL(KIND=4),DIMENSION(*),INTENT(IN)  :: quants
              INTEGER,INTENT(IN)                    :: nparams
              REAL(KIND=4),INTENT(IN), DIMENSION(*) :: params
     end function
      END INTERFACE


!  Editors to modify pooled/group variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditpooledcovariance(task, grp_indices,    &
     &           pld_mean, pld_cov, grp_cov_indices, grp_means, grp_cov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: grp_indices
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_mean
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_cov
              INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL ::grp_cov_indices
              REAL(KIND=8),DIMENSION(*),INTENT(IN),OPTIONAL :: grp_means
              REAL(KIND=8),DIMENSION(*),INTENT(IN), OPTIONAL :: grp_cov
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditpooledcovariance(task, grp_indices,    &
     &           pld_mean, pld_cov, grp_cov_indices, grp_means, grp_cov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,DIMENSION(*),INTENT(IN)      :: grp_indices
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_mean
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: pld_cov
              INTEGER,DIMENSION(*),INTENT(IN),OPTIONAL ::grp_cov_indices
              REAL(KIND=4),DIMENSION(*),INTENT(IN),OPTIONAL :: grp_means
              REAL(KIND=4),DIMENSION(*),INTENT(IN), OPTIONAL :: grp_cov
     end function
      END INTERFACE


!  Editors to modify robust variance-covariance matrix
!  related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditrobustcovariance(task,rcov_storage,    &
     &                                      nparams, params,rmean, rcov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,INTENT(IN)                   :: rcov_storage
              INTEGER,INTENT(IN)                   :: nparams
              REAL(KIND=8),INTENT(IN)              :: params(nparams)
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: rmean
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: rcov
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditrobustcovariance(task,rcov_storage,    &
     &                                      nparams, params,rmean, rcov)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              INTEGER,INTENT(IN)                   :: rcov_storage
              INTEGER,INTENT(IN)                   :: nparams
              REAL(KIND=4),INTENT(IN)              :: params(nparams)
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: rmean
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: rcov
     end function
      END INTERFACE


!  Editors to modify outliers detection parameters
      INTERFACE
        INTEGER FUNCTION vsldsseditoutliersdetection(task,               &
     &                                               nparams, params, w)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,INTENT(IN)      :: nparams
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: params(nparams)
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: w
     end function
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION vslssseditoutliersdetection(task,               &
     &                                               nparams, params, w)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)       :: task
              INTEGER,INTENT(IN)      :: nparams
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: params(nparams)
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: w
     end function
      END INTERFACE

!  Editors to modify missing values parameters
      INTERFACE
        INTEGER FUNCTION vsldsseditmissingvalues(task, nparams, params,  &
     &        init_estimates_n, init_estimates,  prior_n, prior,         &
     &        simul_missing_vals_n,simul_missing_vals,                   &
     &        estimates_n, estimates)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)           :: task
              INTEGER,INTENT(IN)          :: nparams
              REAL(KIND=8),INTENT(IN)     :: params(nparams)
              INTEGER,INTENT(IN),OPTIONAL :: init_estimates_n
              REAL(KIND=8),INTENT(IN), DIMENSION(*),OPTIONAL::           &
     &                                       init_estimates
              INTEGER,INTENT(IN),OPTIONAL :: prior_n
              REAL(KIND=8),INTENT(IN),DIMENSION(*),OPTIONAL :: prior
              INTEGER,INTENT(IN),OPTIONAL :: simul_missing_vals_n
              REAL(KIND=8),INTENT(IN),DIMENSION(*),OPTIONAL ::           &
     &                                 simul_missing_vals
              INTEGER,INTENT(IN),OPTIONAL :: estimates_n
              REAL(KIND=8),INTENT(IN), DIMENSION(*), OPTIONAL ::         &
     &                                 estimates
     end function
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION vslssseditmissingvalues(task, nparams, params,  &
     &        init_estimates_n, init_estimates,  prior_n, prior,         &
     &        simul_missing_vals_n,simul_missing_vals,                   &
     &        estimates_n, estimates)
            IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)           :: task
              INTEGER,INTENT(IN)          :: nparams
              REAL(KIND=4),INTENT(IN)     :: params(nparams)
              INTEGER,INTENT(IN),OPTIONAL :: init_estimates_n
              REAL(KIND=4),INTENT(IN), DIMENSION(*),OPTIONAL::           &
     &                                       init_estimates
              INTEGER,INTENT(IN),OPTIONAL :: prior_n
              REAL(KIND=4),INTENT(IN),DIMENSION(*),OPTIONAL :: prior
              INTEGER,INTENT(IN),OPTIONAL :: simul_missing_vals_n
              REAL(KIND=4),INTENT(IN),DIMENSION(*),OPTIONAL ::           &
     &                                 simul_missing_vals
              INTEGER,INTENT(IN),OPTIONAL :: estimates_n
              REAL(KIND=4),INTENT(IN), DIMENSION(*), OPTIONAL ::         &
     &                                 estimates
     end function
      END INTERFACE

    !     Editors to modify matrix parameterization
    !     related parameters
      INTERFACE
       INTEGER FUNCTION vsldsseditcorparameterization (task,             &
     &                             cor, cor_storage, pcor, pcor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: cor
              INTEGER,INTENT(IN)                   :: cor_storage
              REAL(KIND=8),DIMENSION(*),INTENT(IN) :: pcor
              INTEGER,INTENT(IN)                   :: pcor_storage
     end function
      END INTERFACE

      INTERFACE
       INTEGER FUNCTION vslssseditcorparameterization (task,             &
     &                             cor, cor_storage, pcor, pcor_storage)
              IMPORT :: VSL_SS_TASK
              TYPE(VSL_SS_TASK)                    :: task
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: cor
              INTEGER,INTENT(IN)                   :: cor_storage
              REAL(KIND=4),DIMENSION(*),INTENT(IN) :: pcor
              INTEGER,INTENT(IN)                   :: pcor_storage
     end function
      END INTERFACE
  
    !  Task destructor
    INTERFACE
      INTEGER FUNCTION vslssdeletetask(task)
          IMPORT :: VSL_SS_TASK
            TYPE(VSL_SS_TASK)      :: task
     end function
    END INTERFACE
end module onemkl_vsl_omp_offload_lp64

!===============================================================================
! Copyright (C) 2004 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!   Content:
!           Intel(R) oneAPI Math Kernel Library (oneMKL) PARDISO Fortran-90 header file
!
!           Contains PARDISO routine definition.
!           For CDECL use only.
!
!*******************************************************************************
!DEC$ IF .NOT. DEFINED( __MKL_PARDISO_F90 )

!DEC$ DEFINE __MKL_PARDISO_F90

      MODULE MKL_PARDISO_PRIVATE

        TYPE MKL_PARDISO_HANDLE; INTEGER(KIND=8) DUMMY; END TYPE

      END MODULE MKL_PARDISO_PRIVATE

      MODULE MKL_PARDISO
        USE MKL_PARDISO_PRIVATE

!
! Subroutine prototype for PARDISO
!

      INTERFACE PARDISO
        SUBROUTINE PARDISO_S( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR

          REAL(KIND=4),     INTENT(IN)    :: A(*)
          REAL(KIND=4),     INTENT(INOUT) :: B(*)
          REAL(KIND=4),     INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_S

        SUBROUTINE PARDISO_D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR

          REAL(KIND=8),     INTENT(IN)    :: A(*)
          REAL(KIND=8),     INTENT(INOUT) :: B(*)
          REAL(KIND=8),     INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_D

        SUBROUTINE PARDISO_SC( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR

          COMPLEX(KIND=4),  INTENT(IN)    :: A(*)
          COMPLEX(KIND=4),  INTENT(INOUT) :: B(*)
          COMPLEX(KIND=4),  INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_SC

        SUBROUTINE PARDISO_DC( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=8),  INTENT(IN)    :: A(*)
          COMPLEX(KIND=8),  INTENT(INOUT) :: B(*)
          COMPLEX(KIND=8),  INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_DC


        SUBROUTINE PARDISO_S_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR
          REAL(KIND=4),     INTENT(IN)    :: A(*)
          REAL(KIND=4),     INTENT(INOUT) :: B(N,*)
          REAL(KIND=4),     INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_S_2D

        SUBROUTINE PARDISO_D_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR
          REAL(KIND=8),     INTENT(IN)    :: A(*)
          REAL(KIND=8),     INTENT(INOUT) :: B(N,*)
          REAL(KIND=8),     INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_D_2D

        SUBROUTINE PARDISO_SC_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=4),  INTENT(IN)    :: A(*)
          COMPLEX(KIND=4),  INTENT(INOUT) :: B(N,*)
          COMPLEX(KIND=4),  INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_SC_2D

        SUBROUTINE PARDISO_DC_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MAXFCT
          INTEGER,          INTENT(IN)    :: MNUM
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(IN)    :: PHASE
          INTEGER,          INTENT(IN)    :: N
          INTEGER,          INTENT(IN)    :: IA(*)
          INTEGER,          INTENT(IN)    :: JA(*)
          INTEGER,          INTENT(INOUT) :: PERM(*)
          INTEGER,          INTENT(IN)    :: NRHS
          INTEGER,          INTENT(INOUT) :: IPARM(*)
          INTEGER,          INTENT(IN)    :: MSGLVL
          INTEGER,          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=8),  INTENT(IN)    :: A(*)
          COMPLEX(KIND=8),  INTENT(INOUT) :: B(N,*)
          COMPLEX(KIND=8),  INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_DC_2D
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_STORE( PT, STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_STORE
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_STORE_64( PT, STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER*8,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_STORE_64
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_RESTORE( PT, STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_RESTORE
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_RESTORE_64( PT, STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER*8,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_RESTORE_64
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_DELETE( STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_DELETE
      END INTERFACE

      INTERFACE
        SUBROUTINE PARDISO_HANDLE_DELETE_64( STORE_NAME, ERROR )
          USE MKL_PARDISO_PRIVATE
          CHARACTER, INTENT(IN)  :: STORE_NAME(*)
          INTEGER*8,   INTENT(OUT) :: ERROR
        END SUBROUTINE PARDISO_HANDLE_DELETE_64
      END INTERFACE

!
! Subroutine prototype for PARDISO_64
!
! Note: The pardiso_64 interface is not supported on IA-32 architecture.
!       If called on IA-32, error = -12 is returned.
!
      INTERFACE PARDISO_64
        SUBROUTINE PARDISO_S_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          REAL(KIND=4),             INTENT(IN)    :: A(*)
          REAL(KIND=4),             INTENT(INOUT) :: B(*)
          REAL(KIND=4),             INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_S_64

        SUBROUTINE PARDISO_D_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          REAL(KIND=8),             INTENT(IN)    :: A(*)
          REAL(KIND=8),             INTENT(INOUT) :: B(*)
          REAL(KIND=8),             INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_D_64

        SUBROUTINE PARDISO_SC_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=4),          INTENT(IN)    :: A(*)
          COMPLEX(KIND=4),          INTENT(INOUT) :: B(*)
          COMPLEX(KIND=4),          INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_SC_64

        SUBROUTINE PARDISO_DC_64( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=8),          INTENT(IN)    :: A(*)
          COMPLEX(KIND=8),          INTENT(INOUT) :: B(*)
          COMPLEX(KIND=8),          INTENT(OUT)   :: X(*)
        END SUBROUTINE PARDISO_DC_64

        SUBROUTINE PARDISO_S_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          REAL(KIND=4),             INTENT(IN)    :: A(*)
          REAL(KIND=4),             INTENT(INOUT) :: B(N,*)
          REAL(KIND=4),             INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_S_64_2D

        SUBROUTINE PARDISO_D_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          REAL(KIND=8),             INTENT(IN)    :: A(*)
          REAL(KIND=8),             INTENT(INOUT) :: B(N,*)
          REAL(KIND=8),             INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_D_64_2D

        SUBROUTINE PARDISO_SC_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=4),          INTENT(IN)    :: A(*)
          COMPLEX(KIND=4),          INTENT(INOUT) :: B(N,*)
          COMPLEX(KIND=4),          INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_SC_64_2D

        SUBROUTINE PARDISO_DC_64_2D( PT, MAXFCT, MNUM, MTYPE, PHASE, N, A, IA, JA, PERM, NRHS, IPARM, MSGLVL, B, X, ERROR )
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MAXFCT
          INTEGER(KIND=8),          INTENT(IN)    :: MNUM
          INTEGER(KIND=8),          INTENT(IN)    :: MTYPE
          INTEGER(KIND=8),          INTENT(IN)    :: PHASE
          INTEGER(KIND=8),          INTENT(IN)    :: N
          INTEGER(KIND=8),          INTENT(IN)    :: IA(*)
          INTEGER(KIND=8),          INTENT(IN)    :: JA(*)
          INTEGER(KIND=8),          INTENT(INOUT) :: PERM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: NRHS
          INTEGER(KIND=8),          INTENT(INOUT) :: IPARM(*)
          INTEGER(KIND=8),          INTENT(IN)    :: MSGLVL
          INTEGER(KIND=8),          INTENT(OUT)   :: ERROR
          COMPLEX(KIND=8),          INTENT(IN)    :: A(*)
          COMPLEX(KIND=8),          INTENT(INOUT) :: B(N,*)
          COMPLEX(KIND=8),          INTENT(OUT)   :: X(N,*)
        END SUBROUTINE PARDISO_DC_64_2D

      END INTERFACE

      INTERFACE

       SUBROUTINE PARDISOINIT(PT, MTYPE, IPARM)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(OUT) :: PT(*)
          INTEGER,          INTENT(IN)    :: MTYPE
          INTEGER,          INTENT(OUT) :: IPARM(*)
       END SUBROUTINE PARDISOINIT

      END INTERFACE

      INTERFACE PARDISO_PIV

      FUNCTION MKL_PARDISO_PIVOT( AII, BII, EPS)
         REAL(KIND=8)   :: AII, BII, EPS
         INTEGER   MKL_PARDISO_PIVOT
         END
      END INTERFACE PARDISO_PIV

      INTERFACE PARDISO_GETDIAG

         SUBROUTINE PARDISO_GETDIAG_D(PT,DIAG_FACT,DIAG_A,MNUM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          REAL(KIND=8), INTENT(INOUT)      :: DIAG_FACT(*), DIAG_A(*)
          INTEGER, INTENT(IN)            :: MNUM
          INTEGER, INTENT(INOUT)         :: ERROR
         END

         SUBROUTINE PARDISO_GETDIAG_Z(PT,DIAG_FACT,DIAG_A,MNUM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          COMPLEX(KIND=8), INTENT(INOUT)   :: DIAG_FACT(*), DIAG_A(*)
          INTEGER, INTENT(IN)            :: MNUM
          INTEGER, INTENT(INOUT)         :: ERROR
         END

      END INTERFACE PARDISO_GETDIAG

      INTERFACE PARDISO_EXPORT

         SUBROUTINE PARDISO_EXPORT_D(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          REAL(KIND=8)            , INTENT(INOUT) :: VALUES(*)
          INTEGER                 , INTENT(INOUT) :: IA(*), JA(*)
          INTEGER                 , INTENT(IN)    :: STEP
          INTEGER                 , INTENT(INOUT) :: IPARM(*)
          INTEGER                 , INTENT(OUT)   :: ERROR
         END

         SUBROUTINE PARDISO_EXPORT_S(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          REAL(KIND=4)            , INTENT(INOUT) :: VALUES(*)
          INTEGER                 , INTENT(INOUT) :: IA(*), JA(*)
          INTEGER                 , INTENT(IN)    :: STEP
          INTEGER                 , INTENT(INOUT) :: IPARM(*)
          INTEGER                 , INTENT(OUT)   :: ERROR
         END

         SUBROUTINE PARDISO_EXPORT_C(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          COMPLEX(KIND=4)         , INTENT(INOUT) :: VALUES(*)
          INTEGER                 , INTENT(INOUT) :: IA(*), JA(*)
          INTEGER                 , INTENT(IN)    :: STEP
          INTEGER                 , INTENT(INOUT) :: IPARM(*)
          INTEGER                 , INTENT(OUT)   :: ERROR
         END

         SUBROUTINE PARDISO_EXPORT_Z(PT,VALUES,IA,JA,STEP,IPARM,ERROR)
          USE MKL_PARDISO_PRIVATE
          TYPE(MKL_PARDISO_HANDLE), INTENT(INOUT) :: PT(*)
          COMPLEX(KIND=8)         , INTENT(INOUT) :: VALUES(*)
          INTEGER                 , INTENT(INOUT) :: IA(*), JA(*)
          INTEGER                 , INTENT(IN)    :: STEP
          INTEGER                 , INTENT(INOUT) :: IPARM(*)
          INTEGER                 , INTENT(OUT)   :: ERROR
         END

      END INTERFACE PARDISO_EXPORT



      END MODULE MKL_PARDISO

!DEC$ ENDIF

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      Intel(R) oneAPI Math Kernel Library (oneMKL) FORTRAN interface for
!      OpenMP offload for LAPACK
!*******************************************************************************

   interface

      subroutine mkl_lapack_cgebrd_omp_offload_lp64(m, n, a, lda, d, e,&
                                                    tauq, taup, work,  &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      complex*8, intent(out) :: tauq(*)
      complex*8, intent(out) :: taup(*)
      complex*8, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgebrd_omp_offload_lp64

      subroutine mkl_lapack_dgebrd_omp_offload_lp64(m, n, a, lda, d, e,&
                                                    tauq, taup, work,  &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      double precision, intent(out) :: tauq(*)
      double precision, intent(out) :: taup(*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgebrd_omp_offload_lp64

      subroutine mkl_lapack_sgebrd_omp_offload_lp64(m, n, a, lda, d, e,&
                                                    tauq, taup, work,  &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      real, intent(out) :: tauq(*)
      real, intent(out) :: taup(*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgebrd_omp_offload_lp64

      subroutine mkl_lapack_zgebrd_omp_offload_lp64(m, n, a, lda, d, e,&
                                                    tauq, taup, work,  &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      complex*16, intent(out) :: tauq(*)
      complex*16, intent(out) :: taup(*)
      complex*16, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgebrd_omp_offload_lp64

      subroutine mkl_lapack_cgeqrf_omp_offload_lp64(m, n, a, lda, tau, &
                                                    work, lwork,       &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      complex*8, intent(out) :: tau(*)
      complex*8, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgeqrf_omp_offload_lp64

      subroutine mkl_lapack_dgeqrf_omp_offload_lp64(m, n, a, lda, tau, &
                                                    work, lwork,       &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      double precision, intent(out) :: tau(*)
      double precision, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgeqrf_omp_offload_lp64

      subroutine mkl_lapack_sgeqrf_omp_offload_lp64(m, n, a, lda, tau, &
                                                    work, lwork,       &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      real, intent(out) :: tau(*)
      real, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgeqrf_omp_offload_lp64

      subroutine mkl_lapack_zgeqrf_omp_offload_lp64(m, n, a, lda, tau, &
                                                    work, lwork,       &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      complex*16, intent(out) :: tau(*)
      complex*16, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgeqrf_omp_offload_lp64

      subroutine mkl_lapack_cgeqrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      tau, stride_tau, &
                                                      work, lwork,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      complex*8, intent(out) :: tau(stride_tau,*)
      complex*8, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgeqrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgeqrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      tau, stride_tau, &
                                                      work, lwork,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: tau(stride_tau,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgeqrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgeqrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      tau, stride_tau, &
                                                      work, lwork,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      real, intent(out) :: tau(stride_tau,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgeqrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgeqrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      tau, stride_tau, &
                                                      work, lwork,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      complex*16, intent(out) :: tau(stride_tau,*)
      complex*16, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgeqrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgesvd_omp_offload_lp64(jobu, jobvt, m, n, &
                                                    a, lda, s, u, ldu, &
                                                    vt, ldvt, work,    &
                                                    lwork, rwork,      &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: s(*)
      complex*8, intent(out) :: u(ldu,*)
      complex*8, intent(out) :: vt(ldvt,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgesvd_omp_offload_lp64

      subroutine mkl_lapack_zgesvd_omp_offload_lp64(jobu, jobvt, m, n, &
                                                    a, lda, s, u, ldu, &
                                                    vt, ldvt, work,    &
                                                    lwork, rwork,      &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: s(*)
      complex*16, intent(out) :: u(ldu,*)
      complex*16, intent(out) :: vt(ldvt,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgesvd_omp_offload_lp64

      subroutine mkl_lapack_dgesvd_omp_offload_lp64(jobu, jobvt, m, n, &
                                                    a, lda, s, u, ldu, &
                                                    vt, ldvt, work,    &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: s(*)
      double precision, intent(out) :: u(ldu,*)
      double precision, intent(out) :: vt(ldvt,*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgesvd_omp_offload_lp64

      subroutine mkl_lapack_sgesvd_omp_offload_lp64(jobu, jobvt, m, n, &
                                                    a, lda, s, u, ldu, &
                                                    vt, ldvt, work,    &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: s(*)
      real, intent(out) :: u(ldu,*)
      real, intent(out) :: vt(ldvt,*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgesvd_omp_offload_lp64

      subroutine mkl_lapack_cgesvda_batch_omp_offload_lp64(iparm,      &
                                                         irank, m, n,  &
                                                         a, lda,       &
                                                         stride_a, s,  &
                                                         stride_s, u,  &
                                                         ldu, stride_u,&
                                                         vt, ldvt,     &
                                                         stride_vt,    &
                                                         tolerance,    &
                                                         residual,     &
                                                         work, lwork,  &
                                                         batch_size,   &
                                                         info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      real, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      real, intent(out) :: s(stride_s,*)
      complex*8, intent(out) :: u(stride_u,*)
      complex*8, intent(out) :: vt(stride_u,*)
      real, intent(out) :: residual(*)
      complex*8, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      end subroutine mkl_lapack_cgesvda_batch_omp_offload_lp64

      subroutine mkl_lapack_cgetrf_omp_offload_lp64(m, n, a, lda, ipiv,&
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrf_omp_offload_lp64

      subroutine mkl_lapack_dgesvda_batch_omp_offload_lp64(iparm,      &
                                                         irank, m, n,  &
                                                         a, lda,       &
                                                         stride_a, s,  &
                                                         stride_s, u,  &
                                                         ldu, stride_u,&
                                                         vt, ldvt,     &
                                                         stride_vt,    &
                                                         tolerance,    &
                                                         residual,     &
                                                         work, lwork,  &
                                                         batch_size,   &
                                                         info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      double precision, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: s(stride_s,*)
      double precision, intent(out) :: u(stride_u,*)
      double precision, intent(out) :: vt(stride_u,*)
      double precision, intent(out) :: residual(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      end subroutine mkl_lapack_dgesvda_batch_omp_offload_lp64

      subroutine mkl_lapack_dgetrf_omp_offload_lp64(m, n, a, lda, ipiv,&
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrf_omp_offload_lp64

      subroutine mkl_lapack_sgesvda_batch_omp_offload_lp64(iparm,      &
                                                         irank, m, n,  &
                                                         a, lda,       &
                                                         stride_a, s,  &
                                                         stride_s, u,  &
                                                         ldu, stride_u,&
                                                         vt, ldvt,     &
                                                         stride_vt,    &
                                                         tolerance,    &
                                                         residual,     &
                                                         work, lwork,  &
                                                         batch_size,   &
                                                         info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      real, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      real, intent(out) :: s(stride_s,*)
      real, intent(out) :: u(stride_u,*)
      real, intent(out) :: vt(stride_u,*)
      real, intent(out) :: residual(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      end subroutine mkl_lapack_sgesvda_batch_omp_offload_lp64

      subroutine mkl_lapack_sgetrf_omp_offload_lp64(m, n, a, lda, ipiv,&
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrf_omp_offload_lp64

      subroutine mkl_lapack_zgesvda_batch_omp_offload_lp64(iparm,      &
                                                         irank, m, n,  &
                                                         a, lda,       &
                                                         stride_a, s,  &
                                                         stride_s, u,  &
                                                         ldu, stride_u,&
                                                         vt, ldvt,     &
                                                         stride_vt,    &
                                                         tolerance,    &
                                                         residual,     &
                                                         work, lwork,  &
                                                         batch_size,   &
                                                         info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      double precision, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: s(stride_s,*)
      complex*16, intent(out) :: u(stride_u,*)
      complex*16, intent(out) :: vt(stride_u,*)
      double precision, intent(out) :: residual(*)
      complex*16, intent(out) :: work(*)
      integer, intent(out) :: info(*)
      end subroutine mkl_lapack_zgesvda_batch_omp_offload_lp64

      subroutine mkl_lapack_zgetrf_omp_offload_lp64(m, n, a, lda, ipiv,&
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrf_omp_offload_lp64

      subroutine mkl_lapack_cgetrf_batch_omp_offload_lp64(m, n, a, lda, ipiv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrf_batch_omp_offload_lp64

      subroutine mkl_lapack_dgetrf_batch_omp_offload_lp64(m, n, a, lda, ipiv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrf_batch_omp_offload_lp64

      subroutine mkl_lapack_sgetrf_batch_omp_offload_lp64(m, n, a, lda, ipiv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrf_batch_omp_offload_lp64

      subroutine mkl_lapack_zgetrf_batch_omp_offload_lp64(m, n, a, lda, ipiv,       &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: ipiv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrf_batch_omp_offload_lp64

      subroutine mkl_lapack_cgetrfnp_batch_omp_offload_lp64(m, n, a, lda,           &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrfnp_batch_omp_offload_lp64

      subroutine mkl_lapack_dgetrfnp_batch_omp_offload_lp64(m, n, a, lda,           &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrfnp_batch_omp_offload_lp64

      subroutine mkl_lapack_sgetrfnp_batch_omp_offload_lp64(m, n, a, lda,           &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrfnp_batch_omp_offload_lp64

      subroutine mkl_lapack_zgetrfnp_batch_omp_offload_lp64(m, n, a, lda,           &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrfnp_batch_omp_offload_lp64

      subroutine mkl_lapack_cgetri_oop_batch_omp_offload_lp64(n, a, lda, ipiv, ainv, ldainv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldainv
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetri_oop_batch_omp_offload_lp64

      subroutine mkl_lapack_dgetri_oop_batch_omp_offload_lp64(n, a, lda, ipiv, ainv, ldainv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldainv
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetri_oop_batch_omp_offload_lp64

      subroutine mkl_lapack_sgetri_oop_batch_omp_offload_lp64(n, a, lda, ipiv, ainv, ldainv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldainv
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetri_oop_batch_omp_offload_lp64

      subroutine mkl_lapack_zgetri_oop_batch_omp_offload_lp64(n, a, lda, ipiv, ainv, ldainv, &
                                                           group_count, group_size, &
                                                           info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldainv
      integer, intent(in) :: group_count
      integer, intent(in) :: group_size(*)
      integer, intent(out) :: info(*)
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetri_oop_batch_omp_offload_lp64

      subroutine mkl_lapack_cgetrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      ipiv,            &
                                                      stride_ipiv,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgetrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      ipiv,            &
                                                      stride_ipiv,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgetrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      ipiv,            &
                                                      stride_ipiv,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgetrf_batch_strided_omp_offload_lp64(m, n,&
                                                      a, lda, stride_a,&
                                                      ipiv,            &
                                                      stride_ipiv,     &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgetri_omp_offload_lp64(n, a, lda, ipiv,   &
                                                    work, lwork, info, &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*8, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetri_omp_offload_lp64

      subroutine mkl_lapack_dgetri_omp_offload_lp64(n, a, lda, ipiv,   &
                                                    work, lwork, info, &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetri_omp_offload_lp64

      subroutine mkl_lapack_sgetri_omp_offload_lp64(n, a, lda, ipiv,   &
                                                    work, lwork, info, &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetri_omp_offload_lp64

      subroutine mkl_lapack_zgetri_omp_offload_lp64(n, a, lda, ipiv,   &
                                                    work, lwork, info, &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*16, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetri_omp_offload_lp64

      subroutine mkl_lapack_cgetri_oop_batch_strided_omp_offload_lp64(n,&
                                                          a, lda,       &
                                                          stride_a,     &
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          ainv, ldainv, &
                                                          stride_ainv,  &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*8, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetri_oop_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgetri_oop_batch_strided_omp_offload_lp64(n,&
                                                          a, lda,       &
                                                          stride_a,     &
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          ainv, ldainv, &
                                                          stride_ainv,  &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      double precision, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetri_oop_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgetri_oop_batch_strided_omp_offload_lp64(n,&
                                                          a, lda,       &
                                                          stride_a,     &
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          ainv, ldainv, &
                                                          stride_ainv,  &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      real, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetri_oop_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgetri_oop_batch_strided_omp_offload_lp64(n,&
                                                          a, lda,       &
                                                          stride_a,     &
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          ainv, ldainv, &
                                                          stride_ainv,  &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*16, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetri_oop_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgetrs_omp_offload_lp64(trans, n, nrhs, a, &
                                                    lda, ipiv, b, ldb, &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*8, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrs_omp_offload_lp64

      subroutine mkl_lapack_dgetrs_omp_offload_lp64(trans, n, nrhs, a, &
                                                    lda, ipiv, b, ldb, &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      double precision, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrs_omp_offload_lp64

      subroutine mkl_lapack_sgetrs_omp_offload_lp64(trans, n, nrhs, a, &
                                                    lda, ipiv, b, ldb, &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      real, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrs_omp_offload_lp64

      subroutine mkl_lapack_zgetrs_omp_offload_lp64(trans, n, nrhs, a, &
                                                    lda, ipiv, b, ldb, &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*16, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrs_omp_offload_lp64

      subroutine mkl_lapack_cheev_omp_offload_lp64(jobz, uplo, n, a,   &
                                                   lda, w, work, lwork,&
                                                   rwork, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cheev_omp_offload_lp64

      subroutine mkl_lapack_zheev_omp_offload_lp64(jobz, uplo, n, a,   &
                                                   lda, w, work, lwork,&
                                                   rwork, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zheev_omp_offload_lp64

      subroutine mkl_lapack_cheevd_omp_offload_lp64(jobz, uplo, n, a,  &
                                                    lda, w, work,      &
                                                    lwork, rwork,      &
                                                    lrwork, iwork,     &
                                                    liwork, info,      &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cheevd_omp_offload_lp64

      subroutine mkl_lapack_zheevd_omp_offload_lp64(jobz, uplo, n, a,  &
                                                    lda, w, work,      &
                                                    lwork, rwork,      &
                                                    lrwork, iwork,     &
                                                    liwork, info,      &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zheevd_omp_offload_lp64

      subroutine mkl_lapack_cheevx_omp_offload_lp64(jobz, range, uplo, &
                                                    n, a, lda, vl, vu, &
                                                    il, iu, abstol, m, &
                                                    w, z, ldz, work,   &
                                                    lwork, rwork,      &
                                                    iwork, ifail, info,&
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: z(ldz,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cheevx_omp_offload_lp64

      subroutine mkl_lapack_zheevx_omp_offload_lp64(jobz, range, uplo, &
                                                    n, a, lda, vl, vu, &
                                                    il, iu, abstol, m, &
                                                    w, z, ldz, work,   &
                                                    lwork, rwork,      &
                                                    iwork, ifail, info,&
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: z(ldz,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zheevx_omp_offload_lp64

      subroutine mkl_lapack_chegvd_omp_offload_lp64(itype, jobz, uplo, &
                                                    n, a, lda, b, ldb, &
                                                    w, work, lwork,    &
                                                    rwork, lrwork,     &
                                                    iwork, liwork,     &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_chegvd_omp_offload_lp64

      subroutine mkl_lapack_zhegvd_omp_offload_lp64(itype, jobz, uplo, &
                                                    n, a, lda, b, ldb, &
                                                    w, work, lwork,    &
                                                    rwork, lrwork,     &
                                                    iwork, liwork,     &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zhegvd_omp_offload_lp64

      subroutine mkl_lapack_chegvx_omp_offload_lp64(itype, jobz, range,&
                                                    uplo, n, a, lda, b,&
                                                    ldb, vl, vu, il,   &
                                                    iu, abstol, m, w,  &
                                                    z, ldz, work,      &
                                                    lwork, rwork,      &
                                                    iwork, ifail, info,&
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: z(ldz,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_chegvx_omp_offload_lp64

      subroutine mkl_lapack_zhegvx_omp_offload_lp64(itype, jobz, range,&
                                                    uplo, n, a, lda, b,&
                                                    ldb, vl, vu, il,   &
                                                    iu, abstol, m, w,  &
                                                    z, ldz, work,      &
                                                    lwork, rwork,      &
                                                    iwork, ifail, info,&
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: z(ldz,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zhegvx_omp_offload_lp64

      subroutine mkl_lapack_chetrd_omp_offload_lp64(uplo, n, a, lda, d,&
                                                    e, tau, work,      &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      complex*8, intent(out) :: tau(*)
      complex*8, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_chetrd_omp_offload_lp64

      subroutine mkl_lapack_zhetrd_omp_offload_lp64(uplo, n, a, lda, d,&
                                                    e, tau, work,      &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      complex*16, intent(out) :: tau(*)
      complex*16, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zhetrd_omp_offload_lp64

      subroutine mkl_lapack_dorgqr_omp_offload_lp64(m, n, k, a, lda,   &
                                                    tau, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(in) :: tau(*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dorgqr_omp_offload_lp64

      subroutine mkl_lapack_sorgqr_omp_offload_lp64(m, n, k, a, lda,   &
                                                    tau, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(in) :: tau(*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sorgqr_omp_offload_lp64

      subroutine mkl_lapack_dormqr_omp_offload_lp64(side, trans, m, n, &
                                                    k, a, lda, tau, c, &
                                                    ldc, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      double precision, intent(in) :: tau(*)
      double precision, intent(inout) :: c(ldc,*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dormqr_omp_offload_lp64

      subroutine mkl_lapack_sormqr_omp_offload_lp64(side, trans, m, n, &
                                                    k, a, lda, tau, c, &
                                                    ldc, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      real, intent(in) :: tau(*)
      real, intent(inout) :: c(ldc,*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sormqr_omp_offload_lp64

      subroutine mkl_lapack_csteqr_omp_offload_lp64(compz, n, d, e, z, &
                                                    ldz, work,         &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      real, intent(inout) :: d(*)
      real, intent(inout) :: e(*)
      complex*8, intent(inout) :: z(ldz,*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_csteqr_omp_offload_lp64

      subroutine mkl_lapack_dsteqr_omp_offload_lp64(compz, n, d, e, z, &
                                                    ldz, work,         &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      double precision, intent(inout) :: d(*)
      double precision, intent(inout) :: e(*)
      double precision, intent(inout) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsteqr_omp_offload_lp64

      subroutine mkl_lapack_ssteqr_omp_offload_lp64(compz, n, d, e, z, &
                                                    ldz, work,         &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      real, intent(inout) :: d(*)
      real, intent(inout) :: e(*)
      real, intent(inout) :: z(ldz,*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssteqr_omp_offload_lp64

      subroutine mkl_lapack_zsteqr_omp_offload_lp64(compz, n, d, e, z, &
                                                    ldz, work,         &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      double precision, intent(inout) :: d(*)
      double precision, intent(inout) :: e(*)
      complex*16, intent(inout) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zsteqr_omp_offload_lp64

      subroutine mkl_lapack_dsyev_omp_offload_lp64(jobz, uplo, n, a,   &
                                                   lda, w, work, lwork,&
                                                   info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsyev_omp_offload_lp64

      subroutine mkl_lapack_ssyev_omp_offload_lp64(jobz, uplo, n, a,   &
                                                   lda, w, work, lwork,&
                                                   info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssyev_omp_offload_lp64

      subroutine mkl_lapack_dsyevd_omp_offload_lp64(jobz, uplo, n, a,  &
                                                    lda, w, work,      &
                                                    lwork, iwork,      &
                                                    liwork, info,      &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsyevd_omp_offload_lp64

      subroutine mkl_lapack_ssyevd_omp_offload_lp64(jobz, uplo, n, a,  &
                                                    lda, w, work,      &
                                                    lwork, iwork,      &
                                                    liwork, info,      &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssyevd_omp_offload_lp64

      subroutine mkl_lapack_dsyevx_omp_offload_lp64(jobz, range, uplo, &
                                                    n, a, lda, vl, vu, &
                                                    il, iu, abstol, m, &
                                                    w, z, ldz, work,   &
                                                    lwork, iwork,      &
                                                    ifail, info,       &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsyevx_omp_offload_lp64

      subroutine mkl_lapack_ssyevx_omp_offload_lp64(jobz, range, uplo, &
                                                    n, a, lda, vl, vu, &
                                                    il, iu, abstol, m, &
                                                    w, z, ldz, work,   &
                                                    lwork, iwork,      &
                                                    ifail, info,       &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: z(ldz,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssyevx_omp_offload_lp64

      subroutine mkl_lapack_dsygvd_omp_offload_lp64(itype, jobz, uplo, &
                                                    n, a, lda, b, ldb, &
                                                    w, work, lwork,    &
                                                    iwork, liwork,     &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsygvd_omp_offload_lp64

      subroutine mkl_lapack_ssygvd_omp_offload_lp64(itype, jobz, uplo, &
                                                    n, a, lda, b, ldb, &
                                                    w, work, lwork,    &
                                                    iwork, liwork,     &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssygvd_omp_offload_lp64

      subroutine mkl_lapack_dsygvx_omp_offload_lp64(itype, jobz, range,&
                                                    uplo, n, a, lda, b,&
                                                    ldb, vl, vu, il,   &
                                                    iu, abstol, m, w,  &
                                                    z, ldz, work,      &
                                                    lwork, iwork,      &
                                                    ifail, info,       &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsygvx_omp_offload_lp64

      subroutine mkl_lapack_ssygvx_omp_offload_lp64(itype, jobz, range,&
                                                    uplo, n, a, lda, b,&
                                                    ldb, vl, vu, il,   &
                                                    iu, abstol, m, w,  &
                                                    z, ldz, work,      &
                                                    lwork, iwork,      &
                                                    ifail, info,       &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      real, intent(out) :: z(ldz,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssygvx_omp_offload_lp64

      subroutine mkl_lapack_dsytrd_omp_offload_lp64(uplo, n, a, lda, d,&
                                                    e, tau, work,      &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      double precision, intent(out) :: tau(*)
      double precision, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dsytrd_omp_offload_lp64

      subroutine mkl_lapack_ssytrd_omp_offload_lp64(uplo, n, a, lda, d,&
                                                    e, tau, work,      &
                                                    lwork,             &
                                                    info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      real, intent(out) :: tau(*)
      real, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ssytrd_omp_offload_lp64

      subroutine mkl_lapack_ctrtri_omp_offload_lp64(uplo, diag, n, a,  &
                                                     lda, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ctrtri_omp_offload_lp64

      subroutine mkl_lapack_dtrtri_omp_offload_lp64(uplo, diag, n, a,  &
                                                     lda, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dtrtri_omp_offload_lp64

      subroutine mkl_lapack_strtri_omp_offload_lp64(uplo, diag, n, a,  &
                                                     lda, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_strtri_omp_offload_lp64

      subroutine mkl_lapack_ztrtri_omp_offload_lp64(uplo, diag, n, a,  &
                                                     lda, info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ztrtri_omp_offload_lp64

      subroutine mkl_lapack_ctrtrs_omp_offload_lp64(uplo, trans, diag, &
                                                    n, nrhs, a, lda, b,&
                                                    ldb, info,         &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ctrtrs_omp_offload_lp64

      subroutine mkl_lapack_dtrtrs_omp_offload_lp64(uplo, trans, diag, &
                                                    n, nrhs, a, lda, b,&
                                                    ldb, info,         &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dtrtrs_omp_offload_lp64

      subroutine mkl_lapack_strtrs_omp_offload_lp64(uplo, trans, diag, &
                                                    n, nrhs, a, lda, b,&
                                                    ldb, info,         &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_strtrs_omp_offload_lp64

      subroutine mkl_lapack_ztrtrs_omp_offload_lp64(uplo, trans, diag, &
                                                    n, nrhs, a, lda, b,&
                                                    ldb, info,         &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_ztrtrs_omp_offload_lp64

      subroutine mkl_lapack_cungqr_omp_offload_lp64(m, n, k, a, lda,   &
                                                    tau, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(in) :: tau(*)
      complex*8, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cungqr_omp_offload_lp64

      subroutine mkl_lapack_zungqr_omp_offload_lp64(m, n, k, a, lda,   &
                                                    tau, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(in) :: tau(*)
      complex*16, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zungqr_omp_offload_lp64

      subroutine mkl_lapack_cunmqr_omp_offload_lp64(side, trans, m, n, &
                                                    k, a, lda, tau, c, &
                                                    ldc, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      complex*8, intent(in) :: tau(*)
      complex*8, intent(inout) :: c(ldc,*)
      complex*8, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cunmqr_omp_offload_lp64

      subroutine mkl_lapack_zunmqr_omp_offload_lp64(side, trans, m, n, &
                                                    k, a, lda, tau, c, &
                                                    ldc, work, lwork,  &
                                                    info,              &
                                                    interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      complex*16, intent(in) :: tau(*)
      complex*16, intent(inout) :: c(ldc,*)
      complex*16, intent(out) :: work(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zunmqr_omp_offload_lp64

      subroutine mkl_lapack_cgetrs_batch_strided_omp_offload_lp64(trans,&
                                                          n, nrhs, a,   &
                                                          lda, stride_a,&
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          b, ldb,       &
                                                          stride_b,     &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*8, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrs_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgetrs_batch_strided_omp_offload_lp64(trans,&
                                                          n, nrhs, a,   &
                                                          lda, stride_a,&
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          b, ldb,       &
                                                          stride_b,     &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      double precision, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrs_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgetrs_batch_strided_omp_offload_lp64(trans,&
                                                          n, nrhs, a,   &
                                                          lda, stride_a,&
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          b, ldb,       &
                                                          stride_b,     &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      real, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrs_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgetrs_batch_strided_omp_offload_lp64(trans,&
                                                          n, nrhs, a,   &
                                                          lda, stride_a,&
                                                          ipiv,         &
                                                          stride_ipiv,  &
                                                          b, ldb,       &
                                                          stride_b,     &
                                                          batch_size,   &
                                                          info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*16, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrs_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgetrfnp_omp_offload_lp64(m, n, a, lda,    &
                                                      info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrfnp_omp_offload_lp64

      subroutine mkl_lapack_cgetrfnp_batch_strided_omp_offload_lp64(m, &
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrfnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgetrfnp_omp_offload_lp64(m, n, a, lda,    &
                                                      info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrfnp_omp_offload_lp64

      subroutine mkl_lapack_dgetrfnp_batch_strided_omp_offload_lp64(m, &
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrfnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgetrfnp_omp_offload_lp64(m, n, a, lda,    &
                                                      info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrfnp_omp_offload_lp64

      subroutine mkl_lapack_sgetrfnp_batch_strided_omp_offload_lp64(m, &
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrfnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgetrfnp_omp_offload_lp64(m, n, a, lda,    &
                                                      info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrfnp_omp_offload_lp64

      subroutine mkl_lapack_zgetrfnp_batch_strided_omp_offload_lp64(m, &
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrfnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgetrsnp_batch_strided_omp_offload_lp64(trans,&
                                                            n, nrhs, a,   &
                                                            lda, stride_a,&
                                                            b, ldb,       &
                                                            stride_b,     &
                                                            batch_size,   &
                                                            info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      complex*8, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgetrsnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgetrsnp_batch_strided_omp_offload_lp64(trans,&
                                                            n, nrhs, a,   &
                                                            lda, stride_a,&
                                                            b, ldb,       &
                                                            stride_b,     &
                                                            batch_size,   &
                                                            info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      double precision, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgetrsnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_sgetrsnp_batch_strided_omp_offload_lp64(trans,&
                                                            n, nrhs, a,   &
                                                            lda, stride_a,&
                                                            b, ldb,       &
                                                            stride_b,     &
                                                            batch_size,   &
                                                            info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      real, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgetrsnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgetrsnp_batch_strided_omp_offload_lp64(trans,&
                                                            n, nrhs, a,   &
                                                            lda, stride_a,&
                                                            b, ldb,       &
                                                            stride_b,     &
                                                            batch_size,   &
                                                            info, interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      complex*16, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgetrsnp_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dpotrf_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        double precision, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dpotrf_omp_offload_lp64

      subroutine mkl_lapack_spotrf_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        real, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_spotrf_omp_offload_lp64

      subroutine mkl_lapack_cpotrf_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        complex*8, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cpotrf_omp_offload_lp64

      subroutine mkl_lapack_zpotrf_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        complex*16, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zpotrf_omp_offload_lp64


      subroutine mkl_lapack_dpotrf_batch_strided_omp_offload_lp64(uplo,&
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dpotrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_spotrf_batch_strided_omp_offload_lp64(uplo,&
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_spotrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cpotrf_batch_strided_omp_offload_lp64(uplo,&
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cpotrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zpotrf_batch_strided_omp_offload_lp64(uplo,&
                                                      n, a, lda,       &
                                                      stride_a,        &
                                                      batch_size, info,&
                                                      interop) bind(c)
      use, intrinsic :: iso_c_binding
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
      type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zpotrf_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dpotri_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        double precision, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dpotri_omp_offload_lp64

      subroutine mkl_lapack_spotri_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        real, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_spotri_omp_offload_lp64

      subroutine mkl_lapack_cpotri_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        complex*8, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cpotri_omp_offload_lp64

      subroutine mkl_lapack_zpotri_omp_offload_lp64(uplo, n, a, lda, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n
        complex*16, intent(inout) :: a(lda,*)
        integer, intent(in) :: lda
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zpotri_omp_offload_lp64



      subroutine mkl_lapack_dpotrs_omp_offload_lp64(uplo, n, nrhs, a, lda, b, ldb, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n, nrhs, lda, ldb
        double precision, intent(in) :: a(lda,*)
        double precision, intent(inout) :: b(ldb,*)
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dpotrs_omp_offload_lp64

      subroutine mkl_lapack_spotrs_omp_offload_lp64(uplo, n, nrhs, a, lda, b, ldb, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n, nrhs, lda, ldb
        real, intent(in) :: a(lda,*)
        real, intent(inout) :: b(ldb,*)
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_spotrs_omp_offload_lp64

      subroutine mkl_lapack_cpotrs_omp_offload_lp64(uplo, n, nrhs, a, lda, b, ldb, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n, nrhs, lda, ldb
        complex*8, intent(in) :: a(lda,*)
        complex*8, intent(inout) :: b(ldb,*)
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cpotrs_omp_offload_lp64

      subroutine mkl_lapack_zpotrs_omp_offload_lp64(uplo, n, nrhs, a, lda, b, ldb, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: uplo
        integer, intent(in) :: n, nrhs, lda, ldb
        complex*16, intent(in) :: a(lda,*)
        complex*16, intent(inout) :: b(ldb,*)
        integer, intent(out) :: info
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zpotrs_omp_offload_lp64

      subroutine mkl_lapack_sgels_batch_strided_omp_offload_lp64(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: trans
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: nrhs
        integer, intent(in) :: lda
        integer, intent(in) :: stride_a
        integer, intent(in) :: ldb
        integer, intent(in) :: stride_b
        integer, intent(in) :: batch_size
        real,    intent(inout) :: a(stride_a,*)
        real,    intent(inout) :: b(stride_b,*)
        integer, intent(out) :: info(*)
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_sgels_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_dgels_batch_strided_omp_offload_lp64(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: trans
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: nrhs
        integer, intent(in) :: lda
        integer, intent(in) :: stride_a
        integer, intent(in) :: ldb
        integer, intent(in) :: stride_b
        integer, intent(in) :: batch_size
        double precision, intent(inout) :: a(stride_a,*)
        double precision, intent(inout) :: b(stride_b,*)
        integer, intent(out) :: info(*)
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_dgels_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_cgels_batch_strided_omp_offload_lp64(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: trans
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: nrhs
        integer, intent(in) :: lda
        integer, intent(in) :: stride_a
        integer, intent(in) :: ldb
        integer, intent(in) :: stride_b
        integer, intent(in) :: batch_size
        complex*8, intent(inout) :: a(stride_a,*)
        complex*8, intent(inout) :: b(stride_b,*)
        integer, intent(out) :: info(*)
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_cgels_batch_strided_omp_offload_lp64

      subroutine mkl_lapack_zgels_batch_strided_omp_offload_lp64(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info, interop) bind(c)
        use, intrinsic :: iso_c_binding
        character*1, intent(in) :: trans
        integer, intent(in) :: m
        integer, intent(in) :: n
        integer, intent(in) :: nrhs
        integer, intent(in) :: lda
        integer, intent(in) :: stride_a
        integer, intent(in) :: ldb
        integer, intent(in) :: stride_b
        integer, intent(in) :: batch_size
        complex*16, intent(inout) :: a(stride_a,*)
        complex*16, intent(inout) :: b(stride_b,*)
        integer, intent(out) :: info(*)
        type(c_ptr), intent(in), value :: interop
      end subroutine mkl_lapack_zgels_batch_strided_omp_offload_lp64

   end interface

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      Intel(R) oneAPI Math Kernel Library (oneMKL) FORTRAN interface for BLAS
!      OpenMP offload
!*******************************************************************************

  interface

     ! Matrix transposition and copy API

     subroutine mkl_blas_simatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, ab, lda, ldb, stride, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       real,intent(in)                :: alpha
       real,intent(inout)             :: ab( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_simatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_dimatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, ab, lda, ldb, stride, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       double precision,intent(in)    :: alpha
       double precision,intent(inout) :: ab( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dimatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_cimatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, ab, lda, ldb, stride, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       complex,intent(in)             :: alpha
       complex,intent(inout)          :: ab( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cimatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zimatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, ab, lda, ldb, stride, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb, stride, batch_size
       complex*16,intent(in)          :: alpha
       complex*16,intent(inout)       :: ab( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zimatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_somatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       real,intent(in)                :: alpha
       real,intent(in)                :: a( lda, * )
       real,intent(inout)             :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_somatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_domatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       double precision,intent(in)    :: alpha
       double precision,intent(in)    :: a( lda, * )
       double precision,intent(inout) :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_domatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_comatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       complex,intent(in)             :: alpha
       complex,intent(in)             :: a( lda, * )
       complex,intent(inout)          :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_comatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zomatcopy_batch_strided_omp_offload_lp64 ( ordering, trans, rows,       &
          &cols, alpha, a, lda, stridea, b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, trans
       integer,intent(in)             :: rows, cols, lda, ldb
       integer,intent(in)             :: stridea, strideb, batch_size
       complex*16,intent(in)          :: alpha
       complex*16,intent(in)          :: a( lda, * )
       complex*16,intent(inout)       :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zomatcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_somatadd_batch_strided_omp_offload_lp64 ( ordering, transa, transb,      &
          &rows, cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc, stridec,            &
          &batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       real,intent(in)                :: alpha, beta
       real,intent(in)                :: a( lda, * )
       real,intent(in)                :: b( ldb, * )
       real,intent(inout)             :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_somatadd_batch_strided_omp_offload_lp64

     subroutine mkl_blas_domatadd_batch_strided_omp_offload_lp64 ( ordering, transa, transb,      &
          &rows, cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc, stridec,            &
          &batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       double precision,intent(in)    :: alpha, beta
       double precision,intent(in)    :: a( lda, * )
       double precision,intent(in)    :: b( ldb, * )
       double precision,intent(inout) :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_domatadd_batch_strided_omp_offload_lp64

     subroutine mkl_blas_comatadd_batch_strided_omp_offload_lp64 ( ordering, transa, transb,      &
          &rows, cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc, stridec,            &
          &batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       complex,intent(in)             :: alpha, beta
       complex,intent(in)             :: a( lda, * )
       complex,intent(in)             :: b( ldb, * )
       complex,intent(inout)          :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_comatadd_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zomatadd_batch_strided_omp_offload_lp64 ( ordering, transa, transb,      &
          &rows, cols, alpha, a, lda, stridea, beta, b, ldb, strideb, c, ldc, stridec,            &
          &batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering, transa, transb
       integer,intent(in)             :: rows, cols, lda, ldb, ldc
       integer,intent(in)             :: stridea, strideb, stridec, batch_size
       complex*16,intent(in)          :: alpha, beta
       complex*16,intent(in)          :: a( lda, * )
       complex*16,intent(in)          :: b( ldb, * )
       complex*16,intent(inout)       :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zomatadd_batch_strided_omp_offload_lp64

     subroutine mkl_blas_simatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       real,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_simatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_dimatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       double precision,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dimatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_cimatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cimatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_zimatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, ab_array, lda_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex*16,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  ab_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zimatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_somatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       real,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_somatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_domatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       double precision,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_domatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_comatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_comatcopy_batch_omp_offload_lp64

     subroutine mkl_blas_zomatcopy_batch_omp_offload_lp64 ( ordering, trans_array, rows_array,          &
          &cols_array, alpha_array, a_array, lda_array, b_array, ldb_array, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)         :: ordering
       character*1,intent(in)         :: trans_array(*)
       integer,intent(in)             :: rows_array(*), cols_array(*), lda_array(*), ldb_array(*), group_count, group_size(*)
       complex*16,intent(in)                :: alpha_array(*)
       integer(KIND=C_INTPTR_T),intent(in)  ::  a_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  ::  b_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zomatcopy_batch_omp_offload_lp64

     ! BLAS Level3

     subroutine mkl_blas_dgemm_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemm_omp_offload_lp64

     subroutine mkl_blas_sgemm_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemm_omp_offload_lp64

     subroutine mkl_blas_zgemm_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm_omp_offload_lp64

     subroutine mkl_blas_cgemm_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm_omp_offload_lp64

     subroutine mkl_blas_zgemm3m_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm3m_omp_offload_lp64

     subroutine mkl_blas_cgemm3m_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm3m_omp_offload_lp64
     
     subroutine mkl_blas_gemm_s8u8s32_omp_offload_lp64 ( transa, transb, offsetc, m, n, k,       &
          &alpha, a, lda, ao, b, ldb, bo, beta, c, ldc, co, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)          :: transa, transb, offsetc
       integer,intent(in)              :: m, n, k, lda, ldb, ldc
       integer*1,intent(in)            :: ao, bo
       real,intent(in)                 :: alpha, beta
       integer*1,intent(in)            :: a( lda, * ), b (ldb, * )
       integer*4,intent(inout)         :: c( ldc, * )
       integer*4,intent(in)            :: co( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_gemm_s8u8s32_omp_offload_lp64

     subroutine mkl_blas_dsymm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsymm_omp_offload_lp64

     subroutine mkl_blas_ssymm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssymm_omp_offload_lp64

     subroutine mkl_blas_zsymm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zsymm_omp_offload_lp64

     subroutine mkl_blas_csymm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csymm_omp_offload_lp64

     subroutine mkl_blas_zhemm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhemm_omp_offload_lp64

     subroutine mkl_blas_chemm_omp_offload_lp64 ( side, uplo, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chemm_omp_offload_lp64

     subroutine mkl_blas_dsyrk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyrk_omp_offload_lp64

     subroutine mkl_blas_ssyrk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyrk_omp_offload_lp64

     subroutine mkl_blas_zsyrk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zsyrk_omp_offload_lp64

     subroutine mkl_blas_csyrk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csyrk_omp_offload_lp64

     subroutine mkl_blas_zherk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldc
       double precision,intent(in)        :: alpha, beta
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zherk_omp_offload_lp64

     subroutine mkl_blas_cherk_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldc
       real,intent(in)                     :: alpha, beta
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cherk_omp_offload_lp64

     subroutine mkl_blas_dsyr2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyr2k_omp_offload_lp64

     subroutine mkl_blas_ssyr2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyr2k_omp_offload_lp64

     subroutine mkl_blas_zsyr2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zsyr2k_omp_offload_lp64

     subroutine mkl_blas_csyr2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csyr2k_omp_offload_lp64

     subroutine mkl_blas_zher2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, trans
       integer,intent(in)                 :: n, k, lda, ldb, ldc
       double precision,intent(in)        :: beta
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zher2k_omp_offload_lp64

     subroutine mkl_blas_cher2k_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, ldb, ldc
       real,intent(in)                     :: beta
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cher2k_omp_offload_lp64

     subroutine mkl_blas_dtrmm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrmm_omp_offload_lp64

     subroutine mkl_blas_strmm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strmm_omp_offload_lp64

     subroutine mkl_blas_ztrmm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrmm_omp_offload_lp64

     subroutine mkl_blas_ctrmm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrmm_omp_offload_lp64

     subroutine mkl_blas_strmm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       real,intent(in)                    :: alpha, beta
       real,intent(in)                    :: a( lda, * ), b( ldb, * )
       real,intent(inout)                 :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strmm_oop_omp_offload_lp64

     subroutine mkl_blas_dtrmm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrmm_oop_omp_offload_lp64

     subroutine mkl_blas_ctrmm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex,intent(in)                 :: alpha, beta
       complex,intent(in)                 :: a( lda, * ), b( ldb, * )
       complex,intent(inout)              :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrmm_oop_omp_offload_lp64

     subroutine mkl_blas_ztrmm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr),intent(in),value       :: interop
     end subroutine mkl_blas_ztrmm_oop_omp_offload_lp64

     subroutine mkl_blas_dtrsm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrsm_omp_offload_lp64

     subroutine mkl_blas_strsm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strsm_omp_offload_lp64

     subroutine mkl_blas_ztrsm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrsm_omp_offload_lp64

     subroutine mkl_blas_ctrsm_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, ldb
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrsm_omp_offload_lp64

     subroutine mkl_blas_strsm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       real,intent(in)                    :: alpha, beta
       real,intent(in)                    :: a( lda, * ), b( ldb, * )
       real,intent(inout)                 :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strsm_oop_omp_offload_lp64

     subroutine mkl_blas_dtrsm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrsm_oop_omp_offload_lp64

     subroutine mkl_blas_ctrsm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex,intent(in)                 :: alpha, beta
       complex,intent(in)                 :: a( lda, * ), b( ldb, * )
       complex,intent(inout)              :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrsm_oop_omp_offload_lp64

     subroutine mkl_blas_ztrsm_oop_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha,        &
          &a, lda, b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrsm_oop_omp_offload_lp64

     subroutine mkl_blas_dgemmt_omp_offload_lp64 ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, transa, transb
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemmt_omp_offload_lp64

     subroutine mkl_blas_sgemmt_omp_offload_lp64 ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, transa, transb
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemmt_omp_offload_lp64

     subroutine mkl_blas_zgemmt_omp_offload_lp64 ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: uplo, transa, transb
       integer,intent(in)                 :: m, n, lda, ldb, ldc
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemmt_omp_offload_lp64

     subroutine mkl_blas_cgemmt_omp_offload_lp64 ( uplo, transa, transb, m, n, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, transa, transb
       integer,intent(in)                  :: m, n, lda, ldb, ldc
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemmt_omp_offload_lp64

     ! BLAS Level2

     subroutine mkl_blas_dgbmv_omp_offload_lp64 ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgbmv_omp_offload_lp64

     subroutine mkl_blas_sgbmv_omp_offload_lp64 ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgbmv_omp_offload_lp64

     subroutine mkl_blas_zgbmv_omp_offload_lp64 ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgbmv_omp_offload_lp64

     subroutine mkl_blas_cgbmv_omp_offload_lp64 ( trans, m, n, kl, ku, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, kl, ku, lda, m, n
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgbmv_omp_offload_lp64

     subroutine mkl_blas_dgemv_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemv_omp_offload_lp64

     subroutine mkl_blas_sgemv_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemv_omp_offload_lp64

     subroutine mkl_blas_zgemv_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemv_omp_offload_lp64

     subroutine mkl_blas_cgemv_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemv_omp_offload_lp64

     subroutine mkl_blas_dsbmv_omp_offload_lp64 ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsbmv_omp_offload_lp64

     subroutine mkl_blas_ssbmv_omp_offload_lp64 ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssbmv_omp_offload_lp64

     subroutine mkl_blas_zhbmv_omp_offload_lp64 ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhbmv_omp_offload_lp64

     subroutine mkl_blas_chbmv_omp_offload_lp64 ( uplo, n, k, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, k, lda, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chbmv_omp_offload_lp64

     subroutine mkl_blas_dsymv_omp_offload_lp64 ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsymv_omp_offload_lp64

     subroutine mkl_blas_ssymv_omp_offload_lp64 ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssymv_omp_offload_lp64

     subroutine mkl_blas_zhemv_omp_offload_lp64 ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhemv_omp_offload_lp64

     subroutine mkl_blas_chemv_omp_offload_lp64 ( uplo, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chemv_omp_offload_lp64

     subroutine mkl_blas_dspmv_omp_offload_lp64 ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: a( * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dspmv_omp_offload_lp64

     subroutine mkl_blas_sspmv_omp_offload_lp64 ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: a( * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sspmv_omp_offload_lp64

     subroutine mkl_blas_zhpmv_omp_offload_lp64 ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: a( * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhpmv_omp_offload_lp64

     subroutine mkl_blas_chpmv_omp_offload_lp64 ( uplo, n, alpha, a, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: a( * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chpmv_omp_offload_lp64

     subroutine mkl_blas_dger_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       double precision,intent(in)         :: y( * ), x( * )
       double precision,intent(inout)      :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dger_omp_offload_lp64

     subroutine mkl_blas_sger_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       real,intent(in)                     :: y( * ), x( * )
       real,intent(inout)                  :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sger_omp_offload_lp64

     subroutine mkl_blas_zgerc_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex*16,intent(in)               :: y( * ), x( * )
       complex*16,intent(inout)            :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgerc_omp_offload_lp64

     subroutine mkl_blas_cgerc_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex,intent(in)                  :: y( * ), x( * )
       complex,intent(inout)               :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgerc_omp_offload_lp64

     subroutine mkl_blas_zgeru_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex*16,intent(in)               :: y( * ), x( * )
       complex*16,intent(inout)            :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgeru_omp_offload_lp64

     subroutine mkl_blas_cgeru_omp_offload_lp64 ( m, n, alpha, x, incx,   &
          &y, incy, a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, m, n
       complex,intent(in)                  :: y( * ), x( * )
       complex,intent(inout)               :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgeru_omp_offload_lp64

     subroutine mkl_blas_dsyr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, lda, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyr_omp_offload_lp64

     subroutine mkl_blas_ssyr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, lda, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyr_omp_offload_lp64

     subroutine mkl_blas_zher_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, lda, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zher_omp_offload_lp64

     subroutine mkl_blas_cher_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, lda, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cher_omp_offload_lp64

     subroutine mkl_blas_dspr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dspr_omp_offload_lp64

     subroutine mkl_blas_sspr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sspr_omp_offload_lp64

     subroutine mkl_blas_zhpr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhpr_omp_offload_lp64

     subroutine mkl_blas_chpr_omp_offload_lp64 ( uplo, n, alpha, x, incx,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chpr_omp_offload_lp64

     subroutine mkl_blas_dsyr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       double precision,intent(in)         :: x( * ), y( * )
       double precision,intent(inout)      :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyr2_omp_offload_lp64

     subroutine mkl_blas_ssyr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       real,intent(in)                     :: x( * ), y( * )
       real,intent(inout)                  :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyr2_omp_offload_lp64

     subroutine mkl_blas_zher2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       complex*16,intent(in)               :: x( * ), y( * )
       complex*16,intent(inout)            :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zher2_omp_offload_lp64

     subroutine mkl_blas_cher2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, lda, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, lda, n
       complex,intent(in)                  :: x( * ), y( * )
       complex,intent(inout)               :: a( lda, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cher2_omp_offload_lp64

     subroutine mkl_blas_dspr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * ), y( * )
       double precision,intent(inout)      :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dspr2_omp_offload_lp64

     subroutine mkl_blas_sspr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       real,intent(inout)                  :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sspr2_omp_offload_lp64

     subroutine mkl_blas_zhpr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       complex*16,intent(inout)            :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zhpr2_omp_offload_lp64

     subroutine mkl_blas_chpr2_omp_offload_lp64 ( uplo, n, alpha, x, incx, y, incy,   &
          &a, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       complex,intent(inout)               :: a( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_chpr2_omp_offload_lp64

     subroutine mkl_blas_dtbmv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtbmv_omp_offload_lp64

     subroutine mkl_blas_stbmv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_stbmv_omp_offload_lp64

     subroutine mkl_blas_ztbmv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztbmv_omp_offload_lp64

     subroutine mkl_blas_ctbmv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctbmv_omp_offload_lp64

     subroutine mkl_blas_dtrmv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrmv_omp_offload_lp64

     subroutine mkl_blas_strmv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strmv_omp_offload_lp64

     subroutine mkl_blas_ztrmv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrmv_omp_offload_lp64

     subroutine mkl_blas_ctrmv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrmv_omp_offload_lp64

     subroutine mkl_blas_dtpmv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtpmv_omp_offload_lp64

     subroutine mkl_blas_stpmv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_stpmv_omp_offload_lp64

     subroutine mkl_blas_ztpmv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztpmv_omp_offload_lp64

     subroutine mkl_blas_ctpmv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctpmv_omp_offload_lp64

     subroutine mkl_blas_dtbsv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtbsv_omp_offload_lp64

     subroutine mkl_blas_stbsv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_stbsv_omp_offload_lp64

     subroutine mkl_blas_ztbsv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztbsv_omp_offload_lp64

     subroutine mkl_blas_ctbsv_omp_offload_lp64 ( uplo, trans, diag, n, k, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, k, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctbsv_omp_offload_lp64

     subroutine mkl_blas_dtrsv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( lda, * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrsv_omp_offload_lp64

     subroutine mkl_blas_strsv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strsv_omp_offload_lp64

     subroutine mkl_blas_ztrsv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( lda, * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrsv_omp_offload_lp64

     subroutine mkl_blas_ctrsv_omp_offload_lp64 ( uplo, trans, diag, n, a, lda, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, lda, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrsv_omp_offload_lp64

     subroutine mkl_blas_dtpsv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       double precision,intent(in)         :: a( * )
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtpsv_omp_offload_lp64

     subroutine mkl_blas_stpsv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       real,intent(in)                     :: a( * )
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_stpsv_omp_offload_lp64

     subroutine mkl_blas_ztpsv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex*16,intent(in)               :: a( * )
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztpsv_omp_offload_lp64

     subroutine mkl_blas_ctpsv_omp_offload_lp64 ( uplo, trans, diag, n, a, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, n
       character*1,intent(in)              :: uplo, trans, diag
       complex,intent(in)                  :: a( * )
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctpsv_omp_offload_lp64

     ! BLAS Level1

     function mkl_blas_dasum_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_dasum_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_dasum_omp_offload_lp64

     function mkl_blas_sasum_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_sasum_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_sasum_omp_offload_lp64

     function mkl_blas_dzasum_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_dzasum_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_dzasum_omp_offload_lp64

     function mkl_blas_scasum_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_scasum_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_scasum_omp_offload_lp64

     function mkl_blas_dnrm2_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_dnrm2_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_dnrm2_omp_offload_lp64

     function mkl_blas_snrm2_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_snrm2_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_snrm2_omp_offload_lp64

     function mkl_blas_dznrm2_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_dznrm2_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_dznrm2_omp_offload_lp64

     function mkl_blas_scnrm2_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_scnrm2_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_scnrm2_omp_offload_lp64

     subroutine mkl_blas_daxpy_omp_offload_lp64 ( n, alpha, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_daxpy_omp_offload_lp64

     subroutine mkl_blas_saxpy_omp_offload_lp64 ( n, alpha, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_saxpy_omp_offload_lp64

     subroutine mkl_blas_zaxpy_omp_offload_lp64 ( n, alpha, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zaxpy_omp_offload_lp64

     subroutine mkl_blas_caxpy_omp_offload_lp64 ( n, alpha, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_caxpy_omp_offload_lp64

     subroutine mkl_blas_daxpby_omp_offload_lp64 ( n, alpha, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_daxpby_omp_offload_lp64

     subroutine mkl_blas_saxpby_omp_offload_lp64 ( n, alpha, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_saxpby_omp_offload_lp64

     subroutine mkl_blas_zaxpby_omp_offload_lp64 ( n, alpha, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zaxpby_omp_offload_lp64

     subroutine mkl_blas_caxpby_omp_offload_lp64 ( n, alpha, x, incx,   &
          &beta, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_caxpby_omp_offload_lp64

     subroutine mkl_blas_dcopy_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dcopy_omp_offload_lp64

     subroutine mkl_blas_scopy_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_scopy_omp_offload_lp64

     subroutine mkl_blas_zcopy_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zcopy_omp_offload_lp64

     subroutine mkl_blas_ccopy_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ccopy_omp_offload_lp64

     function mkl_blas_ddot_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_ddot_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_ddot_omp_offload_lp64

     function mkl_blas_sdot_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_sdot_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_sdot_omp_offload_lp64

     function mkl_blas_dsdot_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision                    :: mkl_blas_dsdot_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_dsdot_omp_offload_lp64

     function mkl_blas_sdsdot_omp_offload_lp64 ( n, sb, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real                                :: mkl_blas_sdsdot_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: sb, x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_sdsdot_omp_offload_lp64

     function mkl_blas_zdotc_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16                          :: mkl_blas_zdotc_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_zdotc_omp_offload_lp64

     function mkl_blas_cdotc_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex                             :: mkl_blas_cdotc_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_cdotc_omp_offload_lp64

     function mkl_blas_zdotu_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16                          :: mkl_blas_zdotu_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(in)               :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_zdotu_omp_offload_lp64

     function mkl_blas_cdotu_omp_offload_lp64 ( n, x, incx, y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex                             :: mkl_blas_cdotu_omp_offload_lp64
       integer,intent(in)                  :: incx, incy, n
       complex,intent(in)                  :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_cdotu_omp_offload_lp64

     subroutine mkl_blas_drot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: c, s
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(inout)      :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_drot_omp_offload_lp64

     subroutine mkl_blas_srot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: c, s
       integer,intent(in)                  :: incx, incy, n
       real,intent(inout)                  :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_srot_omp_offload_lp64

     subroutine mkl_blas_zdrot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: c, s
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zdrot_omp_offload_lp64

     subroutine mkl_blas_zrot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: c
       complex*16, intent(in)              :: s
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zrot_omp_offload_lp64

     subroutine mkl_blas_csrot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: c, s
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csrot_omp_offload_lp64

     subroutine mkl_blas_crot_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: c
       complex, intent(in)                 :: s
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_crot_omp_offload_lp64

     subroutine mkl_blas_drotg_omp_offload_lp64 ( a, b, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(inout)      :: a( * ), b( * ), c( * ), s( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_drotg_omp_offload_lp64

     subroutine mkl_blas_srotg_omp_offload_lp64 ( a, b, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(inout)                  :: a( * ), b( * ), c( * ), s( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_srotg_omp_offload_lp64

     subroutine mkl_blas_zrotg_omp_offload_lp64 ( a, b, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(inout)            :: a( * ), b( * ), s( * )
       double precision,intent(inout)      :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zrotg_omp_offload_lp64

     subroutine mkl_blas_crotg_omp_offload_lp64 ( a, b, c, s, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(inout)               :: a( * ), b( * ), s( * )
       real,intent(inout)                  :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_crotg_omp_offload_lp64

     subroutine mkl_blas_drotm_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, param, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(in)         :: param( * )
       double precision,intent(inout)      :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_drotm_omp_offload_lp64

     subroutine mkl_blas_srotm_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, param, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       real,intent(in)                     :: param( * )
       real,intent(inout)                  :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_srotm_omp_offload_lp64

     subroutine mkl_blas_drotmg_omp_offload_lp64 ( d1, d2, x1, x2, param, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: x2
       double precision,intent(inout)      :: d1( * ), d2( * ), x1( * ), param( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_drotmg_omp_offload_lp64

     subroutine mkl_blas_srotmg_omp_offload_lp64 ( d1, d2, x1, x2, param, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: x2
       real,intent(inout)                  :: d1( * ), d2( * ), x1( * ), param( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_srotmg_omp_offload_lp64

     subroutine mkl_blas_dscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       double precision,intent(inout)      :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dscal_omp_offload_lp64

     subroutine mkl_blas_sscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       real,intent(inout)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sscal_omp_offload_lp64

     subroutine mkl_blas_zscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zscal_omp_offload_lp64

     subroutine mkl_blas_cscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cscal_omp_offload_lp64

     subroutine mkl_blas_zdscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, n
       complex*16,intent(inout)            :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zdscal_omp_offload_lp64

     subroutine mkl_blas_csscal_omp_offload_lp64 ( n, alpha, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, n
       complex,intent(inout)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csscal_omp_offload_lp64

     subroutine mkl_blas_dswap_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       double precision,intent(inout)      :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dswap_omp_offload_lp64

     subroutine mkl_blas_sswap_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       real,intent(inout)                  :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sswap_omp_offload_lp64

     subroutine mkl_blas_zswap_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       complex*16,intent(inout)            :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zswap_omp_offload_lp64

     subroutine mkl_blas_cswap_omp_offload_lp64 ( n, x, incx,   &
          &y, incy, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, incy, n
       complex,intent(inout)               :: x( * ), y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cswap_omp_offload_lp64

     function mkl_blas_idamax_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_idamax_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_idamax_omp_offload_lp64

     function mkl_blas_isamax_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_isamax_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_isamax_omp_offload_lp64

     function mkl_blas_izamax_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_izamax_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_izamax_omp_offload_lp64

     function mkl_blas_icamax_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_icamax_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_icamax_omp_offload_lp64

     function mkl_blas_idamin_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_idamin_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       double precision,intent(in)         :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_idamin_omp_offload_lp64

     function mkl_blas_isamin_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_isamin_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       real,intent(in)                     :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_isamin_omp_offload_lp64

     function mkl_blas_izamin_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_izamin_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex*16,intent(in)               :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_izamin_omp_offload_lp64

     function mkl_blas_icamin_omp_offload_lp64 ( n, x, incx, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer                             :: mkl_blas_icamin_omp_offload_lp64
       integer,intent(in)                  :: incx, n
       complex,intent(in)                  :: x( * )
       type(c_ptr), intent(in), value :: interop
     end function mkl_blas_icamin_omp_offload_lp64

     ! BLAS batch

     subroutine mkl_blas_dtrsm_batch_strided_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, stridea, ldb, strideb, batch_size
       double precision,intent(in)        :: alpha
       double precision,intent(in)        :: a( lda, * )
       double precision,intent(inout)     :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrsm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_strsm_batch_strided_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, stridea, ldb, strideb, batch_size
       real,intent(in)                     :: alpha
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strsm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_ztrsm_batch_strided_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: side, uplo, trans, diag
       integer,intent(in)                 :: m, n, lda, stridea, ldb, strideb, batch_size
       complex*16,intent(in)              :: alpha
       complex*16,intent(in)              :: a( lda, * )
       complex*16,intent(inout)           :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrsm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_ctrsm_batch_strided_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda, stridea,        &
          &b, ldb, strideb, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: side, uplo, trans, diag
       integer,intent(in)                  :: m, n, lda, stridea, ldb, strideb, batch_size
       complex,intent(in)                  :: alpha
       complex,intent(in)                  :: a( lda, * )
       complex,intent(inout)               :: b( ldb, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrsm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_dgemm_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       double precision,intent(in)        :: alpha, beta
       double precision,intent(in)        :: a( lda, * ), b( ldb, * )
       double precision,intent(inout)     :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_sgemm_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * ), b( ldb, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zgemm_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_cgemm_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zgemm3m_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)             :: transa, transb
       integer,intent(in)                 :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex*16,intent(in)              :: alpha, beta
       complex*16,intent(in)              :: a( lda, * ), b( ldb, * )
       complex*16,intent(inout)           :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm3m_batch_strided_omp_offload_lp64

     subroutine mkl_blas_cgemm3m_batch_strided_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda, stridea,        &
          &b, ldb, strideb, beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: transa, transb
       integer,intent(in)                  :: m, n, k, lda, stridea, ldb, strideb, ldc, stridec, batch_size
       complex,intent(in)                  :: alpha, beta
       complex,intent(in)                  :: a( lda, * ), b( ldb, * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm3m_batch_strided_omp_offload_lp64
     
     subroutine mkl_blas_ssyrk_batch_strided_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       real,intent(in)                     :: alpha, beta
       real,intent(in)                     :: a( lda, * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyrk_batch_strided_omp_offload_lp64

     subroutine mkl_blas_dsyrk_batch_strided_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       double precision,intent(in)                     :: alpha, beta
       double precision,intent(in)                     :: a( lda, * )
       double precision,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyrk_batch_strided_omp_offload_lp64

     subroutine mkl_blas_csyrk_batch_strided_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       complex,intent(in)                     :: alpha, beta
       complex,intent(in)                     :: a( lda, * )
       complex,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csyrk_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zsyrk_batch_strided_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda, stridea,        &
          beta, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)              :: uplo, trans
       integer,intent(in)                  :: n, k, lda, stridea, ldc, stridec, batch_size
       complex*16,intent(in)                     :: alpha, beta
       complex*16,intent(in)                     :: a( lda, * )
       complex*16,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zsyrk_batch_strided_omp_offload_lp64

    subroutine mkl_blas_daxpy_batch_strided_omp_offload_lp64 ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_daxpy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_saxpy_batch_strided_omp_offload_lp64 ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_saxpy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zaxpy_batch_strided_omp_offload_lp64 ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zaxpy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_caxpy_batch_strided_omp_offload_lp64 ( n, alpha, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_caxpy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_scopy_batch_strided_omp_offload_lp64 ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       real,intent(in)                     :: x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_scopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_dcopy_batch_strided_omp_offload_lp64 ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       double precision,intent(in)         :: x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_ccopy_batch_strided_omp_offload_lp64 ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex,intent(in)                  :: x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ccopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zcopy_batch_strided_omp_offload_lp64 ( n, x, incx, stridex,   &
          &y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, stridex, incy, stridey, batch_size, n
       complex*16,intent(in)               :: x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zcopy_batch_strided_omp_offload_lp64

     subroutine mkl_blas_dgemv_batch_strided_omp_offload_lp64 ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)         :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemv_batch_strided_omp_offload_lp64

     subroutine mkl_blas_sgemv_batch_strided_omp_offload_lp64 ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                     :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemv_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zgemv_batch_strided_omp_offload_lp64 ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)               :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemv_batch_strided_omp_offload_lp64

     subroutine mkl_blas_cgemv_batch_strided_omp_offload_lp64 ( trans, m, n, alpha, a, lda, stridea, x, incx,   &
          &stridex, beta, y, incy, stridey, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                  :: alpha, beta
       integer,intent(in)                  :: incx, incy, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridey, batch_size
       character*1,intent(in)              :: trans
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemv_batch_strided_omp_offload_lp64

     subroutine mkl_blas_ddgmm_batch_strided_omp_offload_lp64 ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       double precision,intent(in)         :: a( lda, * ), x( * )
       double precision,intent(inout)      :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ddgmm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_sdgmm_batch_strided_omp_offload_lp64 ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       real,intent(in)                     :: a( lda, * ), x( * )
       real,intent(inout)                  :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sdgmm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_zdgmm_batch_strided_omp_offload_lp64 ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       complex*16,intent(in)               :: a( lda, * ), x( * )
       complex*16,intent(inout)            :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zdgmm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_cdgmm_batch_strided_omp_offload_lp64 ( side, m, n, a, lda, stridea, x, incx,   &
          &stridex, c, ldc, stridec, batch_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                  :: incx, ldc, lda, m, n
       integer,intent(in)                  :: stridea, stridex, stridec, batch_size
       character*1,intent(in)              :: side
       complex,intent(in)                  :: a( lda, * ), x( * )
       complex,intent(inout)               :: c( ldc, * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cdgmm_batch_strided_omp_offload_lp64

     subroutine mkl_blas_daxpy_batch_omp_offload_lp64(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)             :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_daxpy_batch_omp_offload_lp64

     subroutine mkl_blas_saxpy_batch_omp_offload_lp64(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                         :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_saxpy_batch_omp_offload_lp64

     subroutine mkl_blas_zaxpy_batch_omp_offload_lp64(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)                   :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zaxpy_batch_omp_offload_lp64

     subroutine mkl_blas_caxpy_batch_omp_offload_lp64(n_array,alpha_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                      :: alpha_array(*)
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_caxpy_batch_omp_offload_lp64

     subroutine mkl_blas_scopy_batch_omp_offload_lp64(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_scopy_batch_omp_offload_lp64

     subroutine mkl_blas_dcopy_batch_omp_offload_lp64(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dcopy_batch_omp_offload_lp64

     subroutine mkl_blas_ccopy_batch_omp_offload_lp64(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ccopy_batch_omp_offload_lp64

     subroutine mkl_blas_zcopy_batch_omp_offload_lp64(n_array,x_array,incx_array,    &
          &y_array,incy_array,group_count,group_size_array,interop) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx_array(*),incy_array(*),n_array(*)
       integer,intent(in)                      :: group_count,group_size_array(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: x_array(*)
       integer(KIND=C_INTPTR_T),intent(inout)  :: y_array(*)
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zcopy_batch_omp_offload_lp64

     subroutine mkl_blas_dtrsm_batch_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dtrsm_batch_omp_offload_lp64

     subroutine mkl_blas_strsm_batch_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_strsm_batch_omp_offload_lp64

     subroutine mkl_blas_ztrsm_batch_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ztrsm_batch_omp_offload_lp64

     subroutine mkl_blas_ctrsm_batch_omp_offload_lp64 ( side, uplo, trans, diag, m, n, alpha, a, lda,        &
          &b, ldb, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: side(*), uplo(*), trans(*), diag(*)
       integer,intent(in)                     :: m(*), n(*), lda(*), ldb(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: b( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ctrsm_batch_omp_offload_lp64

     subroutine mkl_blas_dsyrk_batch_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dsyrk_batch_omp_offload_lp64

     subroutine mkl_blas_ssyrk_batch_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ssyrk_batch_omp_offload_lp64

     subroutine mkl_blas_zsyrk_batch_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zsyrk_batch_omp_offload_lp64

     subroutine mkl_blas_csyrk_batch_omp_offload_lp64 ( uplo, trans, n, k, alpha, a, lda,        &
          beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: uplo(*), trans(*)
       integer,intent(in)                     :: n(*), k(*), lda(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_csyrk_batch_omp_offload_lp64

     subroutine mkl_blas_dgemm_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       double precision,intent(in)            :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemm_batch_omp_offload_lp64

     subroutine mkl_blas_sgemm_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       real,intent(in)                        :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemm_batch_omp_offload_lp64

     subroutine mkl_blas_zgemm_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm_batch_omp_offload_lp64

     subroutine mkl_blas_cgemm_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm_batch_omp_offload_lp64

     subroutine mkl_blas_zgemm3m_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex*16,intent(in)                  :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemm3m_batch_omp_offload_lp64

     subroutine mkl_blas_cgemm3m_batch_omp_offload_lp64 ( transa, transb, m, n, k, alpha, a, lda,        &
          &b, ldb, beta, c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       character*1,intent(in)                 :: transa(*), transb(*)
       integer,intent(in)                     :: m(*), n(*), k(*), lda(*), ldb(*), ldc(*)
       integer,intent(in)                     :: group_size(*), group_count
       complex,intent(in)                     :: alpha(*), beta(*)
       integer(KIND=C_INTPTR_T),intent(in)    :: a( * ), b( * )
       integer(KIND=C_INTPTR_T),intent(inout) :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemm3m_batch_omp_offload_lp64
     
     subroutine mkl_blas_dgemv_batch_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       double precision,intent(in)             :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_dgemv_batch_omp_offload_lp64

     subroutine mkl_blas_sgemv_batch_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       real,intent(in)                         :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sgemv_batch_omp_offload_lp64

     subroutine mkl_blas_zgemv_batch_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex*16,intent(in)                   :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zgemv_batch_omp_offload_lp64

     subroutine mkl_blas_cgemv_batch_omp_offload_lp64 ( trans, m, n, alpha, a, lda, x, incx,   &
          &beta, y, incy, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       complex,intent(in)                      :: alpha(*), beta(*)
       integer,intent(in)                      :: incx(*), incy(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: trans(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: y( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cgemv_batch_omp_offload_lp64

     subroutine mkl_blas_ddgmm_batch_omp_offload_lp64 ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_ddgmm_batch_omp_offload_lp64

     subroutine mkl_blas_sdgmm_batch_omp_offload_lp64 ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_sdgmm_batch_omp_offload_lp64

     subroutine mkl_blas_zdgmm_batch_omp_offload_lp64 ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_zdgmm_batch_omp_offload_lp64

     subroutine mkl_blas_cdgmm_batch_omp_offload_lp64 ( side, m, n, a, lda, x, incx,   &
          &c, ldc, group_count, group_size, interop ) BIND(C)
       use, intrinsic :: iso_c_binding
       integer,intent(in)                      :: incx(*), ldc(*), lda(*), m(*), n(*)
       integer,intent(in)                      :: group_size(*), group_count
       character*1,intent(in)                  :: side(*)
       integer(KIND=C_INTPTR_T),intent(in)     :: a( * ), x( * )
       integer(KIND=C_INTPTR_T),intent(inout)  :: c( * )
       type(c_ptr), intent(in), value :: interop
     end subroutine mkl_blas_cdgmm_batch_omp_offload_lp64

  end interface

!===============================================================================
! Copyright (C) 2020 Intel Corporation
!
! This software and the related documents are Intel copyrighted  materials,  and
! your use of  them is  governed by the  express license  under which  they were
! provided to you (License).  Unless the License provides otherwise, you may not
! use, modify, copy, publish, distribute,  disclose or transmit this software or
! the related documents without Intel's prior written permission.
!
! This software and the related documents  are provided as  is,  with no express
! or implied  warranties,  other  than those  that are  expressly stated  in the
! License.
!===============================================================================

!  Content:
!      Intel(R) oneAPI Math Kernel Library (oneMKL) FORTRAN interface for
!      OpenMP offload for LAPACK
!*******************************************************************************

module onemkl_lapack_omp_offload_lp64

   include "mkl_lapack_omp_variant_lp64.f90"

   interface

      subroutine cgebrd(m, n, a, lda, d, e, tauq, taup, work, lwork,   &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      complex*8, intent(out) :: tauq(*)
      complex*8, intent(out) :: taup(*)
      complex*8, intent(out) :: work(*)
!$omp declare variant (cgebrd:mkl_lapack_cgebrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tauq,taup,work,info)
      end subroutine cgebrd

      subroutine dgebrd(m, n, a, lda, d, e, tauq, taup, work, lwork,   &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      double precision, intent(out) :: tauq(*)
      double precision, intent(out) :: taup(*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dgebrd:mkl_lapack_dgebrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tauq,taup,work,info)
      end subroutine dgebrd

      subroutine sgebrd(m, n, a, lda, d, e, tauq, taup, work, lwork,   &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      real, intent(out) :: tauq(*)
      real, intent(out) :: taup(*)
      real, intent(out) :: work(*)
!$omp declare variant (sgebrd:mkl_lapack_sgebrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tauq,taup,work,info)
      end subroutine sgebrd

      subroutine zgebrd(m, n, a, lda, d, e, tauq, taup, work, lwork,   &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      complex*16, intent(out) :: tauq(*)
      complex*16, intent(out) :: taup(*)
      complex*16, intent(out) :: work(*)
!$omp declare variant (zgebrd:mkl_lapack_zgebrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tauq,taup,work,info)
      end subroutine zgebrd

      subroutine cgeqrf(m, n, a, lda, tau, work, lwork, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      complex*8, intent(out) :: tau(*)
      complex*8, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
!$omp declare variant (cgeqrf:mkl_lapack_cgeqrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine cgeqrf

      subroutine dgeqrf(m, n, a, lda, tau, work, lwork, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      double precision, intent(out) :: tau(*)
      double precision, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
!$omp declare variant (dgeqrf:mkl_lapack_dgeqrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine dgeqrf

      subroutine sgeqrf(m, n, a, lda, tau, work, lwork, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      real, intent(out) :: tau(*)
      real, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
!$omp declare variant (sgeqrf:mkl_lapack_sgeqrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine sgeqrf

      subroutine zgeqrf(m, n, a, lda, tau, work, lwork, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      complex*16, intent(out) :: tau(*)
      complex*16, intent(out) :: work(*)
      integer, intent(in) :: lwork
      integer, intent(out) :: info
!$omp declare variant (zgeqrf:mkl_lapack_zgeqrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine zgeqrf

      subroutine cgeqrf_batch_strided(m, n, a, lda, stride_a, tau,     &
                                      stride_tau, work, lwork,         &
                                      batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      complex*8, intent(out) :: tau(stride_tau,*)
      complex*8, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgeqrf_batch_strided:mkl_lapack_cgeqrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine cgeqrf_batch_strided

      subroutine dgeqrf_batch_strided(m, n, a, lda, stride_a, tau,     &
                                      stride_tau, work, lwork,         &
                                      batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: tau(stride_tau,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgeqrf_batch_strided:mkl_lapack_dgeqrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine dgeqrf_batch_strided

      subroutine sgeqrf_batch_strided(m, n, a, lda, stride_a, tau,     &
                                      stride_tau, work, lwork,         &
                                      batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      real, intent(out) :: tau(stride_tau,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgeqrf_batch_strided:mkl_lapack_sgeqrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine sgeqrf_batch_strided

      subroutine zgeqrf_batch_strided(m, n, a, lda, stride_a, tau,     &
                                      stride_tau, work, lwork,         &
                                      batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_tau
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      complex*16, intent(out) :: tau(stride_tau,*)
      complex*16, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgeqrf_batch_strided:mkl_lapack_zgeqrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine zgeqrf_batch_strided

      subroutine cgesvd(jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt,&
                        work, lwork, rwork, info) bind(c)
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: s(*)
      complex*8, intent(out) :: u(ldu,*)
      complex*8, intent(out) :: vt(ldvt,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
!$omp declare variant (cgesvd:mkl_lapack_cgesvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,s,u,vt,work,rwork,info)
      end subroutine cgesvd

      subroutine dgesvd(jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt,&
                        work, lwork, info) bind(c)
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: s(*)
      double precision, intent(out) :: u(ldu,*)
      double precision, intent(out) :: vt(ldvt,*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dgesvd:mkl_lapack_dgesvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,s,u,vt,work,info)
      end subroutine dgesvd

      subroutine sgesvd(jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt,&
                        work, lwork, info) bind(c)
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: s(*)
      real, intent(out) :: u(ldu,*)
      real, intent(out) :: vt(ldvt,*)
      real, intent(out) :: work(*)
!$omp declare variant (sgesvd:mkl_lapack_sgesvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,s,u,vt,work,info)
      end subroutine sgesvd

      subroutine zgesvd(jobu, jobvt, m, n, a, lda, s, u, ldu, vt, ldvt,&
                        work, lwork, rwork, info) bind(c)
      character*1, intent(in) :: jobu
      character*1, intent(in) :: jobvt
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldu
      integer, intent(in) :: ldvt
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: s(*)
      complex*16, intent(out) :: u(ldu,*)
      complex*16, intent(out) :: vt(ldvt,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
!$omp declare variant (zgesvd:mkl_lapack_zgesvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,s,u,vt,work,rwork,info)
      end subroutine zgesvd

      subroutine cgesvda_batch(iparm, irank, m, n, a, lda, stride_a, s,&
                               stride_s, u, ldu, stride_u, vt, ldvt,   &
                               stride_vt, tolerance, residual, work,   &
                               lwork, batch_size, info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      real, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      real, intent(out) :: s(stride_s,*)
      complex*8, intent(out) :: u(stride_u,*)
      complex*8, intent(out) :: vt(stride_u,*)
      real, intent(out) :: residual(*)
      complex*8, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (mkl_lapack_cgesvda_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:irank,a,s,u,vt,residual,work,info)
      end subroutine cgesvda_batch

      subroutine cgetrf(m, n, a, lda, ipiv, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
!$omp declare variant (cgetrf:mkl_lapack_cgetrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine cgetrf

      subroutine dgesvda_batch(iparm, irank, m, n, a, lda, stride_a, s,&
                               stride_s, u, ldu, stride_u, vt, ldvt,   &
                               stride_vt, tolerance, residual, work,   &
                               lwork, batch_size, info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      double precision, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: s(stride_s,*)
      double precision, intent(out) :: u(stride_u,*)
      double precision, intent(out) :: vt(stride_u,*)
      double precision, intent(out) :: residual(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (mkl_lapack_dgesvda_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:irank,a,s,u,vt,residual,work,info)
      end subroutine dgesvda_batch

      subroutine dgetrf(m, n, a, lda, ipiv, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
!$omp declare variant (dgetrf:mkl_lapack_dgetrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine dgetrf

      subroutine sgesvda_batch(iparm, irank, m, n, a, lda, stride_a, s,&
                               stride_s, u, ldu, stride_u, vt, ldvt,   &
                               stride_vt, tolerance, residual, work,   &
                               lwork, batch_size, info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      real, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      real, intent(out) :: s(stride_s,*)
      real, intent(out) :: u(stride_u,*)
      real, intent(out) :: vt(stride_u,*)
      real, intent(out) :: residual(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (mkl_lapack_sgesvda_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:irank,a,s,u,vt,residual,work,info)
      end subroutine sgesvda_batch

      subroutine sgetrf(m, n, a, lda, ipiv, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
!$omp declare variant (sgetrf:mkl_lapack_sgetrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine sgetrf

      subroutine zgesvda_batch(iparm, irank, m, n, a, lda, stride_a, s,&
                               stride_s, u, ldu, stride_u, vt, ldvt,   &
                               stride_vt, tolerance, residual, work,   &
                               lwork, batch_size, info) bind(c)
      integer, intent(in) :: iparm
      integer, intent(inout) :: irank
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_s
      integer, intent(in) :: ldu
      integer, intent(in) :: stride_u
      integer, intent(in) :: ldvt
      integer, intent(in) :: stride_vt
      double precision, intent(in) :: tolerance
      integer, intent(in) :: lwork
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      double precision, intent(out) :: s(stride_s,*)
      complex*16, intent(out) :: u(stride_u,*)
      complex*16, intent(out) :: vt(stride_u,*)
      double precision, intent(out) :: residual(*)
      complex*16, intent(out) :: work(*)
      integer, intent(out) :: info(*)
!$omp declare variant (mkl_lapack_zgesvda_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:irank,a,s,u,vt,residual,work,info)
      end subroutine zgesvda_batch

      subroutine zgetrf(m, n, a, lda, ipiv, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(out) :: ipiv(*)
!$omp declare variant (zgetrf:mkl_lapack_zgetrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine zgetrf

      subroutine cgetrf_batch(m, n, a, lda, ipiv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ipiv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrf_batch:mkl_lapack_cgetrf_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine cgetrf_batch

      subroutine dgetrf_batch(m, n, a, lda, ipiv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ipiv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrf_batch:mkl_lapack_dgetrf_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine dgetrf_batch

      subroutine sgetrf_batch(m, n, a, lda, ipiv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ipiv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrf_batch:mkl_lapack_sgetrf_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine sgetrf_batch

      subroutine zgetrf_batch(m, n, a, lda, ipiv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ipiv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrf_batch:mkl_lapack_zgetrf_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine zgetrf_batch

      subroutine cgetrfnp_batch(m, n, a, lda, &
                                group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrfnp_batch:mkl_lapack_cgetrfnp_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine cgetrfnp_batch

      subroutine dgetrfnp_batch(m, n, a, lda, &
                                group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrfnp_batch:mkl_lapack_dgetrfnp_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine dgetrfnp_batch

      subroutine sgetrfnp_batch(m, n, a, lda, &
                                group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrfnp_batch:mkl_lapack_sgetrfnp_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine sgetrfnp_batch

      subroutine zgetrfnp_batch(m, n, a, lda, &
                               group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: m(*), n(*), lda(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(inout) :: a(*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrfnp_batch:mkl_lapack_zgetrfnp_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine zgetrfnp_batch

      subroutine cgetri_oop_batch(n, a, lda, ipiv, ainv, ldainv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n(*), lda(*), ldainv(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetri_oop_batch:mkl_lapack_cgetri_oop_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine cgetri_oop_batch

      subroutine dgetri_oop_batch(n, a, lda, ipiv, ainv, ldainv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n(*), lda(*), ldainv(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetri_oop_batch:mkl_lapack_dgetri_oop_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine dgetri_oop_batch

      subroutine sgetri_oop_batch(n, a, lda, ipiv, ainv, ldainv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n(*), lda(*), ldainv(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetri_oop_batch:mkl_lapack_sgetri_oop_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine sgetri_oop_batch

      subroutine zgetri_oop_batch(n, a, lda, ipiv, ainv, ldainv, &
                              group_count, group_size, info) bind(c)
      use, intrinsic :: iso_c_binding
      integer, intent(in) :: n(*), lda(*), ldainv(*)
      integer, intent(in) :: group_size(*), group_count
      integer(KIND=C_INTPTR_T), intent(in) :: a(*), ipiv(*)
      integer(KIND=C_INTPTR_T), intent(out) :: ainv(*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetri_oop_batch:mkl_lapack_zgetri_oop_batch_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine zgetri_oop_batch


      subroutine cgetrf_batch_strided(m, n, a, lda, stride_a, ipiv,    &
                                      stride_ipiv, batch_size,         &
                                      info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrf_batch_strided:mkl_lapack_cgetrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine cgetrf_batch_strided

      subroutine dgetrf_batch_strided(m, n, a, lda, stride_a, ipiv,    &
                                      stride_ipiv, batch_size,         &
                                      info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrf_batch_strided:mkl_lapack_dgetrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine dgetrf_batch_strided

      subroutine sgetrf_batch_strided(m, n, a, lda, stride_a, ipiv,    &
                                      stride_ipiv, batch_size,         &
                                      info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrf_batch_strided:mkl_lapack_sgetrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine sgetrf_batch_strided

      subroutine zgetrf_batch_strided(m, n, a, lda, stride_a, ipiv,    &
                                      stride_ipiv, batch_size,         &
                                      info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: ipiv(stride_ipiv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrf_batch_strided:mkl_lapack_zgetrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,info)
      end subroutine zgetrf_batch_strided

      subroutine mkl_cgetrfnp(m, n, a, lda, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
!$omp declare variant (mkl_cgetrfnp:mkl_lapack_cgetrfnp_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine mkl_cgetrfnp

      subroutine mkl_dgetrfnp(m, n, a, lda, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
!$omp declare variant (mkl_dgetrfnp:mkl_lapack_dgetrfnp_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine mkl_dgetrfnp

      subroutine mkl_sgetrfnp(m, n, a, lda, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
!$omp declare variant (mkl_sgetrfnp:mkl_lapack_sgetrfnp_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine mkl_sgetrfnp

      subroutine mkl_zgetrfnp(m, n, a, lda, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
!$omp declare variant (mkl_zgetrfnp:mkl_lapack_zgetrfnp_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine mkl_zgetrfnp

      subroutine cgetri(n, a, lda, ipiv, work, lwork, info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*8, intent(out) :: work(*)
!$omp declare variant (cgetri:mkl_lapack_cgetri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,work,info)
      end subroutine cgetri

      subroutine dgetri(n, a, lda, ipiv, work, lwork, info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dgetri:mkl_lapack_dgetri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,work,info)
      end subroutine dgetri

      subroutine sgetri(n, a, lda, ipiv, work, lwork, info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      real, intent(out) :: work(*)
!$omp declare variant (sgetri:mkl_lapack_sgetri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,work,info)
      end subroutine sgetri

      subroutine zgetri(n, a, lda, ipiv, work, lwork, info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*16, intent(out) :: work(*)
!$omp declare variant (zgetri:mkl_lapack_zgetri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,work,info)
      end subroutine zgetri

      subroutine cgetri_oop_batch_strided(n, a, lda, stride_a, ipiv,   &
                                          stride_ipiv, ainv, ldainv,   &
                                          stride_ainv, batch_size,     &
                                          info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*8, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetri_oop_batch_strided:mkl_lapack_cgetri_oop_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine cgetri_oop_batch_strided

      subroutine dgetri_oop_batch_strided(n, a, lda, stride_a, ipiv,   &
                                          stride_ipiv, ainv, ldainv,   &
                                          stride_ainv, batch_size,     &
                                          info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      double precision, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetri_oop_batch_strided:mkl_lapack_dgetri_oop_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine dgetri_oop_batch_strided

      subroutine sgetri_oop_batch_strided(n, a, lda, stride_a, ipiv,   &
                                          stride_ipiv, ainv, ldainv,   &
                                          stride_ainv, batch_size,     &
                                          info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      real, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetri_oop_batch_strided:mkl_lapack_sgetri_oop_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine sgetri_oop_batch_strided

      subroutine zgetri_oop_batch_strided(n, a, lda, stride_a, ipiv,   &
                                          stride_ipiv, ainv, ldainv,   &
                                          stride_ainv, batch_size,     &
                                          info) bind(c)
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldainv
      integer, intent(in) :: stride_ainv
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*16, intent(inout) :: ainv(stride_ainv,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetri_oop_batch_strided:mkl_lapack_zgetri_oop_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,ainv,info)
      end subroutine zgetri_oop_batch_strided

      subroutine cgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb,          &
                        info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*8, intent(inout) :: b(ldb,*)
!$omp declare variant (cgetrs:mkl_lapack_cgetrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine cgetrs

      subroutine dgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb,          &
                        info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      double precision, intent(inout) :: b(ldb,*)
!$omp declare variant (dgetrs:mkl_lapack_dgetrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine dgetrs

      subroutine sgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb,          &
                        info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      real, intent(inout) :: b(ldb,*)
!$omp declare variant (sgetrs:mkl_lapack_sgetrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine sgetrs

      subroutine zgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb,          &
                        info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      integer, intent(in) :: ipiv(*)
      complex*16, intent(inout) :: b(ldb,*)
!$omp declare variant (zgetrs:mkl_lapack_zgetrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine zgetrs

      subroutine cheev(jobz, uplo, n, a, lda, w, work, lwork, rwork,   &
                       info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
!$omp declare variant (cheev:mkl_lapack_cheev_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,rwork,info)
      end subroutine cheev

      subroutine zheev(jobz, uplo, n, a, lda, w, work, lwork, rwork,   &
                       info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
!$omp declare variant (zheev:mkl_lapack_zheev_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,rwork,info)
      end subroutine zheev

      subroutine cheevd(jobz, uplo, n, a, lda, w, work, lwork, rwork,  &
                        lrwork, iwork, liwork, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (cheevd:mkl_lapack_cheevd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,rwork,iwork,info)
      end subroutine cheevd

      subroutine zheevd(jobz, uplo, n, a, lda, w, work, lwork, rwork,  &
                        lrwork, iwork, liwork, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (zheevd:mkl_lapack_zheevd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,rwork,iwork,info)
      end subroutine zheevd

      subroutine cheevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu,  &
                        abstol, m, w, z, ldz, work, lwork, rwork,      &
                        iwork, ifail, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: z(ldz,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (cheevx:mkl_lapack_cheevx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,m,w,z,work,rwork,iwork,ifail,info)
      end subroutine cheevx

      subroutine zheevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu,  &
                        abstol, m, w, z, ldz, work, lwork, rwork,      &
                        iwork, ifail, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: z(ldz,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (zheevx:mkl_lapack_zheevx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,m,w,z,work,rwork,iwork,ifail,info)
      end subroutine zheevx

      subroutine chegvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, &
                        lwork, rwork, lrwork, iwork, liwork,           &
                        info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (chegvd:mkl_lapack_chegvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,w,work,rwork,iwork,info)
      end subroutine chegvd

      subroutine zhegvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, &
                        lwork, rwork, lrwork, iwork, liwork,           &
                        info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: lrwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (zhegvd:mkl_lapack_zhegvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,w,work,rwork,iwork,info)
      end subroutine zhegvd

      subroutine chegvx(itype, jobz, range, uplo, n, a, lda, b, ldb,   &
                        vl, vu, il, iu, abstol, m, w, z, ldz, work,    &
                        lwork, rwork, iwork, ifail, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      complex*8, intent(out) :: z(ldz,*)
      complex*8, intent(out) :: work(*)
      real, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (chegvx:mkl_lapack_chegvx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,m,w,z,work,rwork,iwork,ifail,info)
      end subroutine chegvx

      subroutine zhegvx(itype, jobz, range, uplo, n, a, lda, b, ldb,   &
                        vl, vu, il, iu, abstol, m, w, z, ldz, work,    &
                        lwork, rwork, iwork, ifail, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      complex*16, intent(out) :: z(ldz,*)
      complex*16, intent(out) :: work(*)
      double precision, intent(out) :: rwork(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (zhegvx:mkl_lapack_zhegvx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,m,w,z,work,rwork,iwork,ifail,info)
      end subroutine zhegvx

      subroutine chetrd(uplo, n, a, lda, d, e, tau, work, lwork,       &
                        info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      complex*8, intent(out) :: tau(*)
      complex*8, intent(out) :: work(*)
!$omp declare variant (chetrd:mkl_lapack_chetrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tau,work,info)
      end subroutine chetrd

      subroutine zhetrd(uplo, n, a, lda, d, e, tau, work, lwork,       &
                        info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      complex*16, intent(out) :: tau(*)
      complex*16, intent(out) :: work(*)
!$omp declare variant (zhetrd:mkl_lapack_zhetrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tau,work,info)
      end subroutine zhetrd

      subroutine dorgqr(m, n, k, a, lda, tau, work, lwork,             &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(in) :: tau(*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dorgqr:mkl_lapack_dorgqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine dorgqr

      subroutine sorgqr(m, n, k, a, lda, tau, work, lwork,             &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(in) :: tau(*)
      real, intent(out) :: work(*)
!$omp declare variant (sorgqr:mkl_lapack_sorgqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine sorgqr

      subroutine dormqr(side, trans, m, n, k, a, lda, tau, c, ldc,     &
                        work, lwork, info) bind(c)
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      double precision, intent(in) :: tau(*)
      double precision, intent(inout) :: c(ldc,*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dormqr:mkl_lapack_dormqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,c,work,info)
      end subroutine dormqr

      subroutine sormqr(side, trans, m, n, k, a, lda, tau, c, ldc,     &
                        work, lwork, info) bind(c)
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      real, intent(in) :: tau(*)
      real, intent(inout) :: c(ldc,*)
      real, intent(out) :: work(*)
!$omp declare variant (sormqr:mkl_lapack_sormqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,c,work,info)
      end subroutine sormqr

      subroutine csteqr(compz, n, d, e, z, ldz, work, info) bind(c)
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      real, intent(inout) :: d(*)
      real, intent(inout) :: e(*)
      complex*8, intent(inout) :: z(ldz,*)
      real, intent(out) :: work(*)
!$omp declare variant (csteqr:mkl_lapack_csteqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:d,e,z,work,info)
      end subroutine csteqr

      subroutine dsteqr(compz, n, d, e, z, ldz, work, info) bind(c)
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      double precision, intent(inout) :: d(*)
      double precision, intent(inout) :: e(*)
      double precision, intent(inout) :: z(ldz,*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dsteqr:mkl_lapack_dsteqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:d,e,z,work,info)
      end subroutine dsteqr

      subroutine ssteqr(compz, n, d, e, z, ldz, work, info) bind(c)
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      real, intent(inout) :: d(*)
      real, intent(inout) :: e(*)
      real, intent(inout) :: z(ldz,*)
      real, intent(out) :: work(*)
!$omp declare variant (ssteqr:mkl_lapack_ssteqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:d,e,z,work,info)
      end subroutine ssteqr

      subroutine zsteqr(compz, n, d, e, z, ldz, work, info) bind(c)
      character*1, intent(in) :: compz
      integer, intent(in) :: n
      integer, intent(in) :: ldz
      integer, intent(out) :: info
      double precision, intent(inout) :: d(*)
      double precision, intent(inout) :: e(*)
      complex*16, intent(inout) :: z(ldz,*)
      double precision, intent(out) :: work(*)
!$omp declare variant (zsteqr:mkl_lapack_zsteqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:d,e,z,work,info)
      end subroutine zsteqr

      subroutine dsyev(jobz, uplo, n, a, lda, w, work, lwork,          &
                       info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dsyev:mkl_lapack_dsyev_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,info)
      end subroutine dsyev

      subroutine ssyev(jobz, uplo, n, a, lda, w, work, lwork,          &
                       info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
!$omp declare variant (ssyev:mkl_lapack_ssyev_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,info)
      end subroutine ssyev

      subroutine dsyevd(jobz, uplo, n, a, lda, w, work, lwork, iwork,  &
                        liwork, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (dsyevd:mkl_lapack_dsyevd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,iwork,info)
      end subroutine dsyevd

      subroutine ssyevd(jobz, uplo, n, a, lda, w, work, lwork, iwork,  &
                        liwork, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (ssyevd:mkl_lapack_ssyevd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,w,work,iwork,info)
      end subroutine ssyevd

      subroutine dsyevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu,  &
                        abstol, m, w, z, ldz, work, lwork, iwork,      &
                        ifail, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (dsyevx:mkl_lapack_dsyevx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,m,w,z,work,iwork,ifail,info)
      end subroutine dsyevx

      subroutine ssyevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu,  &
                        abstol, m, w, z, ldz, work, lwork, iwork,      &
                        ifail, info) bind(c)
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: w(*)
      real, intent(out) :: z(ldz,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (ssyevx:mkl_lapack_ssyevx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,m,w,z,work,iwork,ifail,info)
      end subroutine ssyevx

      subroutine dsygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, &
                        lwork, iwork, liwork, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (dsygvd:mkl_lapack_dsygvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,w,work,iwork,info)
      end subroutine dsygvd

      subroutine ssygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, &
                        lwork, iwork, liwork, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(in) :: lwork
      integer, intent(in) :: liwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
!$omp declare variant (ssygvd:mkl_lapack_ssygvd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,w,work,iwork,info)
      end subroutine ssygvd

      subroutine dsygvx(itype, jobz, range, uplo, n, a, lda, b, ldb,   &
                        vl, vu, il, iu, abstol, m, w, z, ldz, work,    &
                        lwork, iwork, ifail, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      double precision, intent(in) :: vl
      double precision, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      double precision, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      double precision, intent(out) :: w(*)
      double precision, intent(out) :: z(ldz,*)
      double precision, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (dsygvx:mkl_lapack_dsygvx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,m,w,z,work,iwork,ifail,info)
      end subroutine dsygvx

      subroutine ssygvx(itype, jobz, range, uplo, n, a, lda, b, ldb,   &
                        vl, vu, il, iu, abstol, m, w, z, ldz, work,    &
                        lwork, iwork, ifail, info) bind(c)
      integer, intent(in) :: itype
      character*1, intent(in) :: jobz
      character*1, intent(in) :: range
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      real, intent(in) :: vl
      real, intent(in) :: vu
      integer, intent(in) :: il
      integer, intent(in) :: iu
      real, intent(in) :: abstol
      integer, intent(out) :: m
      integer, intent(in) :: ldz
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      real, intent(out) :: w(*)
      real, intent(out) :: z(ldz,*)
      real, intent(out) :: work(*)
      integer, intent(out) :: iwork(*)
      integer, intent(out) :: ifail(*)
!$omp declare variant (ssygvx:mkl_lapack_ssygvx_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,m,w,z,work,iwork,ifail,info)
      end subroutine ssygvx

      subroutine dsytrd(uplo, n, a, lda, d, e, tau, work, lwork,       &
                        info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
      double precision, intent(out) :: d(*)
      double precision, intent(out) :: e(*)
      double precision, intent(out) :: tau(*)
      double precision, intent(out) :: work(*)
!$omp declare variant (dsytrd:mkl_lapack_dsytrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tau,work,info)
      end subroutine dsytrd

      subroutine ssytrd(uplo, n, a, lda, d, e, tau, work, lwork,       &
                        info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
      real, intent(out) :: d(*)
      real, intent(out) :: e(*)
      real, intent(out) :: tau(*)
      real, intent(out) :: work(*)
!$omp declare variant (ssytrd:mkl_lapack_ssytrd_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,d,e,tau,work,info)
      end subroutine ssytrd

      subroutine ctrtri(uplo, diag, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
!$omp declare variant (ctrtri:mkl_lapack_ctrtri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:info,a)
      end subroutine ctrtri

      subroutine dtrtri(uplo, diag, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      double precision, intent(inout) :: a(lda,*)
!$omp declare variant (dtrtri:mkl_lapack_dtrtri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:info,a)
      end subroutine dtrtri

      subroutine strtri(uplo, diag, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      real, intent(inout) :: a(lda,*)
!$omp declare variant (strtri:mkl_lapack_strtri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:info,a)
      end subroutine strtri

      subroutine ztrtri(uplo, diag, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
!$omp declare variant (ztrtri:mkl_lapack_ztrtri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:info,a)
      end subroutine ztrtri

      subroutine ctrtrs(uplo, trans, diag, n, nrhs, a, lda, b, ldb,    &
                        info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
!$omp declare variant (ctrtrs:mkl_lapack_ctrtrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine ctrtrs

      subroutine dtrtrs(uplo, trans, diag, n, nrhs, a, lda, b, ldb,    &
                        info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      double precision, intent(in) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
!$omp declare variant (dtrtrs:mkl_lapack_dtrtrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine dtrtrs

      subroutine strtrs(uplo, trans, diag, n, nrhs, a, lda, b, ldb,    &
                        info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      real, intent(in) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
!$omp declare variant (strtrs:mkl_lapack_strtrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine strtrs

      subroutine ztrtrs(uplo, trans, diag, n, nrhs, a, lda, b, ldb,    &
                        info) bind(c)
      character*1, intent(in) :: uplo
      character*1, intent(in) :: trans
      character*1, intent(in) :: diag
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: ldb
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
!$omp declare variant (ztrtrs:mkl_lapack_ztrtrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine ztrtrs

      subroutine cungqr(m, n, k, a, lda, tau, work, lwork,             &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(inout) :: a(lda,*)
      complex*8, intent(in) :: tau(*)
      complex*8, intent(out) :: work(*)
!$omp declare variant (cungqr:mkl_lapack_cungqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine cungqr

      subroutine zungqr(m, n, k, a, lda, tau, work, lwork,             &
                        info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(inout) :: a(lda,*)
      complex*16, intent(in) :: tau(*)
      complex*16, intent(out) :: work(*)
!$omp declare variant (zungqr:mkl_lapack_zungqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,work,info)
      end subroutine zungqr

      subroutine cunmqr(side, trans, m, n, k, a, lda, tau, c, ldc,     &
                        work, lwork, info) bind(c)
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*8, intent(in) :: a(lda,*)
      complex*8, intent(in) :: tau(*)
      complex*8, intent(inout) :: c(ldc,*)
      complex*8, intent(out) :: work(*)
!$omp declare variant (cunmqr:mkl_lapack_cunmqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,c,work,info)
      end subroutine cunmqr

      subroutine zunmqr(side, trans, m, n, k, a, lda, tau, c, ldc,     &
                        work, lwork, info) bind(c)
      character*1, intent(in) :: side
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: k
      integer, intent(in) :: lda
      integer, intent(in) :: ldc
      integer, intent(in) :: lwork
      integer, intent(out) :: info
      complex*16, intent(in) :: a(lda,*)
      complex*16, intent(in) :: tau(*)
      complex*16, intent(inout) :: c(ldc,*)
      complex*16, intent(out) :: work(*)
!$omp declare variant (zunmqr:mkl_lapack_zunmqr_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,tau,c,work,info)
      end subroutine zunmqr

      subroutine cgetrs_batch_strided(trans, n, nrhs, a, lda, stride_a,&
                                      ipiv, stride_ipiv, b, ldb,       &
                                      stride_b, batch_size,            &
                                      info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*8, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrs_batch_strided:mkl_lapack_cgetrs_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine cgetrs_batch_strided

      subroutine dgetrs_batch_strided(trans, n, nrhs, a, lda, stride_a,&
                                      ipiv, stride_ipiv, b, ldb,       &
                                      stride_b, batch_size,            &
                                      info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      double precision, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrs_batch_strided:mkl_lapack_dgetrs_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine dgetrs_batch_strided

      subroutine sgetrs_batch_strided(trans, n, nrhs, a, lda, stride_a,&
                                      ipiv, stride_ipiv, b, ldb,       &
                                      stride_b, batch_size,            &
                                      info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      real, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrs_batch_strided:mkl_lapack_sgetrs_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine sgetrs_batch_strided

      subroutine zgetrs_batch_strided(trans, n, nrhs, a, lda, stride_a,&
                                      ipiv, stride_ipiv, b, ldb,       &
                                      stride_b, batch_size,            &
                                      info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: stride_ipiv
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      integer, intent(in) :: ipiv(stride_ipiv,*)
      complex*16, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrs_batch_strided:mkl_lapack_zgetrs_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,ipiv,b,info)
      end subroutine zgetrs_batch_strided

      subroutine cgetrfnp_batch_strided(m, n, a, lda, stride_a,        &
                                        batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrfnp_batch_strided:mkl_lapack_cgetrfnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine cgetrfnp_batch_strided

      subroutine dgetrfnp_batch_strided(m, n, a, lda, stride_a,        &
                                        batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrfnp_batch_strided:mkl_lapack_dgetrfnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine dgetrfnp_batch_strided

      subroutine sgetrfnp_batch_strided(m, n, a, lda, stride_a,        &
                                        batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrfnp_batch_strided:mkl_lapack_sgetrfnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine sgetrfnp_batch_strided

      subroutine zgetrfnp_batch_strided(m, n, a, lda, stride_a,        &
                                        batch_size, info) bind(c)
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrfnp_batch_strided:mkl_lapack_zgetrfnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine zgetrfnp_batch_strided

      subroutine cgetrsnp_batch_strided(trans, n, nrhs, a, lda,        &
                                        stride_a, b, ldb, stride_b,    &
                                        batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*8, intent(in) :: a(stride_a,*)
      complex*8, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgetrsnp_batch_strided:mkl_lapack_cgetrsnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine cgetrsnp_batch_strided

      subroutine dgetrsnp_batch_strided(trans, n, nrhs, a, lda,        &
                                        stride_a, b, ldb, stride_b,    &
                                        batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      double precision, intent(in) :: a(stride_a,*)
      double precision, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgetrsnp_batch_strided:mkl_lapack_dgetrsnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine dgetrsnp_batch_strided

      subroutine sgetrsnp_batch_strided(trans, n, nrhs, a, lda,        &
                                        stride_a, b, ldb, stride_b,    &
                                        batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      real, intent(in) :: a(stride_a,*)
      real, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgetrsnp_batch_strided:mkl_lapack_sgetrsnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine sgetrsnp_batch_strided

      subroutine zgetrsnp_batch_strided(trans, n, nrhs, a, lda,        &
                                        stride_a, b, ldb, stride_b,    &
                                        batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*16, intent(in) :: a(stride_a,*)
      complex*16, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgetrsnp_batch_strided:mkl_lapack_zgetrsnp_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine zgetrsnp_batch_strided

      subroutine dpotrf(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (dpotrf:mkl_lapack_dpotrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine dpotrf

      subroutine spotrf(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (spotrf:mkl_lapack_spotrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine spotrf

      subroutine cpotrf(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (cpotrf:mkl_lapack_cpotrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine cpotrf

      subroutine zpotrf(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (zpotrf:mkl_lapack_zpotrf_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine zpotrf


      subroutine dpotrf_batch_strided(uplo, n, a, lda, stride_a,       &
                                      batch_size, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dpotrf_batch_strided:mkl_lapack_dpotrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine dpotrf_batch_strided

      subroutine spotrf_batch_strided(uplo, n, a, lda, stride_a,       &
                                      batch_size, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      real, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (spotrf_batch_strided:mkl_lapack_spotrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine spotrf_batch_strided

      subroutine cpotrf_batch_strided(uplo, n, a, lda, stride_a,       &
                                      batch_size, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cpotrf_batch_strided:mkl_lapack_cpotrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine cpotrf_batch_strided

      subroutine zpotrf_batch_strided(uplo, n, a, lda, stride_a,       &
                                      batch_size, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zpotrf_batch_strided:mkl_lapack_zpotrf_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine zpotrf_batch_strided

      subroutine dpotri(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      double precision, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (dpotri:mkl_lapack_dpotri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine dpotri

      subroutine spotri(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      real, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (spotri:mkl_lapack_spotri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine spotri

      subroutine cpotri(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      complex*8, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (cpotri:mkl_lapack_cpotri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine cpotri

      subroutine zpotri(uplo, n, a, lda, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n
      complex*16, intent(inout) :: a(lda,*)
      integer, intent(in) :: lda
      integer, intent(out) :: info
!$omp declare variant (zpotri:mkl_lapack_zpotri_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,info)
      end subroutine zpotri


      subroutine dpotrs(uplo, n, nrhs, a, lda, b, ldb, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n, nrhs, lda, ldb
      double precision, intent(in) :: a(lda,*)
      double precision, intent(inout) :: b(ldb,*)
      integer, intent(out) :: info
!$omp declare variant (dpotrs:mkl_lapack_dpotrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine dpotrs

      subroutine spotrs(uplo, n, nrhs, a, lda, b, ldb, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n, nrhs, lda, ldb
      real, intent(in) :: a(lda,*)
      real, intent(inout) :: b(ldb,*)
      integer, intent(out) :: info
!$omp declare variant (spotrs:mkl_lapack_spotrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine spotrs

      subroutine cpotrs(uplo, n, nrhs, a, lda, b, ldb, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n, nrhs, lda, ldb
      complex*8, intent(in) :: a(lda,*)
      complex*8, intent(inout) :: b(ldb,*)
      integer, intent(out) :: info
!$omp declare variant (cpotrs:mkl_lapack_cpotrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine cpotrs

      subroutine zpotrs(uplo, n, nrhs, a, lda, b, ldb, info) bind(c)
      character*1, intent(in) :: uplo
      integer, intent(in) :: n, nrhs, lda, ldb
      complex*16, intent(in) :: a(lda,*)
      complex*16, intent(inout) :: b(ldb,*)
      integer, intent(out) :: info
!$omp declare variant (zpotrs:mkl_lapack_zpotrs_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine zpotrs

      subroutine sgels_batch_strided(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      real,    intent(inout) :: a(stride_a,*)
      real,    intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (sgels_batch_strided:mkl_lapack_sgels_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine sgels_batch_strided

      subroutine dgels_batch_strided(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      double precision, intent(inout) :: a(stride_a,*)
      double precision, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (dgels_batch_strided:mkl_lapack_dgels_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine dgels_batch_strided

      subroutine cgels_batch_strided(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*8, intent(inout) :: a(stride_a,*)
      complex*8, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (cgels_batch_strided:mkl_lapack_cgels_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine cgels_batch_strided

      subroutine zgels_batch_strided(trans, m, n, nrhs, a, lda, stride_a, b, ldb, stride_b, batch_size, info) bind(c)
      character*1, intent(in) :: trans
      integer, intent(in) :: m
      integer, intent(in) :: n
      integer, intent(in) :: nrhs
      integer, intent(in) :: lda
      integer, intent(in) :: stride_a
      integer, intent(in) :: ldb
      integer, intent(in) :: stride_b
      integer, intent(in) :: batch_size
      complex*16, intent(inout) :: a(stride_a,*)
      complex*16, intent(inout) :: b(stride_b,*)
      integer, intent(out) :: info(*)
!$omp declare variant (zgels_batch_strided:mkl_lapack_zgels_batch_strided_omp_offload_lp64) match(construct={dispatch}, device={arch(gen)}) append_args(interop(prefer_type("sycl"), targetsync)) adjust_args(need_device_addr:a,b,info)
      end subroutine zgels_batch_strided

   end interface

end module onemkl_lapack_omp_offload_lp64

#!/bin/sh
#shellcheck shell=sh
#===============================================================================
# Copyright (C) 2023 Intel Corporation
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.
#===============================================================================


# This etc/mkl/vars.sh script is intended to be sourced by oneapi-vars.sh script
# and is not intended to be sourced directly.


# ############################################################################
#
# Intel(R) oneAPI Math Kernel Library (oneMKL) vars.sh
# Arguments:
#
#   source <install-dir>/oneapi-vars.sh [--force] [--help] [mod [<MKL_interface>]]
#
#     mod (optional) - Set path to oneMKL F95 modules
#
#     <MKL_interface> (optional) - oneMKL programming interface for the
#                                  "mod" option to set path
#         lp64         : 4 bytes integer (default)
#         ilp64        : 8 bytes integer
#
# ############################################################################

if [ -z "${SETVARS_CALL:-}" ] ; then
  >&2 echo " "
  >&2 echo ":: ERROR: This script must be sourced by oneapi-vars.sh."
  >&2 echo "   Try 'source <install-dir>/oneapi-vars.sh --help' for help."
  >&2 echo " "
  return 255 2>/dev/null || exit 255
fi

if [ -z "${ONEAPI_ROOT:-}" ] ; then
  >&2 echo " "
  >&2 echo ":: ERROR: This script requires that the ONEAPI_ROOT env variable is set."
  >&2 echo "   Try 'source <install-dir>/oneapi-vars.sh --help' for help."
  >&2 echo " "
  return 254 2>/dev/null || exit 254
fi

# ############################################################################

# Constants
__mkl_tmp_MOD_NAME=mod

# Defaults
__mkl_tmp_MOD=
__mkl_tmp_LP64_ILP64=lp64
__mkl_tmp_MKLVARS_VERBOSE=

# Parse arguments
while [ -n "${1:-}" ]; do
    if   [ "$1" = "${__mkl_tmp_MOD_NAME}" ] ; then __mkl_tmp_MOD=${__mkl_tmp_MOD_NAME};
    elif [ "$1" = "lp64" ]                  ; then __mkl_tmp_LP64_ILP64=lp64;
    elif [ "$1" = "ilp64" ]                 ; then __mkl_tmp_LP64_ILP64=ilp64;
    elif [ "$1" = "verbose" ]               ; then __mkl_tmp_MKLVARS_VERBOSE=verbose;
    fi
    shift;
done

# Set environment variables
export MKLROOT="${ONEAPI_ROOT}"
if [ "${__mkl_tmp_MOD}" = "${__mkl_tmp_MOD_NAME}" ] ; then
    __mkl_tmp_C_INCLUDE_PATH="${MKLROOT}/include/mkl/intel64/${__mkl_tmp_LP64_ILP64}"
    export C_INCLUDE_PATH="${__mkl_tmp_C_INCLUDE_PATH}${C_INCLUDE_PATH+:${C_INCLUDE_PATH}}"
fi

if [ "${__mkl_tmp_MKLVARS_VERBOSE}" = "verbose" ] ; then
    echo MKLROOT=${MKLROOT}
    echo C_INCLUDE_PATH=${C_INCLUDE_PATH:-}
fi

#!/bin/sh
#shellcheck shell=sh
#===============================================================================
# Copyright (C) 2003 Intel Corporation
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.
#===============================================================================

# ############################################################################
#
# Intel(R) oneAPI Math Kernel Library (oneMKL) vars.sh
# Syntax:
#
#   source vars.sh [mod [<MKL_interface>]]
#
#     mod (optional) - Set path to oneMKL F95 modules
#
#     <MKL_interface> (optional) - oneMKL programming interface for the
#                                  "mod" option to set path
#         lp64         : 4 bytes integer (default)
#         ilp64        : 8 bytes integer
#
# If the arguments to the sourced script are ignored (consult docs for
# your shell), alternatively you can use environment variables MKLVARS_MOD
# to pass "mod" and MKLVARS_INTERFACE to pass <MKL_interface>.
#
# ############################################################################

# Get absolute path to this script.
# Uses `readlink` to remove links and `pwd -P` to turn into an absolute path.

# Usage:
#   script_dir=$(get_script_path "$script_rel_path")
#
# Inputs:
#   script/relative/pathname/scriptname
#
# Outputs:
#   /script/absolute/pathname

# executing function in a *subshell* to localize vars and effects on `cd`
get_script_path() (
  script="$1"
  while [ -L "$script" ] ; do
    # combining next two lines fails in zsh shell
    script_dir=$(command dirname -- "$script")
    script_dir=$(cd "$script_dir" && command pwd -P)
    script="$(readlink "$script")"
    case $script in
      (/*) ;;
       (*) script="$script_dir/$script" ;;
    esac
  done
  # combining next two lines fails in zsh shell
  script_dir=$(command dirname -- "$script")
  script_dir=$(cd "$script_dir" && command pwd -P)
  printf "%s" "$script_dir"
)


# ############################################################################

# Determine if we are being executed or sourced. Need to detect being sourced
# within an executed script, which can happen on a CI system. We also must
# detect being sourced at a shell prompt (CLI). The setvars.sh script will
# always source this script, but this script can also be called directly.

# We are assuming we know the name of this script, which is a reasonable
# assumption. This script _must_ be named "vars.sh" or it will not work
# with the top-level setvars.sh script. Making this assumption simplifies
# the process of detecting if the script has been sourced or executed. It
# also simplifies the process of detecting the location of this script.

# Using `readlink` to remove possible symlinks in the name of the script.
# Also, "ps -o comm=" is limited to a 15 character result, but it works
# fine here, because we are only looking for the name of this script or the
# name of the execution shell, both always fit into fifteen characters.

# Edge cases exist when executed by way of "/bin/sh setvars.sh"
# Most shells detect or fall thru to error message, sometimes ksh does not.
# This is an odd and unusual situation; not a high priority issue.

_vars_get_proc_name() {
  if [ -n "${ZSH_VERSION:-}" ] ; then
    script="$(ps -p "$$" -o comm=)"
  else
    script="$1"
    while [ -L "$script" ] ; do
      script="$(readlink "$script")"
    done
  fi
  basename -- "$script"
}

_vars_this_script_name="vars.sh"
if [ "$_vars_this_script_name" = "$(_vars_get_proc_name "$0")" ] ; then
  echo "   ERROR: Incorrect usage: this script must be sourced."
  echo "   Usage: . path/to/${_vars_this_script_name}"
  return 255 2>/dev/null || exit 255
fi

# ############################################################################

# Prepend path segment(s) to path-like env vars (PATH, C_INCLUDE_PATH, etc.).

# prepend_path() avoids dangling ":" that affects some env vars (PATH and C_INCLUDE_PATH)
# PATH > https://www.gnu.org/software/libc/manual/html_node/Standard-Environment.html

# Usage:
#   env_var=$(prepend_path "$prepend_to_var" "$existing_env_var")
#   export env_var
#
# Inputs:
#   $1 == path segment to be prepended to $2
#   $2 == value of existing path-like environment variable

prepend_path() (
  path_to_add="$1"
  path_is_now="$2"

  if [ "" = "${path_is_now}" ] ; then   # avoid dangling ":"
    printf "%s" "${path_to_add}"
  else
    printf "%s" "${path_to_add}:${path_is_now}"
  fi
)

# ############################################################################

mkl_help() {
    echo ""
    echo "oneMKL ${__mkl_tmp_SCRIPT_NAME} syntax:"
    echo ""
    echo "  source ${__mkl_tmp_SCRIPT_NAME} [mod [<MKL_interface>]]"
    echo ""
    echo "    mod (optional) - Set path to oneMKL F95 modules"
    echo ""
    echo "    <MKL_interface> (optional) - oneMKL programming interface for the"
    echo "                                 \"mod\" option to set path"
    echo "        lp64         : 4 bytes integer (default)"
    echo "        ilp64        : 8 bytes integer"
    echo ""
    echo "If the arguments to the sourced script are ignored (consult docs for"
    echo "your shell), alternatively you can use environment variables MKLVARS_MOD"
    echo "to pass \"mod\" and MKLVARS_INTERFACE to pass <MKL_interface>."
    echo ""
}

# ############################################################################

# Extract the name and location of this sourced script.

# Generally, "ps -o comm=" is limited to a 15 character result, but it works
# fine for this usage, because we are primarily interested in finding the name
# of the execution shell, not the name of any calling script.

vars_script_name=""
vars_script_shell="$(ps -p "$$" -o comm=)"
# ${var:-} needed to pass "set -eu" checks
# see https://unix.stackexchange.com/a/381465/103967
# see https://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_06_02
if [ -n "${ZSH_VERSION:-}" ] && [ -n "${ZSH_EVAL_CONTEXT:-}" ] ; then     # zsh 5.x and later
  # shellcheck disable=2249
  case $ZSH_EVAL_CONTEXT in (*:file*) vars_script_name="${(%):-%x}" ;; esac ;
elif [ -n "${KSH_VERSION:-}" ] ; then                                     # ksh, mksh or lksh
  if [ "$(set | grep -Fq "KSH_VERSION=.sh.version" ; echo $?)" -eq 0 ] ; then # ksh
    vars_script_name="${.sh.file}" ;
  else # mksh or lksh or [lm]ksh masquerading as ksh or sh
    # force [lm]ksh to issue error msg; which contains this script's path/filename, e.g.:
    # mksh: /home/ubuntu/intel/oneapi/vars.sh[137]: ${.sh.file}: bad substitution
    vars_script_name="$( (echo "${.sh.file}") 2>&1 )" || : ;
    vars_script_name="$(expr "${vars_script_name:-}" : '^.*sh: \(.*\)\[[0-9]*\]:')" ;
  fi
elif [ -n "${BASH_VERSION:-}" ] ; then        # bash
  # shellcheck disable=2128,3028
  (return 0 2>/dev/null) && vars_script_name="${BASH_SOURCE}" ;
elif [ "dash" = "$vars_script_shell" ] ; then # dash
  # force dash to issue error msg; which contains this script's rel/path/filename, e.g.:
  # dash: 146: /home/ubuntu/intel/oneapi/vars.sh: Bad substitution
  vars_script_name="$( (echo "${.sh.file}") 2>&1 )" || : ;
  vars_script_name="$(expr "${vars_script_name:-}" : '^.*dash: [0-9]*: \(.*\):')" ;
elif [ "sh" = "$vars_script_shell" ] ; then   # could be dash masquerading as /bin/sh
  # force a shell error msg; which should contain this script's path/filename
  # sample error msg shown; assume this file is named "vars.sh"; as required by setvars.sh
  vars_script_name="$( (echo "${.sh.file}") 2>&1 )" || : ;
  if [ "$(printf "%s" "$vars_script_name" | grep -Eq "sh: [0-9]+: .*vars\.sh: " ; echo $?)" -eq 0 ] ; then # dash as sh
    # sh: 155: /home/ubuntu/intel/oneapi/vars.sh: Bad substitution
    vars_script_name="$(expr "${vars_script_name:-}" : '^.*sh: [0-9]*: \(.*\):')" ;
  fi
else  # unrecognized shell or dash being sourced from within a user's script
  # force a shell error msg; which should contain this script's path/filename
  # sample error msg shown; assume this file is named "vars.sh"; as required by setvars.sh
  vars_script_name="$( (echo "${.sh.file}") 2>&1 )" || : ;
  if [ "$(printf "%s" "$vars_script_name" | grep -Eq "^.+: [0-9]+: .*vars\.sh: " ; echo $?)" -eq 0 ] ; then # dash
    # .*: 164: intel/oneapi/vars.sh: Bad substitution
    vars_script_name="$(expr "${vars_script_name:-}" : '^.*: [0-9]*: \(.*\):')" ;
  else
    vars_script_name="" ;
  fi
fi

if [ "" = "$vars_script_name" ] ; then
  >&2 echo "   ERROR: Unable to proceed: possible causes listed below."
  >&2 echo "   This script must be sourced. Did you execute or source this script?" ;
  >&2 echo "   Unrecognized/unsupported shell (supported: bash, zsh, ksh, m/lksh, dash)." ;
  >&2 echo "   May fail in dash if you rename this script (assumes \"vars.sh\")." ;
  >&2 echo "   Can be caused by sourcing from ZSH version 4.x or older." ;
  return 255 2>/dev/null || exit 255
fi


# ############################################################################

__mkl_tmp_SCRIPT_NAME=$(basename -- "${vars_script_name:-}")
__mkl_tmp_SCRIPT_DIR=$(get_script_path "${vars_script_name:-}")

# Constants
__mkl_tmp_MOD_NAME=mod

# Defaults
__mkl_tmp_MOD=
__mkl_tmp_LP64_ILP64=lp64
__mkl_tmp_MKLVARS_VERBOSE=

# Parse arguments
if [ -z "${1:-}" ] ; then
    # from environment variables
    if [ -n "${MKLVARS_MOD:-}" ] ; then
        __mkl_tmp_MOD="$MKLVARS_MOD"
        if [ "${__mkl_tmp_MOD}" != "mod" ] ; then
            >&2 echo "   ERROR: Invalid MKLVARS_MOD value \"${__mkl_tmp_MOD}\". The only valid value is \"mod\"."
            return 254 2>/dev/null || exit 254
        fi
        if [ -n "${MKLVARS_INTERFACE:-}" ] ; then
            __mkl_tmp_LP64_ILP64="$MKLVARS_INTERFACE"
            if [ "${__mkl_tmp_LP64_ILP64}" != "lp64" ] && [ "${__mkl_tmp_LP64_ILP64}" != "ilp64" ] ; then
                >&2 echo "   ERROR: Invalid MKLVARS_INTERFACE value \"${__mkl_tmp_LP64_ILP64}\". The valid values are \"lp64\" and \"ilp64\"."
                return 254 2>/dev/null || exit 254
            fi
        fi
    fi
else
    # from command line arguments
    while [ -n "${1:-}" ]; do
        if   [ "$1" = "${__mkl_tmp_MOD_NAME}" ] ; then __mkl_tmp_MOD=${__mkl_tmp_MOD_NAME};
        elif [ "$1" = "lp64" ]                  ; then __mkl_tmp_LP64_ILP64=lp64;
        elif [ "$1" = "ilp64" ]                 ; then __mkl_tmp_LP64_ILP64=ilp64;
        elif [ "$1" = "verbose" ]               ; then __mkl_tmp_MKLVARS_VERBOSE=verbose;
        elif [ "$1" = "--help" ]                ; then mkl_help; return 254 2>/dev/null || exit 254;
        fi
        shift;
    done
fi

# Set environment variables
export MKLROOT=$(dirname -- "${__mkl_tmp_SCRIPT_DIR}")  # grandparent directory of this script
__mkl_tmp_C_INCLUDE_PATH="${MKLROOT}/include"
__mkl_tmp_CPLUS_INCLUDE_PATH="${MKLROOT}/include"
if [ "${__mkl_tmp_MOD}" = "${__mkl_tmp_MOD_NAME}" ] ; then
    __mkl_tmp_C_INCLUDE_PATH="${MKLROOT}/include/mkl/intel64/${__mkl_tmp_LP64_ILP64}:${__mkl_tmp_C_INCLUDE_PATH}"
fi
export C_INCLUDE_PATH=$(prepend_path "${__mkl_tmp_C_INCLUDE_PATH}" "${C_INCLUDE_PATH:-}")
export CPLUS_INCLUDE_PATH=$(prepend_path "${__mkl_tmp_CPLUS_INCLUDE_PATH}" "${CPLUS_INCLUDE_PATH:-}")
export LD_LIBRARY_PATH=$(prepend_path "${MKLROOT}/lib" "${LD_LIBRARY_PATH:-}")
export LIBRARY_PATH=$(prepend_path "${MKLROOT}/lib" "${LIBRARY_PATH:-}")
export PATH=$(prepend_path "${MKLROOT}/bin" "${PATH:-}")
export PKG_CONFIG_PATH=$(prepend_path "${MKLROOT}/lib/pkgconfig" "${PKG_CONFIG_PATH:-}")
export CMAKE_PREFIX_PATH=$(prepend_path "${MKLROOT}/lib/cmake" "${CMAKE_PREFIX_PATH:-}")

if [ "${__mkl_tmp_MKLVARS_VERBOSE}" = "verbose" ] ; then
    echo MKLROOT=${MKLROOT}
    echo C_INCLUDE_PATH=${C_INCLUDE_PATH}
    echo CPLUS_INCLUDE_PATH=${CPLUS_INCLUDE_PATH}
    echo LD_LIBRARY_PATH=${LD_LIBRARY_PATH}
    echo LIBRARY_PATH=${LIBRARY_PATH}
    echo PATH=${PATH}
    echo PKG_CONFIG_PATH=${PKG_CONFIG_PATH}
    echo CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}
fi
